/* Header file for Cray T3D */

/* Let CPP know we're compiling for the T3D */

#define __T3D__

#include "alpha/alpha.h"

/*
 * CRI defines __STDC__ to be 2, so we do too
 */	
#define STDC_VALUE 2

#ifndef AUX_STARTING_FRAME_OFFSET
#define AUX_STARTING_FRAME_OFFSET STARTING_FRAME_OFFSET
#endif

#ifndef AUX_STACK_POINTER_OFFSET
#define AUX_STACK_POINTER_OFFSET STACK_POINTER_OFFSET
#endif

#ifndef AUX_STACK_POINTER_REGNUM
#define AUX_STACK_POINTER_REGNUM STACK_POINTER_REGNUM
#endif

#ifndef AUX_FRAME_POINTER_REGNUM
#define AUX_FRAME_POINTER_REGNUM FRAME_POINTER_REGNUM
#endif

#ifndef AUX_ARG_POINTER_REGNUM
#define AUX_ARG_POINTER_REGNUM ARG_POINTER_REGNUM
#endif

#ifndef BITS_PER_AUX_WORD
#define BITS_PER_AUX_WORD BITS_PER_WORD
#endif

#ifndef MAX_VECTOR_LENGTH
#define MAX_VECTOR_LENGTH 0
#endif

#ifndef APmode
#define APmode Pmode
#endif

#ifndef GAPmode
#define GAPmode GPmode
#endif

#ifndef CLASS_VECTOR_P
#define CLASS_VECTOR_P(X) (0)
#endif

#ifndef AUX_MODE_P
#define AUX_MODE_P(X) (0)
#endif

#ifndef AUX_FIRST_PARM_OFFSET
#define AUX_FIRST_PARM_OFFSET(FNDECL) FIRST_PARM_OFFSET(FNDECL)
#endif

#ifndef BLK_MODE_P
#define BLK_MODE_P(MODE) (MODE == BLKmode)
#endif

#define DIST_POINTER_PE_SHIFT 48
