#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "myrelo.h"
#include "mysymbol.h"

#define NWORDS(x)  (((x)+7)>>3)
print_mth (mth)
     struct mth *mth;
{
  fprintf(stderr, "mth_tt:%d\t", mth->mth_tt);
  fprintf(stderr, "mth_lang:%d\t", mth->mth_lang);
  fprintf(stderr, "mth_hlen:%d\t", mth->mth_hlen);
  fprintf(stderr, "mth_nlen:%d\t", mth->mth_nlen);
  fprintf(stderr, "mth_tlen:%d\n", mth->mth_tlen);

	/*
	 * descriptor lengths are for a single element
	 * of that type
	 */
  fprintf(stderr, "mth_tv:%d\t", mth->mth_tv);
  fprintf(stderr, "mth_csq:%d\t", mth->mth_csq);
  fprintf(stderr, "mth_vdslen:%d\t", mth->mth_vdslen);
  fprintf(stderr, "mth_nldlen:%d\t", mth->mth_nldlen);
  fprintf(stderr, "mth_uldlen:%d\n", mth->mth_uldlen);
  fprintf(stderr, "mth_psdlen:%d\t", mth->mth_psdlen);
  fprintf(stderr, "mth_fdslen:%d\t", mth->mth_fdslen);

  fprintf(stderr, "mth_ov:%d\t", mth->mth_ov);
  fprintf(stderr, "mth_ol:%d\n", mth->mth_ol);

	/*
	 * indexes are 1's based and are offset from the beginning
	 * of the table entry.  A zero means none exist.
	 * ifoo -> index to foo
	 * lfoo -> length of foo
	 */
  fprintf(stderr, "mth_icbt:%d\t", mth->mth_icbt);
  fprintf(stderr, "mth_lcbt:%d\t", mth->mth_lcbt);

  fprintf(stderr, "mth_irbs:%d\t", mth->mth_irbs);
  fprintf(stderr, "mth_lrbs:%d\n", mth->mth_lrbs);

  fprintf(stderr, "mth_ints:%d\t", mth->mth_ints);
  fprintf(stderr, "mth_lnts:%d\t", mth->mth_lnts);

  fprintf(stderr, "mth_ipsd:%d\t", mth->mth_ipsd);
  fprintf(stderr, "mth_lpsd:%d\n", mth->mth_lpsd);

  fprintf(stderr, "mth_itds:%d\t", mth->mth_itds);
  fprintf(stderr, "mth_ltds:%d\t", mth->mth_ltds);

  fprintf(stderr, "mth_ifds:%d\t", mth->mth_ifds);
  fprintf(stderr, "mth_lfds:%d\n", mth->mth_lfds);

  fprintf(stderr, "mth_ivds:%d\t", mth->mth_ivds);
  fprintf(stderr, "mth_lvds:%d\t", mth->mth_lvds);

  fprintf(stderr, "mth_inld:%d\t", mth->mth_inld);
  fprintf(stderr, "mth_lnld:%d\n", mth->mth_lnld);

  fprintf(stderr, "mth_iuld:%d\t", mth->mth_iuld);
  fprintf(stderr, "mth_luld:%d\t", mth->mth_luld);

  fprintf(stderr, "mth_ialts:%d\t", mth->mth_ialts);
  fprintf(stderr, "mth_lalts:%d\n", mth->mth_lalts);

  fprintf(stderr, "mth_ilcs:%d\t", mth->mth_ilcs);
  fprintf(stderr, "mth_llcs:%d\t", mth->mth_llcs);

  fprintf(stderr, "mth_ilds:%d\t", mth->mth_ilds);
  fprintf(stderr, "mth_llds:%d\n", mth->mth_llds);


  fprintf (stderr, "mth_pname: %8.8s\t", mth->mth_pname);
  fprintf (stderr, "mth_plevel: %8.8s\t", mth->mth_plevel);
  fprintf (stderr, "mth_pdate: %8.8s\n", mth->mth_pdate);
  fprintf (stderr, "mth_cdate: %8.8s\t", mth->mth_cdate);
  fprintf (stderr, "mth_ctime: %8.8s\n", mth->mth_ctime);

  fprintf(stderr, "mth_so:%d\t", mth->mth_so);
  fprintf(stderr, "mth_av:%d\t", mth->mth_av);
  fprintf(stderr, "mth_dce:%d\t", mth->mth_dce);
  fprintf(stderr, "mth_dbs:%d\t", mth->mth_dbs);
  fprintf(stderr, "mth_fts:%d\n", mth->mth_fts);
  fprintf(stderr, "mth_sl:%d\t", mth->mth_sl);
  fprintf(stderr, "mth_unused0:%d\t", mth->mth_unused0);
  fprintf(stderr, "mth_slave:%d\t", mth->mth_slave);
  fprintf(stderr, "mth_sref:%d\n", mth->mth_sref);
  fprintf(stderr, "mth_slen:%d\t", mth->mth_slen);
  fprintf(stderr, "mth_sline:%d\t", mth->mth_sline);

  fprintf(stderr, "mth_rbl:%d\t", mth->mth_rbl);
  fprintf(stderr, "mth_asl:%d\t", mth->mth_asl);


  fprintf(stderr, "mth_dex:%d\n", mth->mth_dex);
  fprintf(stderr, "mname %s\n", mth->mth_mname);
  fprintf(stderr, "sname %s\n", &mth->mth_mname[NWORDS(strlen(mth->mth_mname))<<3]);
}

print_psd_from_mth(mth, buf)
     struct mth *mth;
     long *buf;
{
  print_psd(&buf[mth->mth_ipsd-1], mth->mth_lpsd/NWORDS(sizeof (struct psd)));
}


print_psd (psd, n)
     struct psd *psd;
     int n;
{
  while (n--)
    {
      fprintf(stderr, "psd_name: %8.8s\t", psd->psd_name);	/* first 8 chars of name */
      fprintf(stderr, "psd_nlen: %d\t", psd->psd_nlen);	/* name length */
      fprintf(stderr, "psd_ints: %d\t", psd->psd_ints);	/* index to rest of name */
      fprintf(stderr, "psd_enlen: %d\n\t", psd->psd_enlen); /* pascal: external name length */ 
      fprintf(stderr, "psd_ename: %d\t", psd->psd_ename); /* pascal: external name index */
      fprintf(stderr, "psd_eaddr.si_sc: %d\t", psd->psd_eaddr.si_sc);
      fprintf(stderr, "psd_eaddr.si_irbs: %d\t", psd->psd_eaddr.si_irbs);
      fprintf(stderr, "psd_eaddr.si_offset: %d\n\t", psd->psd_eaddr.si_offset);
      fprintf(stderr, "psd_climit.si_sc: %d\t", psd->psd_climit.si_sc);
      fprintf(stderr, "psd_climit.si_irbs: %d\t", psd->psd_climit.si_irbs);
      fprintf(stderr, "psd_climit.si_offset: %d\t", psd->psd_climit.si_offset);
      fprintf(stderr, "psd_parent: %d\n\t", psd->psd_parent); /* index into scope directory for parent */
      fprintf(stderr, "psd_sibling: %d\t", psd->psd_sibling); /*  " " " " for next sibling */
      fprintf(stderr, "psd_child: %d\t", psd->psd_child); /*  " " " " of first child */
      fprintf(stderr, "psd_decl: %d\t", psd->psd_decl);	/* source line of declaration */
      fprintf(stderr, "psd_entry: %d\n\t", psd->psd_entry); /* source line of start of code */
      fprintf(stderr, "psd_exit: %d\t", psd->psd_exit);	/* source line of end of code */
      fprintf(stderr, "psd_icbt: %d\t", psd->psd_icbt);	/* common block list */
      fprintf(stderr, "psd_ccbt: %d\t", psd->psd_ccbt);	/*  */
      fprintf(stderr, "psd_itds: %d\n\t", psd->psd_itds);	/* type descriptors */
      fprintf(stderr, "psd_ctds: %d\t", psd->psd_ctds);	/*  */
      fprintf(stderr, "psd_ivds: %d\t", psd->psd_ivds);	/* variables */
      fprintf(stderr, "psd_cvds: %d\t", psd->psd_cvds);	/*  */
      fprintf(stderr, "psd_inld: %d\n\t", psd->psd_inld);	/* named labels */
      fprintf(stderr, "psd_cnld: %d\t", psd->psd_cnld);	/*  */
      fprintf(stderr, "psd_iuld: %d\t", psd->psd_iuld);	/* unnamed labels */
      fprintf(stderr, "psd_culd: %d\n", psd->psd_culd);	/*  */

      psd++;
    }
}

print_rbs_from_mth(mth, buf)
     struct mth *mth;
     long *buf;
{
  print_rbs(&buf[mth->mth_irbs-1], mth->mth_lrbs/NWORDS(sizeof (struct rbs)));
}


print_rbs (rbs, n)
     struct rbs *rbs;
     int n;
{
  while (n--)
    {
      fprintf(stderr, "rbs_name: %8.8s\t", rbs->rbs_name);	/* first 8 chars of name */
      fprintf(stderr, "rbs_nlen: %d\t", rbs->rbs_nlen);	/* name length */
      fprintf(stderr, "rbs_ints: %d\t", rbs->rbs_ints);	/* index to rest of name */
      fprintf(stderr, "rbs_cb: %d\n\t", rbs->rbs_cb);	/* set: common block */
      fprintf(stderr, "rbs_bl: %d\t", rbs->rbs_bl);	/* block location */
      fprintf(stderr, "rbs_bc: %d\t", rbs->rbs_bc);	/* block contents */
      fprintf(stderr, "rbs_bt: %d\t", rbs->rbs_bt);	/* block type */
      fprintf(stderr, "rbs_iblk: %d\n\t", rbs->rbs_iblk);	/* block index */
      fprintf(stderr, "dummy: %d\n", rbs->dummy);	/* block index */
      rbs++;
    }
}

print_tds_from_mth(mth, buf)
     struct mth *mth;
     long *buf;
{
  print_tds(&buf[mth->mth_itds-1], mth->mth_ltds);
}


print_tds (tds, n)
     struct tds *tds;
     int n;
{
  while (n)
    {
      fprintf(stderr, "tds_name:%8.8s\t", tds->tds_name);
      fprintf(stderr, "tds_nlen: %d\t", tds->tds_nlen);	/* length of type name */
      fprintf(stderr, "tds_ints: %d\t", tds->tds_ints);	/* index to rest of name */
      fprintf(stderr, "tds_ipsd: %d\n\t", tds->tds_ipsd);	/* procedure directory index */
      fprintf(stderr, "tds_df: %d\t", tds->tds_df);	/* display format code */
      fprintf(stderr, "tds_lent: %d\t", tds->tds_lent);	/* number of words in this type descriptor */
      fprintf(stderr, "tds_bitlen: %d\t", tds->tds_bitlen);	/* type variable length in bits */
      fprintf(stderr, "tds_tc: %d\n", tds->tds_tc);	/* type class */
      n -= tds->tds_lent;
      tds = (struct tds *)(((long *) tds) + tds->tds_lent);
    }
}  

print_vds_from_mth(mth, buf)
     struct mth *mth;
     long *buf;
{
  print_vds(&buf[mth->mth_ivds-1], mth->mth_lvds/NWORDS(sizeof (struct vds)));
}


print_vds (vds, n)
     struct vds *vds;
     int n;
{
  while (n--)
    {
      fprintf(stderr, "vds_name: %8.8s\t", vds->vds_name);	/* first 8 chars of name */
      fprintf(stderr, "vds_nlen: %d\t", vds->vds_nlen);	/* name length */
      fprintf(stderr, "vds_ints: %d\t", vds->vds_ints);	/* index to rest of name */
      fprintf(stderr, "vds_ipsd: %d\n\t", vds->vds_ipsd);	/* index to scope */
/*    union sinfo vds_sinfo;		/* information about location */
      if (vds->vds_sinfo.si_sc == 18)
	{
	  fprintf(stderr, "vds_sinfo.si_sc: %d\t", vds->vds_sinfo.si_sc);
	  fprintf(stderr, "vds_sinfo.si_rtype: %d\t", vds->vds_sinfo.si_rtype);
	  fprintf(stderr, "vds_sinfo.si_rnum: %d\t", vds->vds_sinfo.si_rnum);
	  fprintf(stderr, "vds_sinfo.si_offset: %d\n\t", vds->vds_sinfo.si_offset);
	}
      else
	{
	  fprintf(stderr, "vds_sinfo.si_sc: %d\t", vds->vds_sinfo.si_sc);
	  fprintf(stderr, "vds_sinfo.si_irbs: %d\t", vds->vds_sinfo.si_irbs);
	  fprintf(stderr, "vds_sinfo.si_offset: %d\n\t", vds->vds_sinfo.si_offset);
	}



      fprintf(stderr, "vds_itds: %d\t", vds->vds_itds);	/* index of descriptor in type section */
      fprintf(stderr, "vds_r: %d\t", vds->vds_r); /* set: variable was referenced */
      fprintf(stderr, "vds_e: %d\t", vds->vds_e); /* set: variable is equivalenced */
      fprintf(stderr, "vds_ic: %d\n\t", vds->vds_ic); /* identifier class */
      fprintf(stderr, "vds_a: %d\t", vds->vds_a); /* assign flag */
      fprintf(stderr, "vds_lhs: %d\t", vds->vds_lhs); /* LHS flag */
      fprintf(stderr, "vds_d: %d\t", vds->vds_d); /* data loaded flag */
      fprintf(stderr, "vds_p: %d\n\t", vds->vds_p); /* passed flag */
      fprintf(stderr, "vds_rhs: %d\t", vds->vds_rhs); /* RHS flag */
      fprintf(stderr, "vds_pe: %d\t", vds->vds_pe); /* pe resident flag */
      fprintf(stderr, "vds_i: %d\t", vds->vds_i); /* arg intent */
      fprintf(stderr, "vds_pu: %d\n\t", vds->vds_pu); /* public module */
      fprintf(stderr, "vds_pr: %d\t", vds->vds_pr); /* private module */
      fprintf(stderr, "vds_dv: %d\t", vds->vds_dv); /* fortran90 dope vector */
      fprintf(stderr, "vds_refvar: %d\n", vds->vds_refvar); /* c++ reference variable */
      vds++;
    }
}

print_nld_from_mth(mth, buf)
     struct mth *mth;
     long *buf;
{
  print_nld(&buf[mth->mth_inld-1], mth->mth_lnld/NWORDS(sizeof (struct nld)));
}

print_nld (nld, n)
     struct nld *nld;
     int n;
{
  while (n--)
    {
      fprintf(stderr, "nld_name: %8.8s\t", nld->nld_name);	/* first 8 chars of name */
      fprintf(stderr, "nld_nlen: %d\t", nld->nld_nlen);	/* name length */
      fprintf(stderr, "nld_ints: %d\t", nld->nld_ints);	/* index to rest of name */
      fprintf(stderr, "nld_ipsd: %d\n\t", nld->nld_ipsd);		/* index to scope */
      fprintf(stderr, "nld_u: %d\t", nld->nld_u);		/* set: user defined */
      fprintf(stderr, "sinfo: %d %d %d\t", nld->nld_sinfo.si_sc, nld->nld_sinfo.si_irbs,
	      nld->nld_sinfo.si_offset);/* storage information */
      fprintf(stderr, "nld_lnum: %d\t", nld->nld_lnum);		/* source line number */
      fprintf(stderr, "nld_type: %d\n\t", nld->nld_type);		/* label type */
      fprintf(stderr, "nld_enlen: %d\t", nld->nld_enlen);		/* pascal: external name length */
      fprintf(stderr, "nld_ename: %d\n", nld->nld_ename);		/* pascal: external name index */
      nld++;
    }
}

print_uld_from_mth(mth, buf)
     struct mth *mth;
     long *buf;
{
  print_uld(&buf[mth->mth_iuld-1], mth->mth_luld/NWORDS(sizeof (struct uld)));
}

print_uld (uld, n)
     struct uld *uld;
     int n;
{
  while (n--)
    {
      fprintf(stderr, "uld_addr: %d %d %d\t", uld->uld_addr.si_sc, uld->uld_addr.si_irbs,
	      uld->uld_addr.si_offset);/* storage information */
      fprintf(stderr, "uld_lnum: %d\t", uld->uld_lnum);		/* source line number */
      fprintf(stderr, "uld_type: %d\n", uld->uld_type);		/* label type */
      uld++;
    }
}

