struct fn_decl std_protos[] = {
  {"TLappend", "int", "" },
  {"TLassign", "int", "" },
  {"TLclose", "int", "" },
  {"TLdelete", "int", "" },
  {"TLfreeentry", "int", "" },
  {"TLgetentry", "ENTRY", "" },
  {"TLgetfield", "unsigned char *", "" },
  {"TLopen", "int", "" },
  {"TLread", "int", "" },
  {"TLsearch1", "int", "" },
  {"TLsubst", "int", "" },
  {"TLsync", "int", "" },
  {"TLwrite", "int", "" },
  {"__acancel", "int", "int, const long int *, int" },
  {"__aread", "int", "int, int, char *, uint, ecb_t *" },
  {"__assert", "void", "const char *, const char *, int" },
  {"__asyncio", "int", "int, aioop_t *, int" },
  {"__awrite", "int", "int, int, char *, uint, ecb_t *" },
  {"__eprintf", "void", "const char *" },
  {"__evcntl", "int", "evver_t, evcntlcmds_t, long int, long int" },
  {"__evexit", "int", "evver_t, idtype_t, id_t, const ecb_t *" },
  {"__evexitset", "int", "evver_t, const procset_t *, hostid_t, const ecb_t *" },
  {"__evpoll", "int", "evver_t, evpollcmds_t, event_t *, int, const hrtime_t *" },
  {"__evpollmore", "int", "evver_t, event_t *, int" },
  {"__evpost", "int", "evver_t, event_t *, int, int" },
  {"__evqcntl", "int", "evver_t, int, evqcntlcmds_t, long int" },
  {"__evsig", "int", "evver_t, const sigset_t *, const ecb_t *, evsiginfo_t *, int" },
  {"__evtrap", "int", "evver_t, evpollcmds_t, event_t *, int, long int, void (*) (event_t *, int, long int, evcontext_t *), const evta_t *" },
  {"__evtrapcancel", "int", "evver_t, long int *, int" },
  {"__filbuf", "int", "FILE *" },
  {"__flsbuf", "int", "int, FILE *" },
  {"__major", "major_t", "int, long " },
  {"__makedev", "long", "int, major_t, minor_t" },
  {"__minor", "minor_t", "int, long " },
  {"__priocntl", "long int", "" },
  {"__priocntlset", "long int", "" },
  {"_exit", "void", "int" },
  {"_filbuf", "int", "FILE *" },
  {"_flsbuf", "int", "unsigned int, FILE *" },
  {"_fxstat", "int", "int, int, struct stat *" },
  {"_getlong", "u_long", "" },
  {"_getshort", "u_short", "" },
  {"_getsyx", "int", "int *, int *" },
  {"_longjmp", "int", "jmp_buf, int" },
  {"_lxstat", "int", "int, const char *, struct stat *" },
  {"_meta", "int", "int" },
  {"_netdir_getbyaddr", "struct nd_hostservlist", "struct netconfig *, struct netbuf *" },
  {"_netdir_getbyname", "struct nd_addrlist *", "struct netconfig *, struct nd_hostserv *" },
  {"_overlay", "int", "WINDOW *, WINDOW *, int" },
  {"_ring", "int", "int" },
  {"_rpc_dtbsize", "int", "" },
  {"_rpc_endconf", "int", "" },
  {"_rpc_get_a_size", "u_int", "" },
  {"_rpc_get_t_size", "u_int", "" },
  {"_rpc_getconf", "struct netconfig *", "" },
  {"_rpc_getconfip", "struct netconfig *", "" },
  {"_rpc_gethostname", "char *", "" },
  {"_rpc_setconf", "int", "" },
  {"_s_aligned_copy", "void", "" },
  {"_s_checkfd", "struct _si_user *", "" },
  {"_s_close", "void", "" },
  {"_s_do_ioctl", "int", "" },
  {"_s_getfamily", "int", "" },
  {"_s_getudata", "int", "" },
  {"_s_is_ok", "int", "" },
  {"_s_match", "struct netconfig *", "" },
  {"_s_max", "int", "" },
  {"_s_min", "int", "" },
  {"_s_open", "struct _si_user *", "" },
  {"_s_soreceive", "int", "" },
  {"_s_sosend", "int", "" },
  {"_s_uxpathlen", "int", "" },
  {"_setecho", "int", "int" },
  {"_setjmp", "int", "jmp_buf" },
  {"_setnonl", "int", "int" },
  {"_setqiflush", "void", "int" },
  {"_taddr2uaddr", "char *", "struct netconfig *, struct netbuf *" },
  {"_tolower", "int", "int" },
  {"_toupper", "int", "int" },
  {"_uaddr2taddr", "struct netbuf *", "struct netconfig *, char *" },
  {"_xdr_yprequest", "bool", "" },
  {"_xdr_ypresponse", "bool", "" },
  {"_xftw", "int", "int, const char *, int (*) (const char *, const struct stat *, int), int" },
  {"_xmknod", "int", "int, const char *, int , long " },
  {"_xstat", "int", "int, const char *, struct stat *" },
  {"_yp_dobind", "int", "" },
  {"a64l", "long int", "const char *" },
  {"aatos", "char *", "char *, struct address *, int" },
  {"abort", "void", "void" },
  {"abs", "int", "int" },
  {"access", "int", "const char *, int" },
  {"acct", "int", "const char *" },
  {"acos", "double", "double" },
  {"acosf", "float", "float" },
  {"acosh", "double", "double" },
  {"addexportent", "int", "FILE *, char *, char *" },
  {"addseverity", "int", "int, const char *" },
  {"adjtime", "int", "struct timeval *, struct timeval *" },
  {"advance", "int", "const char *, const char *" },
  {"alarm", "unsigned int", "unsigned int" },
  {"alloca", "void *", "__SIZE_TYPE__ " },
  {"and", "int", "void" },
  {"ascftime", "int", "char *, const char *, const struct tm *" },
  {"asctime", "char *", "const struct tm *" },
  {"asin", "double", "double" },
  {"asinf", "float", "float" },
  {"asinh", "double", "double" },
  {"astoa", "struct address *", "char *, struct address *" },
  {"atan", "double", "double" },
  {"atan2", "double", "double, double" },
  {"atan2f", "float", "float, float" },
  {"atanf", "float", "float" },
  {"atanh", "double", "double" },
  {"atexit", "int", "void (*) (void)" },
  {"atof", "double", "const char *" },
  {"atoi", "int", "const char *" },
  {"atol", "long int", "const char *" },
  {"atos", "char *", "char *, struct netbuf *, int" },
  {"auth_destroy", "void", "AUTH *" },
  {"authdes_create", "AUTH *", "" },
  {"authdes_getcred", "void", "struct authdes_cred *, short *, short *, short *, int *" },
  {"authdes_seccreate", "AUTH *", "" },
  {"authnone_create", "AUTH *", "void" },
  {"authsys_create", "AUTH *", "char *, int, int, int, int *" },
  {"authsys_create_default", "AUTH *", "void" },
  {"authunix_create", "AUTH *", "char *, int, int, int, int *" },
  {"authunix_create_default", "AUTH *", "void" },
  {"basename", "char *", "char *" },
  {"baudrate", "int", "void" },
  {"bcmp", "int", "const void *, const void *, int" },
  {"bcopy", "void", "const void *, void *, int" },
  {"beep", "int", "void" },
  {"bgets", "char *", "char *, __SIZE_TYPE__ , FILE *, char *" },
  {"bottom_panel", "int", "PANEL *" },
  {"box", "int", "WINDOW *, int , int " },
  {"brk", "int", "void *" },
  {"bsearch", "void *", "const void *, const void *, __SIZE_TYPE__ , __SIZE_TYPE__ , int (*) (const void *, const void *)" },
  {"bufsplit", "__SIZE_TYPE__", "char *, __SIZE_TYPE__ , char *" },
  {"bzero", "void", "void *, __SIZE_TYPE__ " },
  {"calchash", "long int", "" },
  {"calloc", "void *", "__SIZE_TYPE__ , __SIZE_TYPE__ " },
  {"callrpc", "void", "char *, unsigned long, unsigned long, unsigned long, xdrproc_t, char *, xdrproc_t, char *" },
  {"can_change_color", "bool", "void" },
  {"catclose", "int", "nl_catd" },
  {"catgets", "char *", "nl_catd, int, int, char *" },
  {"catopen", "nl_catd", "const char *, int" },
  {"cbreak", "int", "void" },
  {"cbrt", "double", "double" },
  {"ceil", "double", "double" },
  {"ceilf", "float", "float" },
  {"cfgetispeed", "speed_t", "const struct termios *" },
  {"cfgetospeed", "speed_t", "const struct termios *" },
  {"cfree", "void", "void *" },
  {"cfsetispeed", "int", "struct termios *, speed_t" },
  {"cfsetospeed", "int", "struct termios *, speed_t" },
  {"cftime", "int", "char *, char *, const long *" },
  {"chdir", "int", "const char *" },
  {"chmod", "int", "const char *, int " },
  {"chown", "int", "const char *, int , int " },
  {"chroot", "int", "const char *" },
  {"clean_GEN_rd", "void", "" },
  {"cleanup", "void", "" },
  {"clearerr", "void", "FILE *" },
  {"clearok", "int", "WINDOW *, int" },
  {"clnt_broadcast", "enum clnt_stat", "unsigned long, unsigned long, unsigned long, xdrproc_t, char *, xdrproc_t, char *, resultproc_t" },
  {"clnt_call", "enum clnt_stat", "CLIENT *, unsigned long, xdrproc_t, char *, xdrproc_t, char *, struct timeval" },
  {"clnt_control", "bool_t", "CLIENT *, int, char *" },
  {"clnt_create", "CLIENT *", "char *, unsigned long, unsigned long, char *" },
  {"clnt_destroy", "void", "CLIENT *" },
  {"clnt_freeres", "int", "CLIENT *, xdrproc_t, char *" },
  {"clnt_geterr", "void", "CLIENT *, struct rpc_err *" },
  {"clnt_pcreateerror", "void", "char *" },
  {"clnt_perrno", "void", "enum clnt_stat" },
  {"clnt_perror", "void", "CLIENT *, char *" },
  {"clnt_spcreateerror", "char *", "char *" },
  {"clnt_sperrno", "char *", "enum clnt_stat" },
  {"clnt_sperror", "char *", "CLIENT *, char *" },
  {"clnt_tli_create", "CLIENT *", "" },
  {"clnt_tp_create", "CLIENT *", "" },
  {"clnt_vc_create", "CLIENT *", "" },
  {"clntraw_create", "CLIENT *", "unsigned long, unsigned long" },
  {"clnttcp_create", "CLIENT *", "struct sockaddr_in *, unsigned long, unsigned long, int *, unsigned int, unsigned int *" },
  {"clntudp_bufcreate", "CLIENT *", "struct sockaddr_in *, unsigned long, unsigned long, struct timeval, int *, unsigned int, unsigned int" },
  {"clntudp_create", "CLIENT *", "struct sockaddr_in *, unsigned long, unsigned long, struct timeval, int *" },
  {"clock", "long", "void" },
  {"close", "int", "int" },
  {"closedir", "int", "DIR *" },
  {"color_content", "int", "int, short int *, short int *, short int *" },
  {"compile", "char *", "const char *, char *, char *" },
  {"copylist", "char *", "const char *, long *" },
  {"copysign", "double", "double, double" },
  {"copywin", "int", "WINDOW *, WINDOW *, int, int, int, int, int, int, int" },
  {"cos", "double", "double" },
  {"cosf", "float", "float" },
  {"cosh", "double", "double" },
  {"coshf", "float", "float" },
  {"cr_rduser", "struct rd_user *", "" },
  {"creat", "int", "const char *, int " },
  {"crmode", "int", "void" },
  {"crypt", "char *", "const char *, const char *" },
  {"crypt_close", "int", "int *" },
  {"ctermid", "char *", "char *" },
  {"ctime", "char *", "const long *" },
  {"current_field", "FIELD *", "FORM *" },
  {"current_item", "ITEM *", "MENU *" },
  {"curs_set", "int", "int" },
  {"curserr", "void", "void" },
  {"cuserid", "char *", "char *" },
  {"data_ahead", "int", "FORM *" },
  {"data_behind", "int", "FORM *" },
  {"dbmclose", "void", "void" },
  {"dbminit", "void", "const char *" },
  {"def_prog_mode", "int", "void" },
  {"def_shell_mode", "int", "void" },
  {"defread", "char *", "" },
  {"del_panel", "int", "PANEL *" },
  {"del_rduser", "void", "" },
  {"delay", "void", "long int" },
  {"delay_output", "int", "int" },
  {"delete", "void", "datum" },
  {"delscreen", "void", "SCREEN *" },
  {"delterm", "int", "TERMINAL *" },
  {"delwin", "int", "WINDOW *" },
  {"derwin", "WINDOW *", "WINDOW *, int, int, int, int" },
  {"des_crypt", "char *", "const char *, const char *" },
  {"des_encrypt", "void", "char *, int" },
  {"des_setkey", "void", "const char *" },
  {"devattr", "char *", "" },
  {"devfree", "int", "" },
  {"devreserv", "char **", "" },
  {"dial", "int", "CALL" },
  {"difftime", "double", "long , long " },
  {"dirname", "char *", "char *" },
  {"div", "div_t", "int, int" },
  {"dlclose", "int", "void *" },
  {"dlerror", "char *", "void" },
  {"dlopen", "void *", "char *, int" },
  {"dlsym", "void *", "void *, char *" },
  {"dma_access", "void", "u_char, u_int, u_int, u_char, u_char" },
  {"doupdate", "int", "void" },
  {"drainio", "int", "int" },
  {"drand48", "double", "void" },
  {"drem", "double", "double, double" },
  {"drv_getevtoken", "int", "" },
  {"drv_relevtoken", "void", "" },
  {"dup", "int", "int" },
  {"dup2", "int", "int, int" },
  {"dup_field", "FIELD *", "FIELD *, int, int" },
  {"dupwin", "WINDOW *", "WINDOW *" },
  {"dynamic_field_info", "int", "FIELD *, int *, int *, int *" },
  {"dysize", "int", "int" },
  {"eaccess", "int", "const char *, int" },
  {"echo", "int", "void" },
  {"ecvt", "char *", "double, int, int *, int *" },
  {"elf32_fsize", "__SIZE_TYPE__", "Elf_Type, __SIZE_TYPE__ , unsigned int" },
  {"elf32_getehdr", "Elf32_Ehdr *", "Elf *" },
  {"elf32_getphdr", "Elf32_Phdr *", "Elf *" },
  {"elf32_getshdr", "Elf32_Shdr *", "Elf_Scn *" },
  {"elf32_newehdr", "Elf32_Ehdr *", "Elf *" },
  {"elf32_newphdr", "Elf32_Phdr *", "Elf *, __SIZE_TYPE__ " },
  {"elf32_xlatetof", "Elf_Data *", "Elf_Data *, const Elf_Data *, unsigned int" },
  {"elf32_xlatetom", "Elf_Data *", "Elf_Data *, const Elf_Data *, unsigned int" },
  {"elf_begin", "Elf *", "int, Elf_Cmd, Elf *" },
  {"elf_cntl", "int", "Elf *, Elf_Cmd" },
  {"elf_end", "int", "Elf *" },
  {"elf_errmsg", "const char *", "int" },
  {"elf_errno", "int", "void" },
  {"elf_fill", "void", "int" },
  {"elf_flagdata", "unsigned int", "Elf_Data *, Elf_Cmd, unsigned int" },
  {"elf_flagehdr", "unsigned int", "Elf *, Elf_Cmd, unsigned int" },
  {"elf_flagelf", "unsigned int", "Elf *, Elf_Cmd, unsigned int" },
  {"elf_flagphdr", "unsigned int", "Elf *, Elf_Cmd, unsigned int" },
  {"elf_flagscn", "unsigned int", "Elf_Scn *, Elf_Cmd, unsigned int" },
  {"elf_flagshdr", "unsigned int", "Elf_Scn *, Elf_Cmd, unsigned int" },
  {"elf_getarhdr", "Elf_Arhdr *", "Elf *" },
  {"elf_getarsym", "Elf_Arsym *", "Elf *, __SIZE_TYPE__ *" },
  {"elf_getbase", "long", "Elf *" },
  {"elf_getdata", "Elf_Data *", "Elf_Scn *, Elf_Data *" },
  {"elf_getident", "char *", "Elf *, __SIZE_TYPE__ *" },
  {"elf_getscn", "Elf_Scn *", "Elf *, __SIZE_TYPE__ " },
  {"elf_hash", "long unsigned int", "const char *" },
  {"elf_kind", "Elf_Kind", "Elf *" },
  {"elf_ndxscn", "__SIZE_TYPE__", "Elf_Scn *" },
  {"elf_newdata", "Elf_Data *", "Elf_Scn *" },
  {"elf_newscn", "Elf_Scn *", "Elf *" },
  {"elf_next", "Elf_Cmd", "Elf *" },
  {"elf_nextscn", "Elf_Scn *", "Elf *, Elf_Scn *" },
  {"elf_rand", "__SIZE_TYPE__", "Elf *, __SIZE_TYPE__ " },
  {"elf_rawdata", "Elf_Data *", "Elf_Scn *, Elf_Data *" },
  {"elf_rawfile", "char *", "Elf *, __SIZE_TYPE__ *" },
  {"elf_strptr", "char *", "Elf *, __SIZE_TYPE__ , __SIZE_TYPE__ " },
  {"elf_update", "long", "Elf *, Elf_Cmd" },
  {"elf_version", "unsigned int", "unsigned int" },
  {"encrypt", "void", "char *, int" },
  {"endgrent", "void", "void" },
  {"endnetconfig", "int", "void *" },
  {"endnetpath", "int", "void *" },
  {"endpwent", "void", "void" },
  {"endrpcent", "void", "void" },
  {"endspent", "void", "void" },
  {"endutent", "void", "void" },
  {"endutxent", "void", "void" },
  {"endwin", "int", "void" },
  {"erand", "double", "short *" },
  {"erand48", "double", "short unsigned int *" },
  {"erasechar", "char", "void" },
  {"erf", "double", "double" },
  {"erfc", "double", "double" },
  {"execl", "int", "const char *, const char *, ..." },
  {"execle", "int", "const char *, const char *, ..." },
  {"execlp", "int", "const char *, const char *, ..." },
  {"exect", "int", "const char *, const char **, char **" },
  {"execv", "int", "const char *, char *const *" },
  {"execve", "int", "const char *, char *const *, char *const *" },
  {"execvp", "int", "const char *, char *const *" },
  {"exit", "void", "int" },
  {"exp", "double", "double" },
  {"expf", "float", "float" },
  {"fabs", "double", "double" },
  {"fabsf", "float", "float" },
  {"fattach", "int", "int, const char *" },
  {"fchdir", "int", "int" },
  {"fchmod", "int", "int, int " },
  {"fchown", "int", "int, int , int " },
  {"fclose", "int", "FILE *" },
  {"fcntl", "int", "int, int, ..." },
  {"fcvt", "char *", "double, int, int *, int *" },
  {"fdetach", "int", "const char *" },
  {"fdopen", "FILE *", "int, const char *" },
  {"feof", "int", "FILE *" },
  {"ferror", "int", "FILE *" },
  {"fetch", "datum", "datum" },
  {"fflush", "int", "FILE *" },
  {"ffs", "int", "int" },
  {"fgetc", "int", "FILE *" },
  {"fgetgrent", "struct group *", "FILE *" },
  {"fgetpos", "int", "FILE *, long *" },
  {"fgetpwent", "struct passwd *", "FILE *" },
  {"fgets", "char *", "char *, int, FILE *" },
  {"fgetspent", "struct spwd *", "FILE *" },
  {"field_arg", "char *", "FIELD *" },
  {"field_back", "int", "FIELD *" },
  {"field_buffer", "char *", "FIELD *, int" },
  {"field_count", "int", "FORM *" },
  {"field_fore", "int", "FIELD *" },
  {"field_index", "int", "FIELD *" },
  {"field_info", "int", "FIELD *, int *, int *, int *, int *, int *, int *" },
  {"field_init", "PTF_void", "FORM *" },
  {"field_just", "int", "FIELD *" },
  {"field_opts", "OPTIONS", "FIELD *" },
  {"field_opts_off", "int", "FIELD *, OPTIONS" },
  {"field_opts_on", "int", "FIELD *, OPTIONS" },
  {"field_pad", "int", "FIELD *" },
  {"field_status", "int", "FIELD *" },
  {"field_term", "PTF_void", "FORM *" },
  {"field_type", "FIELDTYPE *", "FIELD *" },
  {"field_userptr", "char *", "FIELD *" },
  {"fileno", "int", "FILE *" },
  {"filter", "int", "void" },
  {"finite", "int", "double" },
  {"firsthash", "datum", "" },
  {"firstkey", "datum", "void" },
  {"flash", "int", "void" },
  {"flock", "int", "int, int" },
  {"floor", "double", "double" },
  {"floorf", "float", "float" },
  {"flushinp", "int", "void" },
  {"fmod", "double", "double, double" },
  {"fmodf", "float", "float, float" },
  {"fmtmsg", "int", "long int, const char *, int, const char *, const char *, const char *" },
  {"fopen", "FILE *", "const char *, const char *" },
  {"fork", "int", "void" },
  {"form_driver", "int", "FORM *, int" },
  {"form_fields", "FIELD **", "FORM *" },
  {"form_init", "PTF_void", "FORM *" },
  {"form_opts", "OPTIONS", "FORM *" },
  {"form_opts_off", "int", "FORM *, OPTIONS" },
  {"form_opts_on", "int", "FORM *, OPTIONS" },
  {"form_page", "int", "FORM *" },
  {"form_sub", "WINDOW *", "FORM *" },
  {"form_term", "PTF_void", "FORM *" },
  {"form_userptr", "char *", "FORM *" },
  {"form_win", "WINDOW *", "FORM *" },
  {"fpathconf", "long int", "int, int" },
  {"fpclass", "fpclass_t", "double" },
  {"fpgetmask", "int", "void" },
  {"fpgetround", "fp_rnd", "void" },
  {"fpgetsticky", "int", "void" },
  {"fprintf", "int", "FILE *, const char *, ..." },
  {"fpsetmask", "int", "int" },
  {"fpsetround", "fp_rnd", "fp_rnd" },
  {"fpsetsticky", "int", "int" },
  {"fputc", "int", "int, FILE *" },
  {"fputs", "int", "const char *, FILE *" },
  {"fread", "__SIZE_TYPE__", "void *, __SIZE_TYPE__ , __SIZE_TYPE__ , FILE *" },
  {"free", "void", "void *" },
  {"free_field", "int", "FIELD *" },
  {"free_fieldtype", "int", "FIELDTYPE *" },
  {"free_form", "int", "FORM *" },
  {"free_item", "int", "ITEM *" },
  {"free_menu", "int", "MENU *" },
  {"freenetconfigent", "void", "struct netconfig *" },
  {"freopen", "FILE *", "const char *, const char *, FILE *" },
  {"frexp", "double", "double, int *" },
  {"fscanf", "int", "FILE *, const char *, ..." },
  {"fseek", "int", "FILE *, long int, int" },
  {"fsetpos", "int", "FILE *, const long *" },
  {"fstat", "int", "int, struct stat *" },
  {"fstatfs", "int", "int, struct statfs *, int, int" },
  {"fstatvfs", "int", "int, struct statvfs *" },
  {"fsync", "int", "int" },
  {"ftell", "long int", "FILE *" },
  {"ftok", "key_t", "const char *, int" },
  {"ftruncate", "int", "int, long " },
  {"ftw", "int", "const char *, int (*) (const char *, const struct stat *, int), int" },
  {"fwrite", "__SIZE_TYPE__", "const void *, __SIZE_TYPE__ , __SIZE_TYPE__ , FILE *" },
  {"gamma", "double", "double" },
  {"gcvt", "char *", "double, int, char *" },
  {"get_error", "int", "" },
  {"getattrs", "int", "WINDOW *" },
  {"getbegx", "int", "WINDOW *" },
  {"getbegy", "int", "WINDOW *" },
  {"getbkgd", "int", "WINDOW *" },
  {"getbmap", "long unsigned int", "void" },
  {"getc", "int", "FILE *" },
  {"getcap", "char *", "" },
  {"getchar", "int", "void" },
  {"getcontext", "int", "ucontext_t *" },
  {"getcurx", "int", "WINDOW *" },
  {"getcury", "int", "WINDOW *" },
  {"getcwd", "char *", "char *, __SIZE_TYPE__ " },
  {"getdate", "struct tm *", "const char *" },
  {"getdents", "int", "int, struct dirent *, unsigned int" },
  {"getdev", "char **", "" },
  {"getdgrp", "char **", "" },
  {"getdomainname", "int", "char *, int" },
  {"getdtablesize", "int", "void" },
  {"getegid", "int", "void" },
  {"getenv", "char *", "const char *" },
  {"geterec", "struct errhdr *", "" },
  {"geteslot", "struct errhdr *", "" },
  {"geteuid", "int", "void" },
  {"getgid", "int", "void" },
  {"getgrent", "struct group *", "void" },
  {"getgrgid", "struct group *", "int " },
  {"getgrnam", "struct group *", "const char *" },
  {"getgroups", "int", "int, int *" },
  {"gethostbyaddr", "struct hostent *", "" },
  {"gethostbyname", "struct hostent *", "" },
  {"gethostent", "struct hostent *", "" },
  {"gethostid", "long", "void" },
  {"gethostname", "int", "char *, int" },
  {"getitimer", "int", "int, struct itimerval *" },
  {"getlogin", "char *", "void" },
  {"getmaxx", "int", "WINDOW *" },
  {"getmaxy", "int", "WINDOW *" },
  {"getmntany", "int", "FILE *, struct mnttab *, struct mnttab *" },
  {"getmntent", "int", "" },
  {"getmouse", "long unsigned int", "void" },
  {"getmsg", "int", "int, struct strbuf *, struct strbuf *, int *" },
  {"getnetbyaddr", "struct netent *", "" },
  {"getnetbyname", "struct netent *", "" },
  {"getnetconfig", "struct netconfig *", "void *" },
  {"getnetconfigent", "struct netconfig *", "char *" },
  {"getnetent", "struct netent *", "" },
  {"getnetpath", "struct netconfig *", "void *" },
  {"getopt", "int", "int, char *const *, const char *" },
  {"getpagesize", "int", "void" },
  {"getparx", "int", "WINDOW *" },
  {"getpary", "int", "WINDOW *" },
  {"getpass", "char *", "const char *" },
  {"getpgid", "int", "int " },
  {"getpgrp", "int", "void" },
  {"getpgrp2", "int", "int " },
  {"getpid", "int", "void" },
  {"getpmsg", "int", "int, struct strbuf *, struct strbuf *, int *, int *" },
  {"getppid", "int", "void" },
  {"getpriority", "int", "int, int" },
  {"getprotobyname", "struct protoent *", "" },
  {"getprotobynumber", "struct protoent *", "" },
  {"getprotoent", "struct protoent *", "" },
  {"getpw", "int", "int, char *" },
  {"getpwent", "struct passwd *", "void" },
  {"getpwnam", "struct passwd *", "const char *" },
  {"getpwuid", "struct passwd *", "int " },
  {"getrlimit", "int", "int, struct rlimit *" },
  {"getrnge", "int", "char *" },
  {"getrpcbyname", "struct rpcent *", "const char *" },
  {"getrpcbynumber", "struct rpcent *", "int" },
  {"getrpcent", "struct rpcent *", "void" },
  {"getrusage", "int", "int, struct rusage *" },
  {"gets", "char *", "char *" },
  {"getservbyname", "struct servent *", "" },
  {"getservbyport", "struct servent *", "" },
  {"getservent", "struct servent *", "" },
  {"getsid", "int", "int " },
  {"getspent", "struct spwd *", "void" },
  {"getspnam", "struct spwd *", "const char *" },
  {"getsubopt", "int", "char **, char *const *, char **" },
  {"gettmode", "int", "void" },
  {"gettxt", "char *", "const char *, const char *" },
  {"getuid", "int", "void" },
  {"getutent", "struct utmp *", "void" },
  {"getutid", "struct utmp *", "const struct utmp *" },
  {"getutline", "struct utmp *", "const struct utmp *" },
  {"getutmp", "void", "const struct utmpx *, struct utmp *" },
  {"getutmpx", "void", "const struct utmp *, struct utmpx *" },
  {"getutxent", "struct utmpx *", "void" },
  {"getutxid", "struct utmpx *", "const struct utmpx *" },
  {"getutxline", "struct utmpx *", "const struct utmpx *" },
  {"getvfsany", "int", "FILE *, struct vfstab *, struct vfstab *" },
  {"getvfsent", "int", "FILE *, struct vfstab *" },
  {"getvfsfile", "int", "FILE *, struct vfstab *, char *" },
  {"getvfsspec", "int", "FILE *, struct vfstab *, char *" },
  {"getvol", "int", "" },
  {"getw", "int", "FILE *" },
  {"getwd", "char *", "char *" },
  {"getwidth", "void", "eucwidth_t *" },
  {"getwin", "WINDOW *", "FILE *" },
  {"gmatch", "int", "const char *, const char *" },
  {"gmtime", "struct tm *", "const long *" },
  {"gsignal", "int", "int" },
  {"halfdelay", "int", "int" },
  {"has_colors", "bool", "void" },
  {"has_ic", "int", "void" },
  {"has_il", "int", "void" },
  {"hashinc", "long int", "" },
  {"hasmntopt", "char *", "" },
  {"hcreate", "int", "__SIZE_TYPE__ " },
  {"hdestroy", "void", "void" },
  {"hide_panel", "int", "PANEL *" },
  {"host2netname", "int", "char *, char *, char *" },
  {"hrtalarm", "int", "hrtcmd_t *, int" },
  {"hrtcancel", "int", "const long int *, int" },
  {"hrtcntl", "int", "int, int, interval_t *, hrtime_t *" },
  {"hrtsleep", "int", "hrtcmd_t *" },
  {"hsearch", "ENTRY *", "ENTRY, ACTION" },
  {"htonl", "long unsigned int", "long unsigned int" },
  {"htons", "short unsigned int", "unsigned int" },
  {"hypot", "double", "double, double" },
  {"idcok", "void", "WINDOW *, int" },
  {"idlok", "int", "WINDOW *, int" },
  {"immedok", "void", "WINDOW *, int" },
  {"index", "char *", "const char *, int" },
  {"inet_addr", "long unsigned int", "" },
  {"inet_makeaddr", "struct in_addr", "" },
  {"inet_network", "long unsigned int", "" },
  {"inet_ntoa", "char *", "" },
  {"init_color", "int", "int, int, int, int" },
  {"init_pair", "int", "int, int, int" },
  {"initgroups", "int", "const char *, int " },
  {"initscr", "WINDOW *", "" },
  {"initscr", "WINDOW *", "void" },
  {"initstate", "char *", "unsigned, char *, int" },
  {"insque", "void", "struct qelem *, struct qelem *" },
  {"intrflush", "int", "WINDOW *, int" },
  {"ioctl", "int", "int, int, ..." },
  {"is_linetouched", "int", "WINDOW *, int" },
  {"is_wintouched", "int", "WINDOW *" },
  {"isalnum", "int", "int" },
  {"isalpha", "int", "int" },
  {"isascii", "int", "int" },
  {"isatty", "int", "int" },
  {"iscntrl", "int", "int" },
  {"isdigit", "int", "int" },
  {"isencrypt", "int", "const char *, __SIZE_TYPE__ " },
  {"isendwin", "int", "void" },
  {"isgraph", "int", "int" },
  {"isinf", "int", "double" },
  {"islower", "int", "int" },
  {"isnan", "int", "double" },
  {"isnand", "int", "double" },
  {"isnanf", "int", "float" },
  {"isprint", "int", "int" },
  {"ispunct", "int", "int" },
  {"isspace", "int", "int" },
  {"isupper", "int", "int" },
  {"isxdigit", "int", "int" },
  {"item_count", "int", "MENU *" },
  {"item_description", "char *", "ITEM *" },
  {"item_index", "int", "ITEM *" },
  {"item_init", "PTF_void", "MENU *" },
  {"item_name", "char *", "ITEM *" },
  {"item_opts", "OPTIONS", "ITEM *" },
  {"item_opts_off", "int", "ITEM *, OPTIONS" },
  {"item_opts_on", "int", "ITEM *, OPTIONS" },
  {"item_term", "PTF_void", "MENU *" },
  {"item_userptr", "char *", "ITEM *" },
  {"item_value", "int", "ITEM *" },
  {"item_visible", "int", "ITEM *" },
  {"itol", "long int", "" },
  {"j0", "double", "double" },
  {"j1", "double", "double" },
  {"jn", "double", "int, double" },
  {"jrand48", "long int", "short unsigned int *" },
  {"keyname", "char *", "int" },
  {"keypad", "int", "WINDOW *, int" },
  {"kill", "int", "int , int" },
  {"killchar", "char", "void" },
  {"killpg", "int", "int, int" },
  {"l3tol", "void", "long int *, const char *, int" },
  {"l64a", "char *", "long int" },
  {"labs", "long int", "long int" },
  {"ladd", "dl_t", "" },
  {"lchown", "int", "const char *, int , int " },
  {"lckpwdf", "int", "void" },
  {"lcong48", "void", "short unsigned int *" },
  {"ldaclose", "int", "struct ldfile *" },
  {"ldahread", "int", "struct ldfile *, archdr *" },
  {"ldaopen", "struct ldfile *", "const char *, struct ldfile *" },
  {"ldclose", "int", "struct ldfile *" },
  {"ldexp", "double", "double, int" },
  {"ldfhread", "int", "struct ldfile *, struct filehdr *" },
  {"ldgetname", "char *", "struct ldfile *, const struct syment *" },
  {"ldiv", "ldiv_t", "long int, long int" },
  {"ldivide", "dl_t", "" },
  {"ldlinit", "int", "struct ldfile *, long int" },
  {"ldlitem", "int", "struct ldfile *, unsigned int, struct lineno *" },
  {"ldlread", "int", "struct ldfile *, long int, unsigned int, struct lineno *" },
  {"ldlseek", "int", "struct ldfile *, unsigned int" },
  {"ldnlseek", "int", "struct ldfile *, const char *" },
  {"ldnrseek", "int", "struct ldfile *, const char *" },
  {"ldnshread", "int", "struct ldfile *, const char *, struct scnhdr *" },
  {"ldnsseek", "int", "struct ldfile *, const char *" },
  {"ldohseek", "int", "struct ldfile *" },
  {"ldopen", "struct ldfile *", "const char *, struct ldfile *" },
  {"ldrseek", "int", "struct ldfile *, unsigned int" },
  {"ldshread", "int", "struct ldfile *, unsigned int, struct scnhdr *" },
  {"ldsseek", "int", "struct ldfile *, unsigned int" },
  {"ldtbindex", "long int", "struct ldfile *" },
  {"ldtbread", "int", "struct ldfile *, long int, struct syment *" },
  {"ldtbseek", "int", "struct ldfile *" },
  {"leaveok", "int", "WINDOW *, int" },
  {"lexp10", "dl_t", "" },
  {"lfind", "void *", "const void *, const void *, __SIZE_TYPE__ *, __SIZE_TYPE__ , int (*) (const void *, const void *)" },
  {"lgamma", "double", "double" },
  {"link", "int", "const char *, const char *" },
  {"link_field", "FIELD *", "FIELD *, int, int" },
  {"link_fieldtype", "FIELDTYPE *", "FIELDTYPE *, FIELDTYPE *" },
  {"listdev", "char **", "" },
  {"listdgrp", "char **", "" },
  {"llog10", "dl_t", "" },
  {"lmul", "dl_t", "" },
  {"localeconv", "struct lconv *", "void" },
  {"localtime", "struct tm *", "const long *" },
  {"lock", "int", "int, int, long" },
  {"lockf", "int", "int, int, long int" },
  {"log", "double", "double" },
  {"log10", "double", "double" },
  {"log10f", "float", "float" },
  {"logb", "double", "double" },
  {"logf", "float", "float" },
  {"logname", "char *", "void" },
  {"longjmp", "void", "jmp_buf, int" },
  {"longname", "char *", "void" },
  {"lrand48", "long int", "void" },
  {"lsearch", "void *", "const void *, void *, __SIZE_TYPE__ *, __SIZE_TYPE__ , int (*) (const void *, const void *)" },
  {"lseek", "long", "int, long , int" },
  {"lshiftl", "dl_t", "" },
  {"lstat", "int", "const char *, struct stat *" },
  {"lsub", "dl_t", "" },
  {"ltol3", "void", "char *, const long int *, int" },
  {"m_addch", "int", "int" },
  {"m_addstr", "int", "char *" },
  {"m_clear", "int", "void" },
  {"m_erase", "int", "void" },
  {"m_initscr", "WINDOW *", "void" },
  {"m_move", "int", "int, int" },
  {"m_newterm", "SCREEN *", "char *, FILE *, FILE *" },
  {"m_refresh", "int", "void" },
  {"maillock", "int", "char *, int" },
  {"mailunlock", "int", "void" },
  {"major", "major_t", "long " },
  {"makdatum", "datum", "" },
  {"makecontext", "void", "ucontext_t *, void (*) (), int, ..." },
  {"makedev", "long", "major_t, minor_t" },
  {"makeutx", "struct utmpx *", "const struct utmpx *" },
  {"mallinfo", "struct mallinfo", "void" },
  {"malloc", "void *", "__SIZE_TYPE__ " },
  {"mallopt", "int", "int, int" },
  {"map_button", "int", "long unsigned int" },
  {"matherr", "int", "struct exception *" },
  {"mbftowc", "int", "char *, __WCHAR_TYPE__ *, int (*) (), int *" },
  {"mblen", "int", "const char *, __SIZE_TYPE__ " },
  {"mbstowcs", "__SIZE_TYPE__", "__WCHAR_TYPE__ *, const char *, __SIZE_TYPE__ " },
  {"mbtowc", "int", "__WCHAR_TYPE__ *, const char *, __SIZE_TYPE__ " },
  {"memalign", "void *", "__SIZE_TYPE__ , __SIZE_TYPE__ " },
  {"memccpy", "void *", "void *, const void *, int, __SIZE_TYPE__ " },
  {"memchr", "void *", "const void *, int, __SIZE_TYPE__ " },
  {"memcmp", "int", "const void *, const void *, __SIZE_TYPE__ " },
  {"memcpy", "void *", "void *, const void *, __SIZE_TYPE__ " },
  {"memlock", "int", "" },
  {"memlocked", "int", "" },
  {"memmove", "void *", "void *, const void *, __SIZE_TYPE__ " },
  {"memset", "void *", "void *, int, __SIZE_TYPE__ " },
  {"memunlock", "int", "" },
  {"menu_back", "int", "MENU *" },
  {"menu_driver", "int", "MENU *, int" },
  {"menu_fore", "int", "MENU *" },
  {"menu_format", "void", "MENU *, int *, int *" },
  {"menu_grey", "int", "MENU *" },
  {"menu_init", "PTF_void", "MENU *" },
  {"menu_items", "ITEM **", "MENU *" },
  {"menu_mark", "char *", "MENU *" },
  {"menu_opts", "OPTIONS", "MENU *" },
  {"menu_opts_off", "int", "MENU *, OPTIONS" },
  {"menu_opts_on", "int", "MENU *, OPTIONS" },
  {"menu_pad", "int", "MENU *" },
  {"menu_pattern", "char *", "MENU *" },
  {"menu_sub", "WINDOW *", "MENU *" },
  {"menu_term", "PTF_void", "MENU *" },
  {"menu_userptr", "char *", "MENU *" },
  {"menu_win", "WINDOW *", "MENU *" },
  {"meta", "int", "WINDOW *, int" },
  {"mfree", "void", "struct map *, __SIZE_TYPE__ , u_long" },
  {"mincore", "int", "caddr_t, __SIZE_TYPE__ , char *" },
  {"minor", "minor_t", "long " },
  {"mkdir", "int", "const char *, int " },
  {"mkdirp", "int", "const char *, int " },
  {"mkfifo", "int", "const char *, int " },
  {"mknod", "int", "const char *, int , long " },
  {"mkstemp", "int", "char *" },
  {"mktemp", "char *", "char *" },
  {"mktime", "long", "struct tm *" },
  {"mmap", "caddr_t", "" },
  {"modf", "double", "double, double *" },
  {"modff", "float", "float, float *" },
  {"modutx", "struct utmpx *", "const struct utmpx *" },
  {"monitor", "void", "int (*) (), int (*) ( ), WORD *, int, int" },
  {"mount", "int", "const char *, const char *, int, ..." },
  {"mouse_off", "int", "long int" },
  {"mouse_on", "int", "long int" },
  {"mouse_set", "int", "long int" },
  {"move_field", "int", "FIELD *, int, int" },
  {"move_panel", "int", "PANEL *, int, int" },
  {"mprotect", "int", "" },
  {"mrand48", "long int", "void" },
  {"msgctl", "int", "int, int, ..." },
  {"msgget", "int", "key_t, int" },
  {"msgrcv", "int", "int, void *, __SIZE_TYPE__ , long int, int" },
  {"msgsnd", "int", "int, const void *, __SIZE_TYPE__ , int" },
  {"munmap", "int", "" },
  {"mvcur", "int", "int, int, int, int" },
  {"mvderwin", "int", "WINDOW *, int, int" },
  {"mvprintw", "int", "int, int, ..." },
  {"mvscanw", "int", "int, int, ..." },
  {"mvwin", "int", "WINDOW *, int, int" },
  {"mvwprintw", "int", "WINDOW *, int, int, ..." },
  {"mvwscanw", "int", "WINDOW *, int, int, ..." },
  {"napms", "int", "int" },
  {"netdir_free", "void", "char *, int" },
  {"netdir_getbyaddr", "int", "struct netconfig *, struct nd_hostservlist **, struct netbuf *" },
  {"netdir_getbyname", "int", "struct netconfig *, struct nd_hostserv *, struct nd_addrlist **" },
  {"netdir_options", "int", "struct netconfig *, int, int, char *" },
  {"netdir_perror", "void", "char *" },
  {"netdir_sperror", "char *", "" },
  {"new_field", "FIELD *", "int, int, int, int, int, int" },
  {"new_fieldtype", "FIELDTYPE *", "PTF_int, PTF_int" },
  {"new_form", "FORM *", "FIELD **" },
  {"new_item", "ITEM *", "char *, char *" },
  {"new_menu", "MENU *", "ITEM **" },
  {"new_page", "int", "FIELD *" },
  {"new_panel", "PANEL *", "WINDOW *" },
  {"newkey", "int", "char *, int, int" },
  {"newpad", "WINDOW *", "int, int" },
  {"newscreen", "SCREEN *", "char *, int, int, int, FILE *, FILE *" },
  {"newterm32", "SCREEN *", "char *, FILE *, FILE *" },
  {"newwin", "WINDOW *", "int, int, int, int" },
  {"nextafter", "double", "double, double" },
  {"nextkey", "datum", "datum" },
  {"nftw", "int", "const char *, int (*) (const char *, const struct stat *, int, struct FTW *), int, int" },
  {"nice", "int", "int" },
  {"nl", "int", "void" },
  {"nl_langinfo", "char *", "nl_item" },
  {"nlist", "int", "const char *, struct nlist *" },
  {"nocbreak", "int", "void" },
  {"nocrmode", "int", "void" },
  {"nodelay", "int", "WINDOW *, int" },
  {"noecho", "int", "void" },
  {"nonl", "int", "void" },
  {"noraw", "int", "void" },
  {"notimeout", "int", "WINDOW *, int" },
  {"nrand48", "long int", "short unsigned int *" },
  {"ns_close", "int", "" },
  {"ns_rcv", "struct nssend *", "" },
  {"ns_send", "int", "" },
  {"ns_setup", "int", "" },
  {"ntohl", "long unsigned int", "long unsigned int" },
  {"ntohs", "short unsigned int", "unsigned int" },
  {"nuname", "int", "struct utsname *" },
  {"open", "int", "const char *, int, ..." },
  {"opendir", "DIR *", "const char *" },
  {"openprivwait", "int", "" },
  {"openwait", "int", "" },
  {"overlay", "int", "WINDOW *, WINDOW *" },
  {"overwrite", "int", "WINDOW *, WINDOW *" },
  {"p2close", "int", "FILE **" },
  {"p2open", "int", "const char *, FILE **" },
  {"p32echochar", "int", "WINDOW *, int " },
  {"p_cdname", "char *", "" },
  {"p_class", "char *", "" },
  {"p_rr", "char *", "" },
  {"p_type", "char *", "" },
  {"pair_content", "int", "int, short int *, short int *" },
  {"panel_above", "PANEL *", "PANEL *" },
  {"panel_below", "PANEL *", "PANEL *" },
  {"panel_userptr", "char *", "PANEL *" },
  {"panel_window", "WINDOW *", "PANEL *" },
  {"pathconf", "long int", "const char *, int" },
  {"pathfind", "char *", "const char *, const char *, const char *" },
  {"pause", "int", "void" },
  {"pclose", "int", "FILE *" },
  {"perror", "void", "const char *" },
  {"pfind", "struct pfdat *", "" },
  {"pglstlk", "int", "" },
  {"pglstunlk", "int", "" },
  {"pid_slot", "int", "proc_t *" },
  {"pipe", "int", "int *" },
  {"plock", "int", "int" },
  {"pmap_getmaps", "struct pmaplist *", "" },
  {"pmap_getport", "u_short", "" },
  {"pmap_rmtcall", "enum clnt_stat", "" },
  {"pmap_set", "int", "" },
  {"pmap_unset", "int", "" },
  {"pnoutrefresh", "int", "WINDOW *, int, int, int, int, int, int" },
  {"poll", "int", "struct pollfd *, long unsigned int, int" },
  {"popen", "FILE *", "const char *, const char *" },
  {"pos_form_cursor", "int", "FORM *" },
  {"pos_menu_cursor", "int", "MENU *" },
  {"post_form", "int", "FORM *" },
  {"post_menu", "int", "MENU *" },
  {"pow", "double", "double, double" },
  {"powf", "float", "float, float" },
  {"prefresh", "int", "WINDOW *, int, int, int, int, int, int" },
  {"printf", "int", "const char *, ..." },
  {"printw", "int", "char *, ..." },
  {"privsig", "void", "" },
  {"profil", "void", "short unsigned int *, __SIZE_TYPE__ , int, unsigned int" },
  {"psiginfo", "void", "siginfo_t *, char *" },
  {"psignal", "void", "int, const char *" },
  {"ptrace", "int", "int, int , int, int" },
  {"putc", "int", "int, FILE *" },
  {"putchar", "int", "int" },
  {"putenv", "int", "char *" },
  {"putmsg", "int", "int, const struct strbuf *, const struct strbuf *, int" },
  {"putp", "int", "char *" },
  {"putpmsg", "int", "int, const struct strbuf *, const struct strbuf *, int, int" },
  {"putpwent", "int", "const struct passwd *, FILE *" },
  {"puts", "int", "const char *" },
  {"putspent", "int", "const struct spwd *, FILE *" },
  {"pututline", "struct utmp *", "const struct utmp *" },
  {"pututxline", "struct utmpx *", "const struct utmpx *" },
  {"putw", "int", "int, FILE *" },
  {"putwin", "int", "WINDOW *, FILE *" },
  {"qsort", "void", "void *, __SIZE_TYPE__ , __SIZE_TYPE__ , int (*) (const void *, const void *)" },
  {"raise", "int", "int" },
  {"rand", "int", "void" },
  {"random", "long", "void" },
  {"raw", "int", "void" },
  {"read", "int", "int, void *, __SIZE_TYPE__ " },
  {"readdir", "struct dirent *", "DIR *" },
  {"readlink", "int", "const char *, void *, int" },
  {"realloc", "void *", "void *, __SIZE_TYPE__ " },
  {"realpath", "char *", "char *, char *" },
  {"redrawwin", "int", "WINDOW *" },
  {"regcmp", "char *", "const char *, ..." },
  {"regex", "char *", "const char *, const char *, ..." },
  {"remainder", "double", "double, double" },
  {"remio", "int", "" },
  {"remove", "int", "const char *" },
  {"remque", "void", "struct qelem *" },
  {"rename", "int", "const char *, const char *" },
  {"replace_panel", "int", "PANEL *, WINDOW *" },
  {"request_mouse_pos", "int", "void" },
  {"reservdev", "struct reservdev **", "" },
  {"reset_prog_mode", "int", "void" },
  {"reset_shell_mode", "int", "void" },
  {"resetty", "int", "void" },
  {"restartterm", "int", "char *, int, int *" },
  {"rewind", "void", "FILE *" },
  {"rewinddir", "void", "DIR *" },
  {"rf_falloc", "int", "" },
  {"rindex", "char *", "const char *, int" },
  {"rint", "double", "double" },
  {"ripoffline", "int", "int, int (*) (WINDOW *, int)" },
  {"rmdir", "int", "const char *" },
  {"rmdirp", "int", "char *, char *" },
  {"rpc_broadcast", "enum clnt_stat", "" },
  {"rpc_call", "enum clnt_stat", "" },
  {"rpcb_getaddr", "int", "" },
  {"rpcb_getmaps", "RPCBLIST *", "" },
  {"rpcb_gettime", "int", "" },
  {"rpcb_rmtcall", "enum clnt_stat", "" },
  {"rpcb_set", "int", "" },
  {"rpcb_taddr2uaddr", "char *", "" },
  {"rpcb_uaddr2taddr", "struct netbuf *", "" },
  {"rpcb_unset", "int", "" },
  {"rpctest_service", "void", "" },
  {"run_crypt", "int", "long int, char *, unsigned int, int *" },
  {"run_setkey", "int", "int *, const char *" },
  {"savetty", "int", "void" },
  {"sbrk", "void *", "int" },
  {"scalb", "double", "double, double" },
  {"scale_form", "int", "FORM *, int *, int *" },
  {"scale_menu", "int", "MENU *, int *, int *" },
  {"scanf", "int", "const char *, ..." },
  {"scanw", "int", "char *, ..." },
  {"scr_dump", "int", "char *" },
  {"scr_init", "int", "char *" },
  {"scr_restore", "int", "char *" },
  {"scroll", "int", "WINDOW *" },
  {"scrollok", "int", "WINDOW *, int" },
  {"scrwidth", "int", "__WCHAR_TYPE__ " },
  {"sdfree", "int", "char *" },
  {"sdget", "char *", "char *, int, ..." },
  {"seed48", "short unsigned int *", "short unsigned int *" },
  {"seekdir", "void", "DIR *, long int" },
  {"semctl", "int", "int, int, int, ..." },
  {"semget", "int", "key_t, int, int" },
  {"semop", "int", "int, struct sembuf *, unsigned int" },
  {"send", "int", "int, char *, int, int" },
  {"set_current_field", "int", "FORM *, FIELD *" },
  {"set_current_item", "int", "MENU *, ITEM *" },
  {"set_field_back", "int", "FIELD *, int " },
  {"set_field_buffer", "int", "FIELD *, int, char *" },
  {"set_field_fore", "int", "FIELD *, int " },
  {"set_field_init", "int", "FORM *, PTF_void" },
  {"set_field_just", "int", "FIELD *, int" },
  {"set_field_opts", "int", "FIELD *, OPTIONS" },
  {"set_field_pad", "int", "FIELD *, int" },
  {"set_field_status", "int", "FIELD *, int" },
  {"set_field_term", "int", "FORM *, PTF_void" },
  {"set_field_type", "int", "FIELD *, FIELDTYPE *, ..." },
  {"set_field_userptr", "int", "FIELD *, char *" },
  {"set_fieldtype_arg", "int", "FIELDTYPE *, PTF_charP, PTF_charP, PTF_void" },
  {"set_fieldtype_choice", "int", "FIELDTYPE *, PTF_int, PTF_int" },
  {"set_form_fields", "int", "FORM *, FIELD **" },
  {"set_form_init", "int", "FORM *, PTF_void" },
  {"set_form_opts", "int", "FORM *, OPTIONS" },
  {"set_form_page", "int", "FORM *, int" },
  {"set_form_sub", "int", "FORM *, WINDOW *" },
  {"set_form_term", "int", "FORM *, PTF_void" },
  {"set_form_userptr", "int", "FORM *, char *" },
  {"set_form_win", "int", "FORM *, WINDOW *" },
  {"set_item_init", "int", "MENU *, PTF_void" },
  {"set_item_opts", "int", "ITEM *, OPTIONS" },
  {"set_item_term", "int", "MENU *, PTF_void" },
  {"set_item_userptr", "int", "ITEM *, char *" },
  {"set_item_value", "int", "ITEM *, int" },
  {"set_max_field", "int", "FIELD *, int" },
  {"set_menu_back", "int", "MENU *, int " },
  {"set_menu_fore", "int", "MENU *, int " },
  {"set_menu_format", "int", "MENU *, int, int" },
  {"set_menu_grey", "int", "MENU *, int " },
  {"set_menu_init", "int", "MENU *, PTF_void" },
  {"set_menu_items", "int", "MENU *, ITEM **" },
  {"set_menu_mark", "int", "MENU *, char *" },
  {"set_menu_opts", "int", "MENU *, OPTIONS" },
  {"set_menu_pad", "int", "MENU *, int" },
  {"set_menu_pattern", "int", "MENU *, char *" },
  {"set_menu_sub", "int", "MENU *, WINDOW *" },
  {"set_menu_term", "int", "MENU *, PTF_void" },
  {"set_menu_userptr", "int", "MENU *, char *" },
  {"set_menu_win", "int", "MENU *, WINDOW *" },
  {"set_new_page", "int", "FIELD *, int" },
  {"set_panel_userptr", "int", "PANEL *, char *" },
  {"set_top_row", "int", "MENU *, int" },
  {"setbuf", "void", "FILE *, char *" },
  {"setcontext", "int", "ucontext_t *" },
  {"setcurscreen", "SCREEN *", "SCREEN *" },
  {"setcurterm", "TERMINAL *", "TERMINAL *" },
  {"setexportent", "FILE *", "void" },
  {"setgid", "int", "int " },
  {"setgrent", "void", "void" },
  {"setgroups", "int", "int, const int *" },
  {"sethostname", "int", "char *, int" },
  {"setitimer", "int", "int, struct itimerval *, struct itimerval *" },
  {"setjmp", "int", "jmp_buf" },
  {"setkey", "void", "const char *" },
  {"setlocale", "char *", "int, const char *" },
  {"setmntent", "FILE *", "char *, char *" },
  {"setnetconfig", "void *", "void" },
  {"setnetpath", "void *", "void" },
  {"setpgid", "int", "int , int " },
  {"setpgrp", "int", "void" },
  {"setpgrp2", "int", "int , int " },
  {"setpriority", "int", "int, int, int" },
  {"setprivwait", "int", "" },
  {"setpwent", "void", "void" },
  {"setregid", "int", "int , int " },
  {"setreuid", "int", "int , int " },
  {"setrlimit", "int", "int, struct rlimit *" },
  {"setrpcent", "int", "int" },
  {"setsid", "int", "void" },
  {"setspent", "void", "void" },
  {"setstate", "char *", "char *" },
  {"setsyx", "int", "int, int" },
  {"setterm", "int", "char *" },
  {"setuid", "int", "int " },
  {"setupterm", "int", "char *, int, int *" },
  {"setutent", "void", "void" },
  {"setutxent", "void", "void" },
  {"setvbuf", "int", "FILE *, char *, int, __SIZE_TYPE__ " },
  {"sgetl", "long int", "const char *" },
  {"shmat", "void *", "int, void *, int" },
  {"shmctl", "int", "int, int, ..." },
  {"shmdt", "int", "void *" },
  {"shmget", "int", "key_t, int, int" },
  {"show_panel", "int", "PANEL *" },
  {"sigaction", "int", "int, const struct sigaction *, struct sigaction *" },
  {"sigaddset", "int", "sigset_t *, int" },
  {"sigaltstack", "int", "const stack_t *, stack_t *" },
  {"sigblock", "int", "int" },
  {"sigdelset", "int", "sigset_t *, int" },
  {"sigemptyset", "int", "sigset_t *" },
  {"sigfillset", "int", "sigset_t *" },
  {"sighold", "int", "int" },
  {"sigignore", "int", "int" },
  {"siginterrupt", "int", "int, int" },
  {"sigismember", "int", "const sigset_t *, int" },
  {"siglongjmp", "void", "sigjmp_buf, int" },
  {"sigpause", "int", "int" },
  {"sigpending", "int", "sigset_t *" },
  {"sigprocmask", "int", "int, const sigset_t *, sigset_t *" },
  {"sigrelse", "int", "int" },
  {"sigsend", "int", "idtype_t, id_t, int" },
  {"sigsendset", "int", "const procset_t *, int" },
  {"sigsetjmp", "int", "sigjmp_buf, int" },
  {"sigsetmask", "int", "int" },
  {"sigsuspend", "int", "sigset_t *" },
  {"sin", "double", "double" },
  {"sinf", "float", "float" },
  {"sinh", "double", "double" },
  {"sinhf", "float", "float" },
  {"sleep", "unsigned int", "unsigned int" },
  {"slk_attroff", "int", "int " },
  {"slk_attron", "int", "int " },
  {"slk_attrset", "int", "int " },
  {"slk_clear", "int", "void" },
  {"slk_init", "int", "int" },
  {"slk_label", "char *", "int" },
  {"slk_noutrefresh", "int", "void" },
  {"slk_refresh", "int", "void" },
  {"slk_restore", "int", "void" },
  {"slk_set", "int", "int, char *, int" },
  {"slk_start", "int", "int, int *" },
  {"slk_touch", "int", "void" },
  {"sprayproc_clear_1", "void *", "" },
  {"sprayproc_get_1", "spraycumul *", "" },
  {"sprayproc_spray_1", "void *", "" },
  {"sprintf", "int", "char *, const char *, ..." },
  {"sputl", "void", "long int, char *" },
  {"sqrt", "double", "double" },
  {"sqrtf", "float", "float" },
  {"srand", "void", "unsigned int" },
  {"srand48", "void", "long int" },
  {"srandom", "void", "int" },
  {"sscanf", "int", "const char *, const char *, ..." },
  {"start_color", "int", "void" },
  {"stat", "int", "const char *, struct stat *" },
  {"statfs", "int", "const char *, struct statfs *, int, int" },
  {"statvfs", "int", "const char *, struct statvfs *" },
  {"step", "int", "const char *, const char *" },
  {"stime", "int", "const long *" },
  {"stoa", "struct netbuf *", "char *, struct netbuf *" },
  {"store", "void", "datum, datum" },
  {"strcadd", "char *", "char *, const char *" },
  {"strcat", "char *", "char *, const char *" },
  {"strccpy", "char *", "char *, const char *" },
  {"strchr", "char *", "const char *, int" },
  {"strclearctty", "void", "" },
  {"strclearpg", "void", "" },
  {"strclearsid", "void", "" },
  {"strcmp", "int", "const char *, const char *" },
  {"strcoll", "int", "const char *, const char *" },
  {"strcpy", "char *", "char *, const char *" },
  {"strcspn", "__SIZE_TYPE__", "const char *, const char *" },
  {"strdup", "char *", "const char *" },
  {"streadd", "char *", "char *, const char *, const char *" },
  {"strecpy", "char *", "char *, const char *, const char *" },
  {"strerror", "char *", "int" },
  {"strfind", "int", "const char *, const char *" },
  {"strftime", "__SIZE_TYPE__", "char *, __SIZE_TYPE__ , const char *, const struct tm *" },
  {"strlen", "__SIZE_TYPE__", "const char *" },
  {"strncat", "char *", "char *, const char *, __SIZE_TYPE__ " },
  {"strncmp", "int", "const char *, const char *, __SIZE_TYPE__ " },
  {"strncpy", "char *", "char *, const char *, __SIZE_TYPE__ " },
  {"strpbrk", "char *", "const char *, const char *" },
  {"strrchr", "char *", "const char *, int" },
  {"strrspn", "char *", "const char *, const char *" },
  {"strspn", "__SIZE_TYPE__", "const char *, const char *" },
  {"strstr", "char *", "const char *, const char *" },
  {"strtod", "double", "const char *, char **" },
  {"strtok", "char *", "char *, const char *" },
  {"strtol", "long int", "const char *, char **, int" },
  {"strtoul", "long unsigned int", "const char *, char **, int" },
  {"strtrns", "char *", "const char *, const char *, const char *, char *" },
  {"strxfrm", "__SIZE_TYPE__", "char *, const char *, __SIZE_TYPE__ " },
  {"subpad", "WINDOW *", "WINDOW *, int, int, int, int" },
  {"subwin", "WINDOW *", "WINDOW *, int, int, int, int" },
  {"svc_create", "int", "" },
  {"svc_fd_create", "SVCXPRT *", "" },
  {"svc_getreqset", "void", "" },
  {"svc_raw_create", "SVCXPRT *", "" },
  {"svc_reg", "int", "" },
  {"svc_tli_create", "SVCXPRT *", "" },
  {"svc_tp_create", "SVCXPRT *", "" },
  {"svc_unreg", "void", "" },
  {"svc_vc_create", "SVCXPRT *", "" },
  {"svcerr_systemerr", "void", "" },
  {"svcfd_create", "SVCXPRT *", "" },
  {"svcraw_create", "SVCXPRT *", "" },
  {"svctcp_create", "SVCXPRT *", "" },
  {"svcudp_bufcreate", "SVCXPRT *", "" },
  {"svcudp_create", "SVCXPRT *", "" },
  {"swab", "void", "const char *, char *, int" },
  {"swapcontext", "int", "ucontext_t *, ucontext_t *" },
  {"symlink", "int", "const char *, const char *" },
  {"sync", "void", "void" },
  {"syncok", "int", "WINDOW *, int" },
  {"syscall", "int", "int, ..." },
  {"sysconf", "long int", "int" },
  {"sysfs", "int", "int, ..." },
  {"sysinfo", "int", "int, char *, long int" },
  {"system", "int", "const char *" },
  {"taddr2uaddr", "char *", "struct netconfig *, struct netbuf *" },
  {"tan", "double", "double" },
  {"tanf", "float", "float" },
  {"tanh", "double", "double" },
  {"tanhf", "float", "float" },
  {"tcdrain", "int", "int" },
  {"tcflow", "int", "int, int" },
  {"tcflush", "int", "int, int" },
  {"tcgetattr", "int", "int, struct termios *" },
  {"tcgetpgrp", "int", "int" },
  {"tcgetsid", "int", "int" },
  {"tcsendbreak", "int", "int, int" },
  {"tcsetattr", "int", "int, int, const struct termios *" },
  {"tcsetpgrp", "int", "int, int " },
  {"tdelete", "void *", "const void *, void **, int (*) (const void *, const void *)" },
  {"telldir", "long int", "DIR *" },
  {"tempnam", "char *", "const char *, const char *" },
  {"termattrs", "int", "void" },
  {"termerr", "void", "void" },
  {"termname", "char *", "void" },
  {"tfind", "void *", "const void *, void *const *, int (*) (const void *, const void *)" },
  {"tgetent", "int", "char *, char *" },
  {"tgetflag", "int", "char *" },
  {"tgetnum", "int", "char *" },
  {"tgetstr", "char *", "char *, char **" },
  {"tgoto", "char *", "char *, int, int" },
  {"tigetstr", "char *", "char *" },
  {"time", "long", "long *" },
  {"times", "long", "struct tms *" },
  {"timezone", "char *", "int, int" },
  {"tinputfd", "void", "int" },
  {"tmpfile", "FILE *", "void" },
  {"tmpnam", "char *", "char *" },
  {"toascii", "int", "int" },
  {"tolower", "int", "int" },
  {"top_panel", "int", "PANEL *" },
  {"top_row", "int", "MENU *" },
  {"touchline", "int", "WINDOW *, int, int" },
  {"touchwin", "int", "WINDOW *" },
  {"toupper", "int", "int" },
  {"tparm", "char *", "" },
  {"tputs", "int", "char *, int, int (*) (char)" },
  {"traceoff", "int", "void" },
  {"traceon", "int", "void" },
  {"truncate", "int", "const char *, long " },
  {"tsearch", "void *", "const void *, void **, int (*) (const void *, const void *)" },
  {"ttyname", "char *", "int" },
  {"ttyslot", "int", "void" },
  {"twalk", "void", "void *, void (*) (void *, VISIT, int)" },
  {"typeahead", "int", "int" },
  {"tzset", "void", "void" },
  {"uaddr2taddr", "struct netbuf *", "struct netconfig *, char *" },
  {"uadmin", "int", "int, int, int" },
  {"ualarm", "unsigned", "unsigned, unsigned" },
  {"ulckpwdf", "int", "void" },
  {"ulimit", "long int", "int, ..." },
  {"umask", "int", "int " },
  {"umount", "int", "const char *" },
  {"uname", "int", "struct utsname *" },
  {"unctrl", "char *", "int" },
  {"undial", "void", "int" },
  {"ungetc", "int", "int, FILE *" },
  {"ungetch", "int", "int" },
  {"unlink", "int", "const char *" },
  {"unordered", "int", "double, double" },
  {"unpost_form", "int", "FORM *" },
  {"unpost_menu", "int", "MENU *" },
  {"unremio", "int", "" },
  {"untouchwin", "int", "WINDOW *" },
  {"update_panels", "void", "void" },
  {"updwtmp", "void", "const char *, struct utmp *" },
  {"updwtmpx", "void", "const char *, struct utmpx *" },
  {"use_env", "void", "int" },
  {"usleep", "unsigned", "unsigned" },
  {"ustat", "int", "long , struct ustat *" },
  {"utime", "int", "const char *, const struct utimbuf *" },
  {"utmpname", "int", "const char *" },
  {"utmpxname", "int", "const char *" },
  {"va_end", "void", "__gnuc_va_list" },
  {"vadvise", "int", "int" },
  {"valloc", "void *", "__SIZE_TYPE__ " },
  {"vfork", "int", "void" },
  {"vfprintf", "int", "FILE *, const char *, __gnuc_va_list" },
  {"vhangup", "int", "void" },
  {"vid32attr", "int", "int " },
  {"vid32puts", "int", "int , int (*) (char)" },
  {"vidupdate", "void", "int , int , int (*) (char)" },
  {"vn_close", "int", "" },
  {"vprintf", "int", "const char *, __gnuc_va_list" },
  {"vsprintf", "int", "char *, const char *, __gnuc_va_list" },
  {"vwprintw", "int", "WINDOW *, char *, void *" },
  {"vwscanw", "int", "WINDOW *, char *, void *" },
  {"waddch", "int", "WINDOW *, int " },
  {"w32attroff", "int", "WINDOW *, int " },
  {"w32attron", "int", "WINDOW *, int " },
  {"w32attrset", "int", "WINDOW *, int " },
  {"w32echochar", "int", "WINDOW *, int " },
  {"winsch", "int", "WINDOW *, int " },
  {"waddchnstr", "int", "WINDOW *, int *, int" },
  {"waddnstr", "int", "WINDOW *, char *, int" },
  {"waddstr", "int", "WINDOW *, char *" },
  {"wait", "int", "void *" },
  {"wait3", "int", "union wait *, int, struct rusage *" },
  {"waitid", "int", "idtype_t, id_t, siginfo_t *, int" },
  {"waitpid", "int", "int , int *, int" },
  {"wallproc_wall_1", "void *", "" },
  {"wbkgd", "int", "WINDOW *, int " },
  {"wbkgdset", "void", "WINDOW *, int " },
  {"wborder", "int", "WINDOW *, int , int , int , int , int , int , int , int " },
  {"wclear", "int", "WINDOW *" },
  {"wclrtobot", "int", "WINDOW *" },
  {"wclrtoeol", "int", "WINDOW *" },
  {"wcstombs", "__SIZE_TYPE__", "char *, const __WCHAR_TYPE__ *, __SIZE_TYPE__ " },
  {"wctomb", "int", "char *, __WCHAR_TYPE__ " },
  {"wcursyncup", "void", "WINDOW *" },
  {"wdelch", "int", "WINDOW *" },
  {"wdeleteln", "int", "WINDOW *" },
  {"werase", "int", "WINDOW *" },
  {"wgetch", "int", "WINDOW *" },
  {"wgetnstr", "int", "WINDOW *, char *, int" },
  {"wgetstr", "int", "WINDOW *, char *" },
  {"whline", "int", "WINDOW *, int , int" },
  {"winch", "int", "WINDOW *" },
  {"winchnstr", "int", "WINDOW *, int *, int" },
  {"winchstr", "int", "WINDOW *, int *" },
  {"winnstr", "int", "WINDOW *, char *, int" },
  {"winsdelln", "int", "WINDOW *, int" },
  {"winsertln", "int", "WINDOW *" },
  {"winsnstr", "int", "WINDOW *, char *, int" },
  {"winstr", "int", "WINDOW *, char *" },
  {"wisprint", "int", "__WCHAR_TYPE__ " },
  {"wmouse_position", "void", "WINDOW *, int *, int *" },
  {"wmove", "int", "WINDOW *, int, int" },
  {"wnoutrefresh", "int", "WINDOW *" },
  {"wprintw", "int", "WINDOW *, ..." },
  {"wredrawln", "int", "WINDOW *, int, int" },
  {"wrefresh", "int", "WINDOW *" },
  {"write", "int", "int, const void *, __SIZE_TYPE__ " },
  {"wscanw", "int", "WINDOW *, ..." },
  {"wscrl", "int", "WINDOW *, int" },
  {"wsetscrreg", "int", "WINDOW *, int, int" },
  {"wstandend", "int", "WINDOW *" },
  {"wstandout", "int", "WINDOW *" },
  {"wsyncdown", "void", "WINDOW *" },
  {"wsyncup", "void", "WINDOW *" },
  {"wtimeout", "void", "WINDOW *, int" },
  {"wtouchln", "int", "WINDOW *, int, int, int" },
  {"wvline", "int", "WINDOW *, int , int" },
  {"xdr_datum", "bool", "" },
  {"xdr_double", "int", "" },
  {"xdr_exports", "int", "" },
  {"xdr_fhstatus", "int", "" },
  {"xdr_float", "int", "" },
  {"xdr_keybuf", "int", "" },
  {"xdr_mountlist", "int", "" },
  {"xdr_netbuf", "int", "" },
  {"xdr_path", "int", "" },
  {"xdr_pmap", "int", "" },
  {"xdr_pmaplist", "int", "" },
  {"xdr_pointer", "int", "" },
  {"xdr_reference", "int", "" },
  {"xdr_rmtcall_args", "int", "" },
  {"xdr_rmtcallres", "int", "" },
  {"xdr_rpcb", "int", "" },
  {"xdr_rpcb_rmtcallargs", "int", "" },
  {"xdr_rpcb_rmtcallres", "int", "" },
  {"xdr_rpcblist", "int", "" },
  {"xdr_sprayarr", "int", "" },
  {"xdr_spraycumul", "int", "" },
  {"xdr_spraytimeval", "int", "" },
  {"xdr_u_char", "int", "" },
  {"xdr_utmparr", "int", "" },
  {"xdr_utmpidlearr", "int", "" },
  {"xdr_vector", "int", "" },
  {"xdr_yp_buf", "int", "" },
  {"xdr_yp_inaddr", "bool", "" },
  {"xdr_ypall", "bool", "" },
  {"xdr_ypdelete_args", "int", "" },
  {"xdr_ypdomain_wrap_string", "bool", "" },
  {"xdr_ypmap_parms", "bool", "" },
  {"xdr_ypmap_wrap_string", "bool", "" },
  {"xdr_ypowner_wrap_string", "bool", "" },
  {"xdr_yppushresp_xfr", "bool", "" },
  {"xdr_ypreq_key", "bool", "" },
  {"xdr_ypreq_newxfr", "bool", "" },
  {"xdr_ypreq_nokey", "bool", "" },
  {"xdr_ypreq_xfr", "bool", "" },
  {"xdr_ypresp_key_val", "bool", "" },
  {"xdr_ypresp_maplist", "bool", "" },
  {"xdr_ypresp_master", "bool", "" },
  {"xdr_ypresp_order", "bool", "" },
  {"xdr_ypresp_val", "bool", "" },
  {"xdr_ypupdate_args", "int", "" },
  {"xdrrec_create", "void", "" },
  {"xdrrec_endofrecord", "int", "" },
  {"xdrrec_eof", "int", "" },
  {"xdrrec_skiprecord", "int", "" },
  {"xdrstdio_create", "void", "" },
  {"xprt_register", "void", "" },
  {"xprt_unregister", "void", "" },
  {"y0", "double", "double" },
  {"y1", "double", "double" },
  {"yn", "double", "int, double" },
  {"yp_all", "int", "char *, char *, struct ypall_callback *" },
  {"yp_bind", "int", "const char *" },
  {"yp_first", "int", "char *, char *, char **, int *, char **, int *" },
  {"yp_get_default_domain", "int", "char **" },
  {"yp_master", "int", "char *, char *, char **" },
  {"yp_match", "int", "char *, char *, char *, int, char **, int *" },
  {"yp_next", "int", "char *, char *, char *, int, char **, int *, char **, int *" },
  {"yp_order", "int", "char *, char *, int *" },
  {"yp_unbind", "void", "const char *" },
  {"yperr_string", "char *", "int" },
  {"ypprot_err", "int", "unsigned int" },
  {"ypu_change_1", "u_int *", "" },
  {"ypu_delete_1", "u_int *", "" },
  {"ypu_insert_1", "u_int *", "" },
  {"ypu_store_1", "u_int *", "" },
{0, 0, 0}
};
#define HASH_SIZE 2503
short hash_tab[HASH_SIZE] = {
  1089,
  0,
  124,
  126,
  726,
  0,
  0,
  0,
  934,
  0,
  0,
  1304,
  120,
  797,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1118,
  1194,
  1090,
  1007,
  1274,
  316,
  341,
  732,
  795,
  814,
  1235,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  162,
  365,
  530,
  686,
  765,
  775,
  824,
  48,
  1041,
  1258,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  562,
  417,
  944,
  506,
  1091,
  0,
  181,
  195,
  414,
  240,
  750,
  631,
  980,
  1024,
  1092,
  88,
  546,
  1137,
  1093,
  256,
  614,
  1094,
  396,
  1285,
  1220,
  0,
  0,
  82,
  427,
  596,
  260,
  536,
  0,
  919,
  137,
  1173,
  1008,
  40,
  261,
  0,
  140,
  0,
  0,
  999,
  1324,
  649,
  0,
  0,
  1309,
  917,
  0,
  38,
  0,
  0,
  0,
  6,
  0,
  367,
  938,
  815,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  465,
  0,
  0,
  269,
  251,
  669,
  1109,
  622,
  0,
  0,
  0,
  1317,
  573,
  1256,
  1335,
  0,
  0,
  0,
  0,
  968,
  0,
  695,
  0,
  0,
  1157,
  1177,
  0,
  424,
  0,
  716,
  11,
  698,
  259,
  928,
  1307,
  0,
  489,
  0,
  0,
  72,
  383,
  0,
  1300,
  59,
  491,
  0,
  0,
  191,
  373,
  515,
  936,
  946,
  0,
  0,
  122,
  606,
  1189,
  1013,
  910,
  0,
  0,
  982,
  0,
  0,
  1000,
  0,
  0,
  0,
  640,
  741,
  379,
  1192,
  871,
  1269,
  0,
  583,
  1313,
  808,
  820,
  0,
  39,
  0,
  0,
  0,
  391,
  1236,
  0,
  1298,
  0,
  292,
  1180,
  0,
  0,
  0,
  0,
  1161,
  0,
  0,
  777,
  0,
  1156,
  1287,
  1175,
  1290,
  1123,
  1207,
  0,
  0,
  453,
  0,
  0,
  0,
  0,
  0,
  0,
  1299,
  145,
  950,
  0,
  663,
  0,
  0,
  0,
  0,
  918,
  0,
  577,
  0,
  1244,
  0,
  0,
  819,
  0,
  1318,
  0,
  0,
  0,
  179,
  198,
  237,
  0,
  0,
  749,
  767,
  0,
  0,
  0,
  371,
  315,
  428,
  429,
  349,
  566,
  744,
  239,
  0,
  0,
  0,
  96,
  0,
  1204,
  0,
  0,
  0,
  0,
  458,
  0,
  0,
  46,
  277,
  751,
  706,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1,
  437,
  761,
  567,
  0,
  652,
  302,
  861,
  317,
  888,
  935,
  264,
  52,
  90,
  879,
  989,
  849,
  1277,
  27,
  641,
  970,
  1026,
  1268,
  0,
  0,
  299,
  1278,
  0,
  0,
  0,
  0,
  0,
  825,
  0,
  0,
  0,
  0,
  0,
  0,
  703,
  632,
  0,
  0,
  0,
  0,
  0,
  0,
  395,
  0,
  0,
  0,
  0,
  0,
  1166,
  401,
  463,
  0,
  1017,
  0,
  21,
  382,
  450,
  0,
  991,
  1150,
  152,
  929,
  537,
  342,
  283,
  924,
  1262,
  0,
  0,
  538,
  911,
  0,
  1108,
  0,
  1272,
  806,
  965,
  0,
  0,
  647,
  983,
  1340,
  0,
  388,
  0,
  0,
  0,
  1087,
  0,
  812,
  104,
  108,
  1023,
  1065,
  0,
  142,
  0,
  0,
  927,
  1021,
  73,
  0,
  0,
  0,
  147,
  9,
  394,
  0,
  0,
  571,
  832,
  572,
  77,
  223,
  267,
  636,
  1182,
  1036,
  1208,
  432,
  545,
  1230,
  759,
  0,
  0,
  0,
  464,
  0,
  737,
  0,
  0,
  0,
  0,
  1100,
  0,
  0,
  0,
  0,
  0,
  507,
  0,
  0,
  0,
  0,
  618,
  408,
  925,
  753,
  0,
  0,
  0,
  0,
  0,
  0,
  940,
  0,
  0,
  786,
  0,
  0,
  309,
  452,
  736,
  734,
  856,
  900,
  984,
  1116,
  0,
  850,
  0,
  310,
  0,
  0,
  282,
  0,
  0,
  0,
  717,
  281,
  957,
  0,
  774,
  1264,
  0,
  0,
  0,
  0,
  0,
  611,
  446,
  0,
  211,
  1049,
  114,
  0,
  971,
  115,
  615,
  539,
  116,
  363,
  1185,
  657,
  915,
  1226,
  1263,
  117,
  0,
  791,
  1206,
  14,
  540,
  1172,
  0,
  389,
  148,
  0,
  762,
  0,
  348,
  0,
  376,
  1252,
  0,
  0,
  0,
  0,
  826,
  0,
  0,
  866,
  0,
  156,
  0,
  0,
  0,
  0,
  0,
  0,
  313,
  626,
  813,
  873,
  0,
  0,
  166,
  0,
  300,
  569,
  1158,
  314,
  1195,
  1284,
  0,
  0,
  357,
  168,
  213,
  337,
  144,
  392,
  412,
  840,
  876,
  93,
  964,
  74,
  79,
  94,
  344,
  398,
  206,
  393,
  738,
  895,
  448,
  462,
  981,
  1034,
  1176,
  1045,
  1187,
  1322,
  0,
  510,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  535,
  20,
  482,
  0,
  1098,
  0,
  1133,
  1246,
  0,
  330,
  364,
  403,
  0,
  0,
  0,
  0,
  0,
  0,
  648,
  0,
  0,
  0,
  859,
  733,
  0,
  95,
  0,
  1122,
  0,
  543,
  563,
  0,
  1003,
  98,
  943,
  0,
  0,
  468,
  469,
  386,
  470,
  598,
  658,
  1239,
  0,
  0,
  0,
  0,
  869,
  0,
  0,
  584,
  705,
  121,
  0,
  1200,
  197,
  0,
  831,
  0,
  1288,
  0,
  0,
  0,
  1336,
  0,
  0,
  22,
  0,
  0,
  0,
  0,
  0,
  0,
  858,
  0,
  1018,
  0,
  756,
  0,
  0,
  0,
  508,
  0,
  533,
  778,
  0,
  0,
  119,
  1081,
  992,
  1190,
  200,
  1219,
  1267,
  0,
  0,
  0,
  0,
  528,
  0,
  16,
  473,
  0,
  0,
  0,
  295,
  0,
  229,
  0,
  33,
  0,
  150,
  164,
  713,
  828,
  645,
  1209,
  1257,
  0,
  0,
  0,
  0,
  0,
  0,
  881,
  0,
  1308,
  0,
  0,
  0,
  24,
  0,
  642,
  184,
  1002,
  932,
  0,
  1316,
  623,
  650,
  64,
  783,
  651,
  1168,
  343,
  351,
  0,
  402,
  271,
  289,
  549,
  1012,
  0,
  30,
  898,
  207,
  827,
  8,
  902,
  0,
  0,
  913,
  0,
  0,
  513,
  34,
  1199,
  870,
  28,
  575,
  700,
  1046,
  841,
  1240,
  0,
  61,
  905,
  0,
  109,
  0,
  1146,
  0,
  0,
  0,
  550,
  845,
  138,
  425,
  848,
  1144,
  951,
  0,
  852,
  906,
  1030,
  1095,
  1126,
  0,
  0,
  0,
  0,
  1312,
  672,
  0,
  0,
  0,
  0,
  0,
  0,
  103,
  0,
  0,
  0,
  0,
  0,
  0,
  685,
  1020,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  707,
  0,
  0,
  0,
  304,
  105,
  111,
  106,
  112,
  887,
  945,
  1184,
  0,
  0,
  0,
  1039,
  42,
  511,
  675,
  0,
  0,
  0,
  0,
  0,
  1249,
  0,
  0,
  0,
  0,
  0,
  185,
  612,
  355,
  1015,
  555,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  886,
  377,
  0,
  0,
  336,
  668,
  0,
  0,
  0,
  0,
  646,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  591,
  592,
  433,
  436,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  274,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  298,
  544,
  0,
  75,
  0,
  0,
  1132,
  1107,
  0,
  0,
  0,
  189,
  1028,
  0,
  0,
  279,
  0,
  0,
  471,
  15,
  793,
  896,
  1043,
  1242,
  0,
  0,
  0,
  0,
  1096,
  224,
  0,
  0,
  0,
  0,
  868,
  1054,
  128,
  0,
  0,
  593,
  1210,
  430,
  653,
  0,
  1247,
  0,
  1280,
  1303,
  1124,
  1305,
  1306,
  0,
  0,
  405,
  0,
  624,
  0,
  490,
  0,
  0,
  0,
  0,
  0,
  439,
  908,
  872,
  461,
  123,
  325,
  680,
  772,
  956,
  1001,
  1329,
  280,
  498,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  400,
  0,
  671,
  883,
  766,
  0,
  0,
  153,
  619,
  976,
  0,
  613,
  799,
  1071,
  1325,
  247,
  1326,
  0,
  472,
  0,
  0,
  160,
  97,
  1070,
  1167,
  0,
  0,
  368,
  0,
  0,
  0,
  438,
  244,
  0,
  0,
  125,
  974,
  0,
  0,
  0,
  0,
  0,
  1139,
  0,
  234,
  1178,
  1082,
  843,
  1193,
  1293,
  0,
  81,
  889,
  0,
  0,
  684,
  0,
  217,
  0,
  604,
  287,
  1243,
  0,
  0,
  204,
  568,
  922,
  0,
  0,
  747,
  385,
  1066,
  483,
  559,
  1225,
  1327,
  0,
  1135,
  86,
  0,
  0,
  0,
  0,
  0,
  560,
  0,
  0,
  0,
  57,
  1224,
  901,
  41,
  0,
  0,
  724,
  0,
  132,
  231,
  0,
  541,
  776,
  442,
  23,
  554,
  912,
  958,
  216,
  1042,
  1228,
  0,
  1191,
  522,
  660,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1237,
  635,
  406,
  967,
  0,
  68,
  0,
  0,
  0,
  345,
  1099,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  353,
  930,
  0,
  0,
  655,
  509,
  25,
  66,
  688,
  742,
  625,
  420,
  421,
  891,
  1153,
  157,
  721,
  0,
  480,
  296,
  547,
  582,
  1072,
  1038,
  720,
  729,
  0,
  0,
  0,
  60,
  0,
  0,
  0,
  477,
  986,
  0,
  303,
  0,
  286,
  897,
  0,
  709,
  689,
  1321,
  141,
  758,
  56,
  451,
  781,
  899,
  556,
  374,
  10,
  335,
  975,
  0,
  822,
  419,
  0,
  0,
  0,
  67,
  0,
  0,
  441,
  727,
  301,
  415,
  909,
  493,
  1212,
  0,
  0,
  990,
  755,
  690,
  711,
  962,
  0,
  855,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  443,
  230,
  512,
  837,
  1035,
  725,
  0,
  0,
  589,
  0,
  867,
  193,
  920,
  194,
  768,
  1283,
  639,
  0,
  0,
  0,
  0,
  0,
  413,
  0,
  0,
  834,
  0,
  0,
  0,
  0,
  0,
  0,
  1051,
  0,
  218,
  0,
  0,
  0,
  664,
  988,
  0,
  677,
  835,
  739,
  564,
  0,
  0,
  0,
  0,
  1222,
  0,
  1154,
  0,
  714,
  219,
  0,
  1276,
  0,
  570,
  1331,
  605,
  916,
  1169,
  0,
  0,
  0,
  350,
  0,
  0,
  0,
  0,
  0,
  444,
  810,
  1101,
  380,
  390,
  0,
  0,
  0,
  254,
  0,
  0,
  1068,
  1010,
  0,
  770,
  1060,
  1142,
  0,
  0,
  0,
  133,
  0,
  0,
  13,
  50,
  600,
  1281,
  0,
  0,
  0,
  0,
  526,
  0,
  627,
  803,
  0,
  220,
  0,
  0,
  0,
  0,
  0,
  0,
  972,
  0,
  178,
  561,
  1174,
  0,
  165,
  610,
  712,
  488,
  771,
  158,
  809,
  1215,
  0,
  366,
  578,
  0,
  683,
  1110,
  278,
  699,
  952,
  31,
  985,
  0,
  0,
  0,
  0,
  0,
  321,
  1120,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1067,
  361,
  0,
  110,
  0,
  0,
  839,
  0,
  0,
  0,
  0,
  0,
  907,
  588,
  892,
  475,
  884,
  1339,
  0,
  1102,
  0,
  0,
  740,
  378,
  1114,
  1148,
  0,
  0,
  340,
  1088,
  953,
  0,
  0,
  252,
  0,
  416,
  0,
  0,
  818,
  0,
  1250,
  1254,
  36,
  0,
  0,
  0,
  0,
  0,
  0,
  1216,
  0,
  0,
  662,
  0,
  177,
  1069,
  524,
  1105,
  0,
  0,
  0,
  0,
  0,
  687,
  0,
  525,
  579,
  659,
  960,
  1055,
  0,
  210,
  0,
  358,
  481,
  0,
  0,
  12,
  0,
  0,
  0,
  0,
  290,
  0,
  1106,
  1270,
  0,
  0,
  0,
  0,
  0,
  238,
  1073,
  811,
  1141,
  1342,
  0,
  0,
  0,
  0,
  0,
  0,
  1179,
  0,
  0,
  520,
  0,
  0,
  1037,
  0,
  0,
  516,
  0,
  0,
  0,
  214,
  1031,
  1032,
  1127,
  1128,
  241,
  0,
  0,
  0,
  476,
  616,
  1075,
  85,
  1201,
  422,
  440,
  1004,
  0,
  1214,
  1259,
  948,
  0,
  0,
  1271,
  19,
  654,
  0,
  0,
  846,
  0,
  183,
  0,
  0,
  0,
  0,
  253,
  1080,
  411,
  0,
  903,
  1006,
  0,
  107,
  0,
  0,
  0,
  0,
  55,
  0,
  718,
  857,
  874,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  118,
  1165,
  1232,
  0,
  1311,
  0,
  270,
  284,
  369,
  459,
  529,
  701,
  0,
  447,
  484,
  0,
  1053,
  585,
  44,
  0,
  0,
  977,
  0,
  844,
  0,
  0,
  0,
  1061,
  0,
  143,
  978,
  1341,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  760,
  0,
  0,
  0,
  1077,
  423,
  0,
  43,
  69,
  136,
  257,
  404,
  0,
  0,
  0,
  0,
  0,
  70,
  682,
  914,
  1131,
  0,
  963,
  1181,
  1315,
  0,
  327,
  0,
  1328,
  54,
  847,
  1227,
  0,
  0,
  0,
  558,
  1147,
  1275,
  297,
  0,
  0,
  71,
  0,
  893,
  0,
  798,
  800,
  1314,
  65,
  0,
  0,
  862,
  621,
  0,
  0,
  454,
  455,
  1164,
  0,
  0,
  0,
  1319,
  0,
  0,
  0,
  661,
  0,
  356,
  933,
  0,
  0,
  0,
  0,
  0,
  1265,
  474,
  0,
  0,
  319,
  0,
  186,
  1047,
  1050,
  466,
  228,
  697,
  710,
  634,
  0,
  0,
  324,
  601,
  0,
  1291,
  445,
  205,
  0,
  0,
  0,
  691,
  0,
  0,
  0,
  0,
  146,
  80,
  479,
  32,
  882,
  1155,
  0,
  836,
  1104,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  854,
  0,
  0,
  0,
  372,
  1149,
  0,
  0,
  0,
  0,
  0,
  161,
  208,
  492,
  467,
  565,
  1261,
  792,
  0,
  580,
  880,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1323,
  0,
  0,
  0,
  37,
  1022,
  629,
  318,
  865,
  1333,
  0,
  0,
  339,
  987,
  0,
  0,
  171,
  174,
  276,
  557,
  833,
  275,
  1221,
  1337,
  0,
  263,
  864,
  1301,
  456,
  0,
  268,
  288,
  0,
  99,
  172,
  995,
  1251,
  0,
  0,
  0,
  829,
  0,
  305,
  381,
  942,
  173,
  1202,
  0,
  167,
  426,
  496,
  1292,
  0,
  232,
  0,
  0,
  679,
  0,
  47,
  752,
  532,
  0,
  0,
  1084,
  0,
  0,
  0,
  209,
  0,
  0,
  0,
  139,
  418,
  503,
  0,
  0,
  0,
  215,
  487,
  0,
  937,
  0,
  779,
  0,
  0,
  0,
  1241,
  91,
  0,
  242,
  0,
  0,
  149,
  249,
  804,
  851,
  0,
  0,
  0,
  0,
  332,
  58,
  0,
  617,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  681,
  285,
  505,
  495,
  633,
  0,
  360,
  674,
  45,
  801,
  926,
  1048,
  0,
  0,
  226,
  0,
  494,
  1253,
  0,
  0,
  359,
  0,
  0,
  0,
  227,
  0,
  1138,
  973,
  0,
  794,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  523,
  1310,
  574,
  190,
  407,
  773,
  1085,
  527,
  0,
  0,
  0,
  0,
  182,
  1113,
  1229,
  1145,
  581,
  1294,
  308,
  0,
  0,
  0,
  0,
  0,
  0,
  18,
  311,
  551,
  312,
  397,
  552,
  92,
  638,
  743,
  203,
  163,
  155,
  722,
  757,
  842,
  921,
  1058,
  1086,
  1186,
  941,
  1205,
  2,
  266,
  1282,
  255,
  0,
  0,
  0,
  0,
  904,
  1130,
  1117,
  531,
  1334,
  0,
  0,
  0,
  0,
  346,
  0,
  460,
  728,
  885,
  0,
  807,
  0,
  0,
  375,
  0,
  1103,
  1056,
  1111,
  607,
  0,
  763,
  754,
  838,
  1273,
  322,
  969,
  931,
  1083,
  0,
  250,
  0,
  823,
  35,
  347,
  1160,
  501,
  0,
  0,
  0,
  0,
  0,
  0,
  431,
  1152,
  0,
  0,
  0,
  0,
  1279,
  548,
  0,
  159,
  0,
  212,
  875,
  0,
  860,
  630,
  0,
  0,
  202,
  0,
  0,
  542,
  748,
  0,
  113,
  0,
  502,
  293,
  63,
  457,
  258,
  586,
  0,
  1074,
  0,
  0,
  196,
  0,
  0,
  0,
  0,
  0,
  17,
  1170,
  326,
  0,
  236,
  76,
  894,
  939,
  1125,
  0,
  0,
  504,
  676,
  517,
  1052,
  199,
  246,
  821,
  1295,
  1260,
  0,
  0,
  1016,
  500,
  1025,
  0,
  0,
  51,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1183,
  0,
  225,
  0,
  0,
  201,
  1057,
  0,
  0,
  151,
  0,
  1078,
  0,
  890,
  0,
  0,
  89,
  180,
  0,
  0,
  0,
  696,
  0,
  590,
  329,
  5,
  620,
  1248,
  354,
  449,
  0,
  1255,
  993,
  4,
  708,
  514,
  959,
  1059,
  0,
  1238,
  863,
  0,
  0,
  1197,
  0,
  0,
  0,
  0,
  0,
  370,
  0,
  0,
  534,
  518,
  1033,
  1129,
  1296,
  1338,
  0,
  0,
  0,
  1062,
  0,
  49,
  628,
  694,
  702,
  0,
  1196,
  853,
  644,
  435,
  731,
  0,
  0,
  670,
  0,
  1151,
  0,
  0,
  0,
  0,
  0,
  130,
  0,
  53,
  609,
  599,
  0,
  0,
  169,
  62,
  1213,
  0,
  0,
  0,
  387,
  101,
  0,
  0,
  723,
  0,
  0,
  1163,
  0,
  0,
  323,
  0,
  0,
  1027,
  0,
  1040,
  0,
  1014,
  0,
  0,
  553,
  0,
  0,
  0,
  1162,
  0,
  0,
  0,
  0,
  0,
  1064,
  409,
  830,
  954,
  1188,
  0,
  0,
  0,
  221,
  0,
  175,
  715,
  608,
  1231,
  1245,
  0,
  0,
  0,
  673,
  1330,
  0,
  176,
  0,
  0,
  1044,
  0,
  0,
  352,
  1171,
  100,
  796,
  384,
  745,
  805,
  789,
  998,
  362,
  1029,
  0,
  0,
  0,
  764,
  1097,
  331,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  966,
  996,
  0,
  294,
  730,
  0,
  497,
  955,
  0,
  0,
  134,
  1140,
  1211,
  1223,
  84,
  1159,
  0,
  0,
  328,
  0,
  0,
  135,
  1121,
  262,
  0,
  0,
  877,
  0,
  1115,
  273,
  0,
  0,
  0,
  0,
  102,
  666,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  782,
  0,
  0,
  643,
  320,
  78,
  1234,
  0,
  410,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1218,
  802,
  0,
  0,
  0,
  961,
  1076,
  602,
  603,
  192,
  746,
  692,
  0,
  0,
  399,
  0,
  595,
  1079,
  485,
  790,
  1198,
  1009,
  1203,
  0,
  0,
  0,
  0,
  0,
  233,
  0,
  307,
  0,
  0,
  704,
  0,
  0,
  87,
  222,
  693,
  0,
  248,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  187,
  265,
  787,
  816,
  1136,
  0,
  0,
  154,
  788,
  434,
  1005,
  1233,
  678,
  0,
  0,
  878,
  0,
  486,
  997,
  0,
  1320,
  0,
  665,
  26,
  735,
  272,
  769,
  597,
  519,
  1011,
  499,
  1119,
  923,
  0,
  29,
  656,
  0,
  0,
  0,
  784,
  0,
  0,
  0,
  0,
  0,
  188,
  0,
  478,
  0,
  0,
  0,
  521,
  0,
  129,
  0,
  0,
  0,
  291,
  0,
  1286,
  0,
  1134,
  0,
  0,
  0,
  245,
  243,
  0,
  0,
  1112,
  83,
  0,
  334,
  576,
  979,
  0,
  333,
  1019,
  0,
  1289,
  0,
  170,
  0,
  0,
  0,
  0,
  0,
  0,
  338,
  0,
  994,
  667,
  780,
  1143,
  0,
  235,
  306,
  0,
  0,
  1302,
  0,
  0,
  7,
  719,
  0,
  0,
  3,
  785,
  1063,
  817,
  1217,
  0,
  127,
  594,
  0,
  0,
  1266,
  131,
  0,
  0,
  949,
  1297,
  1332,
  587,
  637,
  947,
};
