/*									tab:2
 *
 * tcpip.h - Generic Active Messages Macro for TCP/IP Active Messages
 *
 * "Copyright (c) 1994 by Lok Tin Liu and The Regents of the University 
 * of California.  All rights reserved."
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Author: 			Lok Tin Liu
 * Version:			29
 * Creation Date:	Fri Jul  8 13:35:01 1994
 * Filename:		tcpip.h
 * History:
 */


#ifndef _TCPIP_AM_H_
#define _TCPIP_AM_H_

#include "am.h"

#define splitc_poll() am_poll()
#define exit(code) am_exit(code)
#define barrier() am_barrier(1)

#define am_xferBuffer(dest, fun, arg, local, remote, len) \
  am_store(dest, fun, arg, 0, local, remote, len)

#define am_xferBuffer2(dest, fun, arg1, arg2, local, remote, len) \
  am_store(dest, fun, arg1, arg2, local, remote, len)

#endif

