/* Generated automatically by the program `genrecog'
from the machine description file `md'.  */

#include "config.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "real.h"
#include "output.h"
#include "flags.h"

extern rtx gen_split_71 ();
extern rtx gen_split_132 ();
extern rtx gen_split_133 ();

/* `recog' contains a decision tree
   that recognizes whether the rtx X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.
   If the rtx is valid, recog returns a nonnegative number
   which is the insn code number for the pattern that matched.
   This is the same as the order in the machine description of
   the entry that matched.  This number can be used as an index into
   entry that matched.  This number can be used as an index into various
   insn_* tables, such as insn_templates, insn_outfun, and insn_n_operands
   (found in insn-output.c).

   The third argument to recog is an optional pointer to an int.
   If present, recog will accept a pattern if it matches except for
   missing CLOBBER expressions at the end.  In that case, the value
   pointed to by the optional pointer will be set to the number of
   CLOBBERs that need to be added (it should be initialized to zero by
   the caller).  If it is set nonzero, the caller should allocate a
   PARALLEL of the appropriate size, copy the initial entries, and call
   add_clobbers (found in insn-emit.c) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl in a SEQUENCE if it can be.*/

rtx recog_operand[MAX_RECOG_OPERANDS];

rtx *recog_operand_loc[MAX_RECOG_OPERANDS];

rtx *recog_dup_loc[MAX_DUP_OPERANDS];

char recog_dup_num[MAX_DUP_OPERANDS];

#define operands recog_operand

int
recog_1 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  int tem;

  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != SImode)
    goto ret0;
  switch (GET_CODE (x1))
    {
    case IOR:
      goto L18;
    case NEG:
      goto L27;
    case PLUS:
      goto L33;
    case MINUS:
      goto L68;
    case SMIN:
      goto L116;
    case UMIN:
      goto L121;
    case SMAX:
      goto L126;
    case UMAX:
      goto L131;
    case IF_THEN_ELSE:
      goto L136;
    case MEM:
      goto L210;
    case EQ:
    case NE:
    case LE:
    case LT:
    case GE:
    case GT:
    case LEU:
    case LTU:
    case GEU:
    case GTU:
      if (comparison_operator (x1, SImode))
	{
	  ro[3] = x1;
	  goto L13;
	}
    }
  goto ret0;

  L18:
  x2 = XEXP (x1, 0);
  if (comparison_operator (x2, SImode))
    {
      ro[3] = x2;
      goto L19;
    }
  goto ret0;

  L19:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L20;
    }
  goto ret0;

  L20:
  x3 = XEXP (x2, 1);
  if (arith11_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L21;
    }
  goto ret0;

  L21:
  x2 = XEXP (x1, 1);
  if (comparison_operator (x2, SImode))
    {
      ro[6] = x2;
      goto L22;
    }
  goto ret0;

  L22:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[4] = x3;
      goto L23;
    }
  goto ret0;

  L23:
  x3 = XEXP (x2, 1);
  if (arith11_operand (x3, SImode))
    {
      ro[5] = x3;
      return 16;
    }
  goto ret0;

  L27:
  x2 = XEXP (x1, 0);
  if (comparison_operator (x2, SImode))
    {
      ro[3] = x2;
      goto L28;
    }
  goto ret0;

  L28:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L29;
    }
  goto ret0;

  L29:
  x3 = XEXP (x2, 1);
  if (arith11_operand (x3, SImode))
    {
      ro[2] = x3;
      return 17;
    }
  goto ret0;

  L33:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode)
    goto ret0;
  switch (GET_CODE (x2))
    {
    case LEU:
      goto L34;
    case GEU:
      goto L41;
    case GTU:
      goto L48;
    }
  L54:
  if (comparison_operator (x2, SImode))
    {
      ro[4] = x2;
      goto L55;
    }
  goto ret0;

  L34:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L35;
    }
  goto L54;

  L35:
  x3 = XEXP (x2, 1);
  if (arith11_operand (x3, SImode))
    {
      ro[3] = x3;
      goto L36;
    }
  goto L54;

  L36:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      return 18;
    }
  x2 = XEXP (x1, 0);
  goto L54;

  L41:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L42;
    }
  goto L54;

  L42:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[3] = x3;
      goto L43;
    }
  goto L54;

  L43:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      return 19;
    }
  x2 = XEXP (x1, 0);
  goto L54;

  L48:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L49;
    }
  goto L54;

  L49:
  x3 = XEXP (x2, 1);
  if (int11_operand (x3, SImode))
    {
      ro[3] = x3;
      goto L50;
    }
  goto L54;

  L50:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      return 20;
    }
  x2 = XEXP (x1, 0);
  goto L54;

  L55:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L56;
    }
  goto ret0;

  L56:
  x3 = XEXP (x2, 1);
  if (arith11_operand (x3, SImode))
    {
      ro[3] = x3;
      goto L57;
    }
  goto ret0;

  L57:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      return 21;
    }
  goto ret0;

  L68:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode)
    goto ret0;
  if (GET_CODE (x2) == MINUS && 1)
    goto L69;
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L62;
    }
  goto ret0;

  L69:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L70;
    }
  goto ret0;

  L70:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != SImode)
    goto ret0;
  switch (GET_CODE (x3))
    {
    case GTU:
      goto L71;
    case LTU:
      goto L87;
    case LEU:
      goto L103;
    }
  goto ret0;

  L71:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L72;
    }
  goto ret0;

  L72:
  x4 = XEXP (x3, 1);
  if (arith11_operand (x4, SImode))
    {
      ro[3] = x4;
      goto L73;
    }
  goto ret0;

  L73:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[4] = x2;
      return 23;
    }
  goto ret0;

  L87:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L88;
    }
  goto ret0;

  L88:
  x4 = XEXP (x3, 1);
  if (register_operand (x4, SImode))
    {
      ro[3] = x4;
      goto L89;
    }
  goto ret0;

  L89:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[4] = x2;
      return 25;
    }
  goto ret0;

  L103:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L104;
    }
  goto ret0;

  L104:
  x4 = XEXP (x3, 1);
  if (int11_operand (x4, SImode))
    {
      ro[3] = x4;
      goto L105;
    }
  goto ret0;

  L105:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[4] = x2;
      return 27;
    }
  goto ret0;

  L62:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != SImode)
    goto ret0;
  switch (GET_CODE (x2))
    {
    case GTU:
      goto L63;
    case LTU:
      goto L79;
    case LEU:
      goto L95;
    }
  L110:
  if (comparison_operator (x2, SImode))
    {
      ro[4] = x2;
      goto L111;
    }
  goto ret0;

  L63:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L64;
    }
  goto L110;

  L64:
  x3 = XEXP (x2, 1);
  if (arith11_operand (x3, SImode))
    {
      ro[3] = x3;
      return 22;
    }
  goto L110;

  L79:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L80;
    }
  goto L110;

  L80:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[3] = x3;
      return 24;
    }
  goto L110;

  L95:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L96;
    }
  goto L110;

  L96:
  x3 = XEXP (x2, 1);
  if (int11_operand (x3, SImode))
    {
      ro[3] = x3;
      return 26;
    }
  goto L110;

  L111:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L112;
    }
  goto ret0;

  L112:
  x3 = XEXP (x2, 1);
  if (arith11_operand (x3, SImode))
    {
      ro[3] = x3;
      return 28;
    }
  goto ret0;

  L116:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L117;
    }
  goto ret0;

  L117:
  x2 = XEXP (x1, 1);
  if (arith11_operand (x2, SImode))
    {
      ro[2] = x2;
      return 29;
    }
  goto ret0;

  L121:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L122;
    }
  goto ret0;

  L122:
  x2 = XEXP (x1, 1);
  if (arith11_operand (x2, SImode))
    {
      ro[2] = x2;
      return 30;
    }
  goto ret0;

  L126:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L127;
    }
  goto ret0;

  L127:
  x2 = XEXP (x1, 1);
  if (arith11_operand (x2, SImode))
    {
      ro[2] = x2;
      return 31;
    }
  goto ret0;

  L131:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L132;
    }
  goto ret0;

  L132:
  x2 = XEXP (x1, 1);
  if (arith11_operand (x2, SImode))
    {
      ro[2] = x2;
      return 32;
    }
  goto ret0;

  L136:
  x2 = XEXP (x1, 0);
  if (comparison_operator (x2, VOIDmode))
    {
      ro[5] = x2;
      goto L137;
    }
  goto ret0;

  L137:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[3] = x3;
      goto L138;
    }
  goto ret0;

  L138:
  x3 = XEXP (x2, 1);
  if (arith11_operand (x3, SImode))
    {
      ro[4] = x3;
      goto L139;
    }
  goto ret0;

  L139:
  x2 = XEXP (x1, 1);
  if (reg_or_cint_move_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L140;
    }
  goto ret0;

  L140:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 33;
  L148:
  if (reg_or_cint_move_operand (x2, SImode))
    {
      ro[2] = x2;
      return 34;
    }
  goto ret0;

  L210:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L211;
  goto ret0;

  L211:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L212;
    }
  goto ret0;

  L212:
  x3 = XEXP (x2, 1);
  if (symbolic_operand (x3, SImode))
    {
      ro[2] = x3;
      if (flag_pic && operands[1] == pic_offset_table_rtx)
	return 54;
      }
  goto ret0;

  L13:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L14;
    }
  goto ret0;

  L14:
  x2 = XEXP (x1, 1);
  if (arith11_operand (x2, SImode))
    {
      ro[2] = x2;
      return 15;
    }
  goto ret0;
 ret0: return -1;
}

int
recog_2 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  int tem;

  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode && GET_CODE (x1) == MEM && 1)
    goto L219;
  L286:
  if (pnum_clobbers != 0 && pic_operand (x1, SImode))
    {
      ro[1] = x1;
      *pnum_clobbers = 1;
      return 62;
    }
  L289:
  switch (GET_MODE (x1))
    {
    case SImode:
      switch (GET_CODE (x1))
	{
	case HIGH:
	  goto L290;
	case PLUS:
	  goto L613;
	case LO_SUM:
	  goto L314;
	case ZERO_EXTEND:
	  goto L532;
	case SIGN_EXTEND:
	  goto L544;
	case FIX:
	  goto L588;
	case MINUS:
	  goto L647;
	case AND:
	  goto L791;
	case IOR:
	  goto L947;
	case XOR:
	  goto L817;
	case NEG:
	  goto L826;
	case NOT:
	  goto L834;
	case LSHIFTRT:
	  goto L902;
	case ASHIFT:
	  goto L928;
	case ASHIFTRT:
	  goto L965;
	case ROTATERT:
	  goto L982;
	case ROTATE:
	  goto L987;
	case ZERO_EXTRACT:
	  goto L1095;
	case SIGN_EXTRACT:
	  goto L1107;
	}
    }
  L991:
  if (plus_xor_ior_operator (x1, SImode))
    {
      ro[5] = x1;
      goto L992;
    }
  goto ret0;

  L219:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L220;
  goto L286;

  L220:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != SImode)
    {
      goto L286;
    }
  switch (GET_CODE (x3))
    {
    case MULT:
      goto L221;
    case PLUS:
      goto L229;
    }
  goto L286;

  L221:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L222;
    }
  goto L286;

  L222:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 4 && 1)
    goto L223;
  goto L286;

  L223:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      if (! TARGET_DISABLE_INDEXING)
	return 56;
      }
  goto L286;

  L229:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == MULT && 1)
    goto L230;
  goto L286;

  L230:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, SImode))
    {
      ro[1] = x5;
      goto L231;
    }
  goto L286;

  L231:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 4 && 1)
    goto L232;
  goto L286;

  L232:
  x4 = XEXP (x3, 1);
  if (register_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L233;
    }
  goto L286;

  L233:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[3] = x3;
      if (! TARGET_DISABLE_INDEXING && reload_in_progress)
	return 57;
      }
  goto L286;

  L290:
  x2 = XEXP (x1, 0);
  ro[1] = x2;
  if (symbolic_operand (operands[1], Pmode)
   && ! function_label_operand (operands[1])
   && ! read_only_operand (operands[1]))
    return 63;
  L300:
  if (function_label_operand (x2, SImode))
    goto L305;
  L310:
  ro[1] = x2;
  if (check_pic (1) && !is_function_label_plus_const (operands[1]))
    return 67;
  goto L991;

  L305:
  ro[1] = x2;
  if (!TARGET_PORTABLE_RUNTIME)
    return 65;
  L306:
  ro[1] = x2;
  if (TARGET_PORTABLE_RUNTIME)
    return 66;
  goto L310;

  L613:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode)
    {
      goto L991;
    }
  switch (GET_CODE (x2))
    {
    case NOT:
      goto L614;
    case MULT:
      goto L913;
    case PLUS:
      goto L920;
    case SUBREG:
    case REG:
      if (register_operand (x2, SImode))
	{
	  ro[1] = x2;
	  goto L295;
	}
    }
  goto L991;

  L614:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L615;
    }
  goto L991;

  L615:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[2] = x2;
      return 131;
    }
  goto L991;

  L913:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L914;
    }
  goto L991;

  L914:
  x3 = XEXP (x2, 1);
  if (shadd_operand (x3, SImode))
    {
      ro[3] = x3;
      goto L915;
    }
  goto L991;

  L915:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      return 183;
    }
  goto L991;

  L920:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == MULT && 1)
    goto L921;
  goto L991;

  L921:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L922;
    }
  goto L991;

  L922:
  x4 = XEXP (x3, 1);
  if (shadd_operand (x4, SImode))
    {
      ro[4] = x4;
      goto L923;
    }
  goto L991;

  L923:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L924;
    }
  goto L991;

  L924:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[3] = x2;
      if (reload_in_progress)
	return 184;
      }
  goto L991;

  L295:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == HIGH && 1)
    goto L296;
  L638:
  if (arith_operand (x2, SImode))
    {
      ro[2] = x2;
      return 134;
    }
  goto L991;

  L296:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[2] = x3;
      if (reload_completed)
	return 64;
      }
  goto L638;

  L314:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L315;
    }
  goto L991;

  L315:
  x2 = XEXP (x1, 1);
  if (function_label_operand (x2, SImode))
    goto L321;
  L327:
  if (immediate_operand (x2, SImode))
    {
      ro[2] = x2;
      if (!is_function_label_plus_const (operands[2]))
	return 70;
      }
  goto L991;

  L321:
  ro[2] = x2;
  if (!TARGET_PORTABLE_RUNTIME)
    return 68;
  L322:
  ro[2] = x2;
  if (TARGET_PORTABLE_RUNTIME)
    return 69;
  goto L327;

  L532:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case HImode:
      if (reg_or_nonsymb_mem_operand (x2, HImode))
	{
	  ro[1] = x2;
	  return 110;
	}
      break;
    case QImode:
      if (reg_or_nonsymb_mem_operand (x2, QImode))
	{
	  ro[1] = x2;
	  return 112;
	}
    }
  goto L991;

  L544:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case HImode:
      if (register_operand (x2, HImode))
	{
	  ro[1] = x2;
	  return 113;
	}
      break;
    case QImode:
      if (register_operand (x2, QImode))
	{
	  ro[1] = x2;
	  return 115;
	}
    }
  goto L991;

  L588:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != FIX)
    {
    goto L991;
    }
  switch (GET_MODE (x2))
    {
    case SFmode:
      goto L589;
    case DFmode:
      goto L594;
    }
  goto L991;

  L589:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SFmode))
    {
      ro[1] = x3;
      return 126;
    }
  goto L991;

  L594:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DFmode))
    {
      ro[1] = x3;
      return 127;
    }
  goto L991;

  L647:
  x2 = XEXP (x1, 0);
  if (arith11_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L648;
    }
  goto L991;

  L648:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[2] = x2;
      return 136;
    }
  goto L991;

  L791:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode)
    {
      goto L991;
    }
  switch (GET_CODE (x2))
    {
    case NOT:
      goto L792;
    case ROTATE:
      goto L957;
    case ASHIFT:
      goto L1011;
    case SUBREG:
    case REG:
      if (register_operand (x2, SImode))
	{
	  ro[1] = x2;
	  goto L781;
	}
    }
  goto L991;

  L792:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L793;
    }
  goto L991;

  L793:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[2] = x2;
      return 153;
    }
  goto L991;

  L957:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[1] = x3;
      goto L958;
    }
  goto L991;

  L958:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == MINUS && 1)
    goto L959;
  goto L991;

  L959:
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 31 && 1)
    goto L960;
  goto L991;

  L960:
  x4 = XEXP (x3, 1);
  if (register_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L961;
    }
  goto L991;

  L961:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[3] = x2;
      if (INTVAL (operands[1]) == -2)
	return 190;
      }
  goto L991;

  L1011:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L1012;
    }
  goto L991;

  L1012:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[2] = x3;
      goto L1013;
    }
  goto L991;

  L1013:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[3] = x2;
      if (exact_log2 (1 + (INTVAL (operands[3]) >> (INTVAL (operands[2]) & 31))) >= 0)
	return 199;
      }
  goto L991;

  L781:
  x2 = XEXP (x1, 1);
  if (and_operand (x2, SImode))
    {
      ro[2] = x2;
      return 151;
    }
  goto L991;

  L947:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode)
    {
      goto L991;
    }
  if (GET_CODE (x2) == ASHIFT && 1)
    goto L948;
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L803;
    }
  goto L991;

  L948:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[1] = x3;
      goto L949;
    }
  goto L991;

  L949:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == MINUS && 1)
    goto L950;
  goto L991;

  L950:
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 31 && 1)
    goto L951;
  goto L991;

  L951:
  x4 = XEXP (x3, 1);
  if (register_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L952;
    }
  goto L991;

  L952:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[3] = x2;
      if (exact_log2 (INTVAL (operands[1]) + 1) >= 0)
	return 189;
      }
  goto L991;

  L803:
  x2 = XEXP (x1, 1);
  if (ior_operand (x2, SImode))
    {
      ro[2] = x2;
      return 157;
    }
  L808:
  if (register_operand (x2, SImode))
    {
      ro[2] = x2;
      return 158;
    }
  goto L991;

  L817:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L818;
    }
  goto L991;

  L818:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[2] = x2;
      return 161;
    }
  goto L991;

  L826:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      return 163;
    }
  goto L991;

  L834:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      return 166;
    }
  goto L991;

  L902:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode)
    {
      goto L991;
    }
  if (memory_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L903;
    }
  L977:
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L978;
    }
  goto L991;

  L903:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != CONST_INT)
    {
      x2 = XEXP (x1, 0);
    goto L977;
    }
  if (XWINT (x2, 0) == 24 && 1)
    return 181;
  if (XWINT (x2, 0) == 16 && 1)
    return 182;
  x2 = XEXP (x1, 0);
  goto L977;

  L978:
  x2 = XEXP (x1, 1);
  if (arith32_operand (x2, SImode))
    {
      ro[2] = x2;
      return 194;
    }
  goto L991;

  L928:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L929;
    }
  L933:
  if (arith5_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L934;
    }
  L940:
  if (lhs_lshift_cint_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L941;
    }
  goto L991;

  L929:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[2] = x2;
      return 186;
    }
  x2 = XEXP (x1, 0);
  goto L933;

  L934:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == MINUS && 1)
    goto L935;
  x2 = XEXP (x1, 0);
  goto L940;

  L935:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 31 && 1)
    goto L936;
  x2 = XEXP (x1, 0);
  goto L940;

  L936:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      return 187;
    }
  x2 = XEXP (x1, 0);
  goto L940;

  L941:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == MINUS && 1)
    goto L942;
  goto L991;

  L942:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 31 && 1)
    goto L943;
  goto L991;

  L943:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      return 188;
    }
  goto L991;

  L965:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L971;
    }
  goto L991;

  L971:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case MINUS:
      if (GET_MODE (x2) == SImode && 1)
	goto L972;
      break;
    case CONST_INT:
      ro[2] = x2;
      return 192;
    }
  goto L991;

  L972:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 31 && 1)
    goto L973;
  goto L991;

  L973:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      return 193;
    }
  goto L991;

  L982:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L983;
    }
  goto L991;

  L983:
  x2 = XEXP (x1, 1);
  if (arith32_operand (x2, SImode))
    {
      ro[2] = x2;
      return 195;
    }
  goto L991;

  L987:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L988;
    }
  goto L991;

  L988:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[2] = x2;
      return 196;
    }
  goto L991;

  L1095:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L1096;
    }
  goto L991;

  L1096:
  x2 = XEXP (x1, 1);
  if (uint5_operand (x2, SImode))
    {
      ro[2] = x2;
      goto L1097;
    }
  L1102:
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 1 && 1)
    goto L1103;
  goto L991;

  L1097:
  x2 = XEXP (x1, 2);
  if (uint5_operand (x2, SImode))
    {
      ro[3] = x2;
      return 218;
    }
  x2 = XEXP (x1, 1);
  goto L1102;

  L1103:
  x2 = XEXP (x1, 2);
  if (register_operand (x2, SImode))
    {
      ro[3] = x2;
      return 219;
    }
  goto L991;

  L1107:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L1108;
    }
  goto L991;

  L1108:
  x2 = XEXP (x1, 1);
  if (uint5_operand (x2, SImode))
    {
      ro[2] = x2;
      goto L1109;
    }
  L1114:
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 1 && 1)
    goto L1115;
  goto L991;

  L1109:
  x2 = XEXP (x1, 2);
  if (uint5_operand (x2, SImode))
    {
      ro[3] = x2;
      return 220;
    }
  x2 = XEXP (x1, 1);
  goto L1114;

  L1115:
  x2 = XEXP (x1, 2);
  if (register_operand (x2, SImode))
    {
      ro[3] = x2;
      return 221;
    }
  goto L991;

  L992:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode)
    goto ret0;
  switch (GET_CODE (x2))
    {
    case ASHIFT:
      goto L993;
    case LSHIFTRT:
      goto L1002;
    }
  goto ret0;

  L993:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L994;
    }
  goto ret0;

  L994:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[3] = x3;
      goto L995;
    }
  goto ret0;

  L995:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == LSHIFTRT && 1)
    goto L996;
  goto ret0;

  L996:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L997;
    }
  goto ret0;

  L997:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[4] = x3;
      if (INTVAL (operands[3]) + INTVAL (operands[4]) == 32)
	return 197;
      }
  goto ret0;

  L1002:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L1003;
    }
  goto ret0;

  L1003:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[4] = x3;
      goto L1004;
    }
  goto ret0;

  L1004:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == ASHIFT && 1)
    goto L1005;
  goto ret0;

  L1005:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L1006;
    }
  goto ret0;

  L1006:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[3] = x3;
      if (INTVAL (operands[3]) + INTVAL (operands[4]) == 32)
	return 198;
      }
  goto ret0;
 ret0: return -1;
}

int
recog_3 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  int tem;

  x1 = XEXP (x0, 0);
  switch (GET_MODE (x1))
    {
    case CCFPmode:
      if (GET_CODE (x1) == REG && XINT (x1, 0) == 0 && 1)
	goto L2;
      break;
    case SImode:
      if (register_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L17;
	}
    }
  if (GET_CODE (x1) == PC && 1)
    goto L151;
  L214:
  switch (GET_MODE (x1))
    {
    case SImode:
      if (reg_or_nonsymb_mem_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L215;
	}
    L217:
      if (register_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L218;
	}
      break;
    case HImode:
      if (reg_or_nonsymb_mem_operand (x1, HImode))
	{
	  ro[0] = x1;
	  goto L336;
	}
    L338:
      if (register_operand (x1, HImode))
	{
	  ro[0] = x1;
	  goto L339;
	}
      break;
    case QImode:
      if (reg_or_nonsymb_mem_operand (x1, QImode))
	{
	  ro[0] = x1;
	  goto L390;
	}
      break;
    case DFmode:
      if (general_operand (x1, DFmode))
	{
	  ro[0] = x1;
	  goto L435;
	}
    L437:
      if (reg_or_nonsymb_mem_operand (x1, DFmode))
	{
	  ro[0] = x1;
	  goto L438;
	}
    L440:
      if (register_operand (x1, DFmode))
	{
	  ro[0] = x1;
	  goto L441;
	}
    L570:
      if (general_operand (x1, DFmode))
	{
	  ro[0] = x1;
	  goto L571;
	}
    L458:
      if (GET_CODE (x1) == MEM && 1)
	goto L459;
      break;
    case DImode:
      if (register_operand (x1, DImode))
	{
	  ro[0] = x1;
	  goto L477;
	}
    L480:
      if (reg_or_nonsymb_mem_operand (x1, DImode))
	{
	  ro[0] = x1;
	  goto L481;
	}
    L650:
      if (nonimmediate_operand (x1, DImode))
	{
	  ro[0] = x1;
	  goto L651;
	}
      break;
    case SFmode:
      if (general_operand (x1, SFmode))
	{
	  ro[0] = x1;
	  goto L489;
	}
    L491:
      if (reg_or_nonsymb_mem_operand (x1, SFmode))
	{
	  ro[0] = x1;
	  goto L492;
	}
    L494:
      if (register_operand (x1, SFmode))
	{
	  ro[0] = x1;
	  goto L495;
	}
    L562:
      if (general_operand (x1, SFmode))
	{
	  ro[0] = x1;
	  goto L563;
	}
    L512:
      switch (GET_CODE (x1))
	{
	case MEM:
	  goto L513;
	}
    }
  switch (GET_CODE (x1))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x1) == SImode && 1)
	goto L1118;
    }
  L1027:
  if (GET_CODE (x1) == PC && 1)
    goto L1091;
  goto ret0;

  L2:
  x1 = XEXP (x0, 1);
  if (comparison_operator (x1, CCFPmode))
    {
      ro[2] = x1;
      goto L3;
    }
  goto ret0;

  L3:
  x2 = XEXP (x1, 0);
  if (reg_or_0_operand (x2, SFmode))
    {
      ro[0] = x2;
      goto L4;
    }
  L8:
  if (reg_or_0_operand (x2, DFmode))
    {
      ro[0] = x2;
      goto L9;
    }
  goto ret0;

  L4:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, SFmode))
    {
      ro[1] = x2;
      return 3;
    }
  x2 = XEXP (x1, 0);
  goto L8;

  L9:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DFmode))
    {
      ro[1] = x2;
      return 4;
    }
  goto ret0;
 L17:
  tem = recog_1 (x0, insn, pnum_clobbers);
  if (tem >= 0) return tem;
  x1 = XEXP (x0, 0);
  goto L214;

  L151:
  x1 = XEXP (x0, 1);
  if (GET_CODE (x1) == IF_THEN_ELSE && 1)
    goto L152;
  x1 = XEXP (x0, 0);
  goto L214;

  L152:
  x2 = XEXP (x1, 0);
  if (comparison_operator (x2, VOIDmode))
    {
      ro[3] = x2;
      goto L153;
    }
  L170:
  switch (GET_CODE (x2))
    {
    case NE:
      goto L171;
    case EQ:
      goto L182;
    }
  x1 = XEXP (x0, 0);
  goto L214;

  L153:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L154;
    }
  goto L170;

  L154:
  x3 = XEXP (x2, 1);
  if (arith5_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L155;
    }
  goto L170;

  L155:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L156;
    case PC:
      goto L165;
    }
  x2 = XEXP (x1, 0);
  goto L170;

  L156:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L157;

  L157:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 45;
  x2 = XEXP (x1, 0);
  goto L170;

  L165:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L166;
  x2 = XEXP (x1, 0);
  goto L170;

  L166:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 46;

  L171:
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case SImode:
      switch (GET_CODE (x3))
	{
	case ZERO_EXTRACT:
	  goto L172;
	}
      break;
    case CCFPmode:
      if (GET_CODE (x3) == REG && XINT (x3, 0) == 0 && 1)
	goto L194;
    }
  x1 = XEXP (x0, 0);
  goto L214;

  L172:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[0] = x4;
      goto L173;
    }
  x1 = XEXP (x0, 0);
  goto L214;

  L173:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 1 && 1)
    goto L174;
  x1 = XEXP (x0, 0);
  goto L214;

  L174:
  x4 = XEXP (x3, 2);
  if (uint5_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L175;
    }
  x1 = XEXP (x0, 0);
  goto L214;

  L175:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L176;
  x1 = XEXP (x0, 0);
  goto L214;

  L176:
  x2 = XEXP (x1, 1);
  if (pc_or_label_operand (x2, VOIDmode))
    {
      ro[2] = x2;
      goto L177;
    }
  x1 = XEXP (x0, 0);
  goto L214;

  L177:
  x2 = XEXP (x1, 2);
  if (pc_or_label_operand (x2, VOIDmode))
    {
      ro[3] = x2;
      return 47;
    }
  x1 = XEXP (x0, 0);
  goto L214;

  L194:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L195;
  x1 = XEXP (x0, 0);
  goto L214;

  L195:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L196;
    case PC:
      goto L205;
    }
  x1 = XEXP (x0, 0);
  goto L214;

  L196:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L197;

  L197:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 49;
  x1 = XEXP (x0, 0);
  goto L214;

  L205:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L206;
  x1 = XEXP (x0, 0);
  goto L214;

  L206:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 50;

  L182:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == ZERO_EXTRACT && 1)
    goto L183;
  x1 = XEXP (x0, 0);
  goto L214;

  L183:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[0] = x4;
      goto L184;
    }
  x1 = XEXP (x0, 0);
  goto L214;

  L184:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 1 && 1)
    goto L185;
  x1 = XEXP (x0, 0);
  goto L214;

  L185:
  x4 = XEXP (x3, 2);
  if (uint5_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L186;
    }
  x1 = XEXP (x0, 0);
  goto L214;

  L186:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L187;
  x1 = XEXP (x0, 0);
  goto L214;

  L187:
  x2 = XEXP (x1, 1);
  if (pc_or_label_operand (x2, VOIDmode))
    {
      ro[2] = x2;
      goto L188;
    }
  x1 = XEXP (x0, 0);
  goto L214;

  L188:
  x2 = XEXP (x1, 2);
  if (pc_or_label_operand (x2, VOIDmode))
    {
      ro[3] = x2;
      return 48;
    }
  x1 = XEXP (x0, 0);
  goto L214;

  L215:
  x1 = XEXP (x0, 1);
  if (move_operand (x1, SImode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], SImode)
   || reg_or_0_operand (operands[1], SImode))
	return 55;
      }
  x1 = XEXP (x0, 0);
  goto L217;
 L218:
  return recog_2 (x0, insn, pnum_clobbers);

  L336:
  x1 = XEXP (x0, 1);
  if (move_operand (x1, HImode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], HImode)
   || reg_or_0_operand (operands[1], HImode))
	return 73;
      }
  x1 = XEXP (x0, 0);
  goto L338;

  L339:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != HImode)
    goto ret0;
  switch (GET_CODE (x1))
    {
    case MEM:
      goto L340;
    case HIGH:
      goto L382;
    case LO_SUM:
      goto L386;
    case ZERO_EXTEND:
      goto L536;
    case SIGN_EXTEND:
      goto L548;
    }
  goto ret0;

  L340:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L341;
  goto ret0;

  L341:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != SImode)
    goto ret0;
  switch (GET_CODE (x3))
    {
    case MULT:
      goto L342;
    case PLUS:
      goto L350;
    }
  goto ret0;

  L342:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L343;
    }
  goto ret0;

  L343:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 2 && 1)
    goto L344;
  goto ret0;

  L344:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      if (! TARGET_DISABLE_INDEXING)
	return 74;
      }
  goto ret0;

  L350:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == MULT && 1)
    goto L351;
  goto ret0;

  L351:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, SImode))
    {
      ro[2] = x5;
      goto L352;
    }
  goto ret0;

  L352:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 2 && 1)
    goto L353;
  goto ret0;

  L353:
  x4 = XEXP (x3, 1);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L354;
    }
  goto ret0;

  L354:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[3] = x3;
      if (! TARGET_DISABLE_INDEXING && reload_in_progress)
	return 75;
      }
  goto ret0;

  L382:
  x2 = XEXP (x1, 0);
  ro[1] = x2;
  if (check_pic (1))
    return 78;
  goto ret0;

  L386:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, HImode))
    {
      ro[1] = x2;
      goto L387;
    }
  goto ret0;

  L387:
  x2 = XEXP (x1, 1);
  if (immediate_operand (x2, VOIDmode))
    {
      ro[2] = x2;
      return 79;
    }
  goto ret0;

  L536:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == QImode && reg_or_nonsymb_mem_operand (x2, QImode))
    {
      ro[1] = x2;
      return 111;
    }
  goto ret0;

  L548:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, QImode))
    {
      ro[1] = x2;
      return 114;
    }
  goto ret0;

  L390:
  x1 = XEXP (x0, 1);
  if (move_operand (x1, QImode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], QImode)
   || reg_or_0_operand (operands[1], QImode))
	return 81;
      }
  x1 = XEXP (x0, 0);
  goto L1027;

  L435:
  x1 = XEXP (x0, 1);
  ro[1] = x1;
  if (GET_CODE (operands[1]) == CONST_DOUBLE
   && operands[1] != CONST0_RTX (DFmode))
    return 86;
  x1 = XEXP (x0, 0);
  goto L437;

  L438:
  x1 = XEXP (x0, 1);
  if (reg_or_0_or_nonsymb_mem_operand (x1, DFmode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], DFmode)
   || reg_or_0_operand (operands[1], DFmode))
	return 90;
      }
  x1 = XEXP (x0, 0);
  goto L440;

  L441:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != DFmode)
    {
      x1 = XEXP (x0, 0);
      goto L570;
    }
  switch (GET_CODE (x1))
    {
    case MEM:
      goto L442;
    case FLOAT_EXTEND:
      goto L556;
    case PLUS:
      goto L838;
    case MINUS:
      goto L848;
    case MULT:
      goto L858;
    case DIV:
      goto L868;
    case NEG:
      goto L878;
    case ABS:
      goto L886;
    case SQRT:
      goto L894;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L442:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L443;
  x1 = XEXP (x0, 0);
  goto L570;

  L443:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != SImode)
    {
      x1 = XEXP (x0, 0);
      goto L570;
    }
  switch (GET_CODE (x3))
    {
    case MULT:
      goto L444;
    case PLUS:
      goto L452;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L444:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L445;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L445:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 8 && 1)
    goto L446;
  x1 = XEXP (x0, 0);
  goto L570;

  L446:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      if (! TARGET_DISABLE_INDEXING)
	return 91;
      }
  x1 = XEXP (x0, 0);
  goto L570;

  L452:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == MULT && 1)
    goto L453;
  x1 = XEXP (x0, 0);
  goto L570;

  L453:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, SImode))
    {
      ro[1] = x5;
      goto L454;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L454:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 8 && 1)
    goto L455;
  x1 = XEXP (x0, 0);
  goto L570;

  L455:
  x4 = XEXP (x3, 1);
  if (register_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L456;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L456:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[3] = x3;
      if (! TARGET_DISABLE_INDEXING && reload_in_progress)
	return 92;
      }
  x1 = XEXP (x0, 0);
  goto L570;

  L556:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      return 116;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L838:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L839;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L839:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DFmode))
    {
      ro[2] = x2;
      return 167;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L848:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L849;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L849:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DFmode))
    {
      ro[2] = x2;
      return 169;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L858:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L859;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L859:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DFmode))
    {
      ro[2] = x2;
      return 171;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L868:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L869;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L869:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DFmode))
    {
      ro[2] = x2;
      return 173;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L878:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      return 175;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L886:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      return 177;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L894:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      return 179;
    }
  x1 = XEXP (x0, 0);
  goto L570;

  L571:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == DFmode && GET_CODE (x1) == FLOAT && 1)
    goto L576;
  x1 = XEXP (x0, 0);
  goto L458;

  L576:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      if (register_operand (x2, SImode))
	{
	  ro[1] = x2;
	  return 121;
	}
      break;
    case DImode:
      if (register_operand (x2, DImode))
	{
	  ro[1] = x2;
	  if (TARGET_SNAKE)
	    return 125;
	  }
    }
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[1] = x2;
      return 120;
    }
  x1 = XEXP (x0, 0);
  goto L458;

  L459:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L460;
  goto ret0;

  L460:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != SImode)
    goto ret0;
  switch (GET_CODE (x3))
    {
    case MULT:
      goto L461;
    case PLUS:
      goto L469;
    }
  goto ret0;

  L461:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L462;
    }
  goto ret0;

  L462:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 8 && 1)
    goto L463;
  goto ret0;

  L463:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L464;
    }
  goto ret0;

  L464:
  x1 = XEXP (x0, 1);
  if (register_operand (x1, DFmode))
    {
      ro[0] = x1;
      if (! TARGET_DISABLE_INDEXING)
	return 93;
      }
  goto ret0;

  L469:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == MULT && 1)
    goto L470;
  goto ret0;

  L470:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, SImode))
    {
      ro[1] = x5;
      goto L471;
    }
  goto ret0;

  L471:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 8 && 1)
    goto L472;
  goto ret0;

  L472:
  x4 = XEXP (x3, 1);
  if (register_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L473;
    }
  goto ret0;

  L473:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[3] = x3;
      goto L474;
    }
  goto ret0;

  L474:
  x1 = XEXP (x0, 1);
  if (register_operand (x1, DFmode))
    {
      ro[0] = x1;
      if (! TARGET_DISABLE_INDEXING && reload_in_progress)
	return 94;
      }
  goto ret0;

  L477:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != DImode)
    {
      x1 = XEXP (x0, 0);
      goto L480;
    }
  switch (GET_CODE (x1))
    {
    case HIGH:
      goto L478;
    case LO_SUM:
      goto L485;
    case FIX:
      goto L598;
    case PLUS:
      goto L608;
    case MINUS:
      goto L642;
    case AND:
      goto L785;
    case IOR:
      goto L797;
    case XOR:
      goto L812;
    case NEG:
      goto L822;
    case NOT:
      goto L830;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L478:
  x2 = XEXP (x1, 0);
  ro[1] = x2;
  if (check_pic (1))
    return 98;
  x1 = XEXP (x0, 0);
  goto L480;

  L485:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L486;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L486:
  x2 = XEXP (x1, 1);
  if (immediate_operand (x2, DImode))
    {
      ro[2] = x2;
      return 100;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L598:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != FIX)
    {
      x1 = XEXP (x0, 0);
    goto L480;
    }
  switch (GET_MODE (x2))
    {
    case SFmode:
      goto L599;
    case DFmode:
      goto L604;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L599:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SFmode))
    {
      ro[1] = x3;
      if (TARGET_SNAKE)
	return 128;
      }
  x1 = XEXP (x0, 0);
  goto L480;

  L604:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DFmode))
    {
      ro[1] = x3;
      if (TARGET_SNAKE)
	return 129;
      }
  x1 = XEXP (x0, 0);
  goto L480;

  L608:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L609;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L609:
  x2 = XEXP (x1, 1);
  if (arith11_operand (x2, DImode))
    {
      ro[2] = x2;
      return 130;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L642:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L643;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L643:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DImode))
    {
      ro[2] = x2;
      return 135;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L785:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DImode)
    {
      x1 = XEXP (x0, 0);
      goto L480;
    }
  if (GET_CODE (x2) == NOT && 1)
    goto L786;
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L776;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L786:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L787;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L787:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DImode))
    {
      ro[2] = x2;
      return 152;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L776:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DImode))
    {
      ro[2] = x2;
      return 150;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L797:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L798;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L798:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DImode))
    {
      ro[2] = x2;
      return 155;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L812:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L813;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L813:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DImode))
    {
      ro[2] = x2;
      return 160;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L822:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      return 162;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L830:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      return 165;
    }
  x1 = XEXP (x0, 0);
  goto L480;

  L481:
  x1 = XEXP (x0, 1);
  if (general_operand (x1, DImode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], DImode)
   || reg_or_0_operand (operands[1], DImode))
	return 99;
      }
  x1 = XEXP (x0, 0);
  goto L650;

  L651:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == DImode && GET_CODE (x1) == MULT && 1)
    goto L652;
  goto ret0;

  L652:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == ZERO_EXTEND && 1)
    goto L653;
  goto ret0;

  L653:
  x3 = XEXP (x2, 0);
  if (nonimmediate_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L654;
    }
  goto ret0;

  L654:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == ZERO_EXTEND && 1)
    goto L655;
  L661:
  if (uint32_operand (x2, DImode))
    {
      ro[2] = x2;
      if (TARGET_SNAKE && ! TARGET_DISABLE_FPREGS)
	return 139;
      }
  goto ret0;

  L655:
  x3 = XEXP (x2, 0);
  if (nonimmediate_operand (x3, SImode))
    {
      ro[2] = x3;
      if (TARGET_SNAKE && ! TARGET_DISABLE_FPREGS)
	return 138;
      }
  goto L661;

  L489:
  x1 = XEXP (x0, 1);
  ro[1] = x1;
  if (GET_CODE (operands[1]) == CONST_DOUBLE
   && operands[1] != CONST0_RTX (SFmode))
    return 101;
  x1 = XEXP (x0, 0);
  goto L491;

  L492:
  x1 = XEXP (x0, 1);
  if (reg_or_0_or_nonsymb_mem_operand (x1, SFmode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], SFmode)
   || reg_or_0_operand (operands[1], SFmode))
	return 105;
      }
  x1 = XEXP (x0, 0);
  goto L494;

  L495:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != SFmode)
    {
      x1 = XEXP (x0, 0);
      goto L562;
    }
  switch (GET_CODE (x1))
    {
    case MEM:
      goto L496;
    case FLOAT_TRUNCATE:
      goto L560;
    case PLUS:
      goto L843;
    case MINUS:
      goto L853;
    case MULT:
      goto L863;
    case DIV:
      goto L873;
    case NEG:
      goto L882;
    case ABS:
      goto L890;
    case SQRT:
      goto L898;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L496:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L497;
  x1 = XEXP (x0, 0);
  goto L562;

  L497:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != SImode)
    {
      x1 = XEXP (x0, 0);
      goto L562;
    }
  switch (GET_CODE (x3))
    {
    case MULT:
      goto L498;
    case PLUS:
      goto L506;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L498:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L499;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L499:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 4 && 1)
    goto L500;
  x1 = XEXP (x0, 0);
  goto L562;

  L500:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      if (! TARGET_DISABLE_INDEXING)
	return 106;
      }
  x1 = XEXP (x0, 0);
  goto L562;

  L506:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == MULT && 1)
    goto L507;
  x1 = XEXP (x0, 0);
  goto L562;

  L507:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, SImode))
    {
      ro[1] = x5;
      goto L508;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L508:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 4 && 1)
    goto L509;
  x1 = XEXP (x0, 0);
  goto L562;

  L509:
  x4 = XEXP (x3, 1);
  if (register_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L510;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L510:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[3] = x3;
      if (! TARGET_DISABLE_INDEXING && reload_in_progress)
	return 107;
      }
  x1 = XEXP (x0, 0);
  goto L562;

  L560:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      return 117;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L843:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L844;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L844:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SFmode))
    {
      ro[2] = x2;
      return 168;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L853:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L854;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L854:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SFmode))
    {
      ro[2] = x2;
      return 170;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L863:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L864;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L864:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SFmode))
    {
      ro[2] = x2;
      return 172;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L873:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L874;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L874:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SFmode))
    {
      ro[2] = x2;
      return 174;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L882:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      return 176;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L890:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      return 178;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L898:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      return 180;
    }
  x1 = XEXP (x0, 0);
  goto L562;

  L563:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SFmode && GET_CODE (x1) == FLOAT && 1)
    goto L568;
  x1 = XEXP (x0, 0);
  goto L512;

  L568:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      if (register_operand (x2, SImode))
	{
	  ro[1] = x2;
	  return 119;
	}
      break;
    case DImode:
      if (register_operand (x2, DImode))
	{
	  ro[1] = x2;
	  if (TARGET_SNAKE)
	    return 124;
	  }
    }
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[1] = x2;
      return 118;
    }
  x1 = XEXP (x0, 0);
  goto L512;

  L513:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L514;
  goto ret0;

  L514:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != SImode)
    goto ret0;
  switch (GET_CODE (x3))
    {
    case MULT:
      goto L515;
    case PLUS:
      goto L523;
    }
  goto ret0;

  L515:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L516;
    }
  goto ret0;

  L516:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 4 && 1)
    goto L517;
  goto ret0;

  L517:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L518;
    }
  goto ret0;

  L518:
  x1 = XEXP (x0, 1);
  if (register_operand (x1, SFmode))
    {
      ro[0] = x1;
      if (! TARGET_DISABLE_INDEXING)
	return 108;
      }
  goto ret0;

  L523:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == MULT && 1)
    goto L524;
  goto ret0;

  L524:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, SImode))
    {
      ro[1] = x5;
      goto L525;
    }
  goto ret0;

  L525:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 4 && 1)
    goto L526;
  goto ret0;

  L526:
  x4 = XEXP (x3, 1);
  if (register_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L527;
    }
  goto ret0;

  L527:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[3] = x3;
      goto L528;
    }
  goto ret0;

  L528:
  x1 = XEXP (x0, 1);
  if (register_operand (x1, SFmode))
    {
      ro[0] = x1;
      if (! TARGET_DISABLE_INDEXING && reload_in_progress)
	return 109;
      }
  goto ret0;

  L1118:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L1119;
    }
  goto ret0;

  L1119:
  x2 = XEXP (x1, 1);
  if (uint5_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L1120;
    }
  goto ret0;

  L1120:
  x2 = XEXP (x1, 2);
  if (uint5_operand (x2, SImode))
    {
      ro[2] = x2;
      goto L1121;
    }
  goto ret0;

  L1121:
  x1 = XEXP (x0, 1);
  if (arith5_operand (x1, SImode))
    {
      ro[3] = x1;
      return 222;
    }
  L1127:
  if (GET_CODE (x1) == CONST_INT && 1)
    {
      ro[3] = x1;
      if ((INTVAL (operands[3]) & 0x10) != 0 &&
   (~INTVAL (operands[3]) & (1L << INTVAL (operands[1])) - 1 & ~0xf) == 0)
	return 223;
      }
  goto ret0;

  L1091:
  x1 = XEXP (x0, 1);
  if (register_operand (x1, SImode))
    {
      ro[0] = x1;
      return 217;
    }
  if (GET_CODE (x1) == LABEL_REF && 1)
    goto L1029;
  goto ret0;

  L1029:
  x2 = XEXP (x1, 0);
  ro[0] = x2;
  return 206;
 ret0: return -1;
}

int
recog_4 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  int tem;

  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == LEU && 1)
    goto L1035;
  L1151:
  if (comparison_operator (x3, VOIDmode))
    {
      ro[2] = x3;
      goto L1152;
    }
  L1185:
  if (eq_neq_comparison_operator (x3, VOIDmode))
    {
      ro[2] = x3;
      goto L1186;
    }
  L1200:
  if (movb_comparison_operator (x3, VOIDmode))
    {
      ro[2] = x3;
      goto L1201;
    }
  goto ret0;

  L1035:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[0] = x4;
      goto L1036;
    }
  goto L1151;

  L1036:
  x4 = XEXP (x3, 1);
  if (arith11_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L1037;
    }
  goto L1151;

  L1037:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == PLUS && 1)
    goto L1038;
  x3 = XEXP (x2, 0);
  goto L1151;

  L1038:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == MEM && 1)
    goto L1039;
  x3 = XEXP (x2, 0);
  goto L1151;

  L1039:
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) == SImode && GET_CODE (x5) == PLUS && 1)
    goto L1040;
  x3 = XEXP (x2, 0);
  goto L1151;

  L1040:
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) == PC && 1)
    goto L1041;
  x3 = XEXP (x2, 0);
  goto L1151;

  L1041:
  x6 = XEXP (x5, 1);
  if (rtx_equal_p (x6, ro[0]) && 1)
    goto L1042;
  x3 = XEXP (x2, 0);
  goto L1151;

  L1042:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == LABEL_REF && 1)
    goto L1043;
  x3 = XEXP (x2, 0);
  goto L1151;

  L1043:
  x5 = XEXP (x4, 0);
  ro[2] = x5;
  goto L1044;

  L1044:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L1045;
  x3 = XEXP (x2, 0);
  goto L1151;

  L1045:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L1046;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1151;

  L1046:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L1047;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1151;

  L1047:
  x3 = XEXP (x2, 0);
  ro[3] = x3;
  return 208;

  L1152:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == PLUS && 1)
    goto L1153;
  goto L1185;

  L1153:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, SImode))
    {
      ro[0] = x5;
      goto L1154;
    }
  goto L1185;

  L1154:
  x5 = XEXP (x4, 1);
  if (int5_operand (x5, SImode))
    {
      ro[1] = x5;
      goto L1155;
    }
  goto L1185;

  L1155:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L1156;
  goto L1185;

  L1156:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L1157;
  x3 = XEXP (x2, 0);
  goto L1185;

  L1157:
  x4 = XEXP (x3, 0);
  ro[3] = x4;
  goto L1158;

  L1158:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L1159;
  x3 = XEXP (x2, 0);
  goto L1185;

  L1159:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L1160;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1185;

  L1160:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[0]) && 1)
    goto L1161;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1185;

  L1161:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L1162;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1185;

  L1162:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[0]) && 1)
    goto L1163;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1185;

  L1163:
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, ro[1]) && pnum_clobbers != 0 && 1)
    {
      *pnum_clobbers = 1;
      return 224;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1185;

  L1186:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[0] = x4;
      goto L1187;
    }
  goto L1200;

  L1187:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && 1)
    {
      ro[5] = x4;
      goto L1188;
    }
  goto L1200;

  L1188:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L1189;
  x3 = XEXP (x2, 0);
  goto L1200;

  L1189:
  x4 = XEXP (x3, 0);
  ro[3] = x4;
  goto L1190;

  L1190:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L1191;
  x3 = XEXP (x2, 0);
  goto L1200;

  L1191:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L1192;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1200;

  L1192:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[0]) && 1)
    goto L1193;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1200;

  L1193:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L1194;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1200;

  L1194:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[0]) && 1)
    goto L1195;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1200;

  L1195:
  x3 = XEXP (x2, 1);
  if (pnum_clobbers != 0 && int5_operand (x3, SImode))
    {
      ro[1] = x3;
      if (INTVAL (operands[5]) == - INTVAL (operands[1]))
	{
	  *pnum_clobbers = 1;
	  return 225;
	}
      }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1200;

  L1201:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L1202;
    }
  goto ret0;

  L1202:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L1203;
  goto ret0;

  L1203:
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      goto L1204;
    case PC:
      goto L1217;
    }
  goto ret0;

  L1204:
  x4 = XEXP (x3, 0);
  ro[3] = x4;
  goto L1205;

  L1205:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L1206;
  goto ret0;

  L1206:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L1207;
  goto ret0;

  L1207:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L1208;
    }
  goto ret0;

  L1208:
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, ro[1]) && 1)
    return 226;
  goto ret0;

  L1217:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L1218;
  goto ret0;

  L1218:
  x4 = XEXP (x3, 0);
  ro[3] = x4;
  goto L1219;

  L1219:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L1220;
  goto ret0;

  L1220:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L1221;
    }
  goto ret0;

  L1221:
  x2 = XEXP (x1, 1);
  if (rtx_equal_p (x2, ro[1]) && 1)
    return 227;
  goto ret0;
 ret0: return -1;
}

int
recog_5 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  int tem;

  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      switch (GET_CODE (x2))
	{
	case MEM:
	  goto L249;
	case REG:
	  if (XINT (x2, 0) == 29 && 1)
	    goto L679;
	}
    L236:
      if (register_operand (x2, SImode))
	{
	  ro[3] = x2;
	  goto L237;
	}
    L280:
      if (register_operand (x2, SImode))
	{
	  ro[0] = x2;
	  goto L281;
	}
      break;
    case HImode:
      if (GET_CODE (x2) == MEM && 1)
	goto L370;
      if (register_operand (x2, HImode))
	{
	  ro[3] = x2;
	  goto L358;
	}
      break;
    case QImode:
      if (GET_CODE (x2) == MEM && 1)
	goto L406;
      if (register_operand (x2, QImode))
	{
	  ro[3] = x2;
	  goto L394;
	}
    }
  if (GET_CODE (x2) == PC && 1)
    goto L1033;
  goto ret0;

  L249:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != SImode)
    goto ret0;
  if (GET_CODE (x3) == PLUS && 1)
    goto L250;
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L272;
    }
  goto ret0;

  L250:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L251;
    }
  goto ret0;

  L251:
  x4 = XEXP (x3, 1);
  if (pre_cint_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L252;
    }
  goto ret0;

  L252:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, SImode))
    {
      ro[3] = x2;
      goto L253;
    }
  goto ret0;

  L253:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L254;
  goto ret0;

  L254:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L255;
    }
  goto ret0;

  L255:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L256;
  goto ret0;

  L256:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[1]) && 1)
    goto L257;
  goto ret0;

  L257:
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, ro[2]) && 1)
    return 59;
  goto ret0;

  L272:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, SImode))
    {
      ro[3] = x2;
      goto L273;
    }
  goto ret0;

  L273:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L274;
  goto ret0;

  L274:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L275;
    }
  goto ret0;

  L275:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L276;
  goto ret0;

  L276:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[1]) && 1)
    goto L277;
  goto ret0;

  L277:
  x3 = XEXP (x2, 1);
  if (post_cint_operand (x3, SImode))
    {
      ro[2] = x3;
      return 61;
    }
  goto ret0;

  L679:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != SImode)
    {
      x2 = XEXP (x1, 0);
      goto L236;
    }
  switch (GET_CODE (x2))
    {
    case MULT:
      goto L680;
    case DIV:
      goto L702;
    case UDIV:
      goto L724;
    case MOD:
      goto L746;
    case UMOD:
      goto L768;
    }
  x2 = XEXP (x1, 0);
  goto L236;

  L680:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 26 && 1)
    goto L681;
  x2 = XEXP (x1, 0);
  goto L236;

  L681:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 25 && 1)
    goto L682;
  x2 = XEXP (x1, 0);
  goto L236;

  L682:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L683;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L236;

  L683:
  x2 = XEXP (x1, 0);
  if (pnum_clobbers != 0 && register_operand (x2, SImode))
    {
      ro[0] = x2;
      *pnum_clobbers = 3;
      return 140;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L236;

  L702:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 26 && 1)
    goto L703;
  x2 = XEXP (x1, 0);
  goto L236;

  L703:
  x3 = XEXP (x2, 1);
  if (div_operand (x3, SImode))
    {
      ro[0] = x3;
      goto L704;
    }
  x2 = XEXP (x1, 0);
  goto L236;

  L704:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L705;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L236;

  L705:
  x2 = XEXP (x1, 0);
  if (pnum_clobbers != 0 && register_operand (x2, SImode))
    {
      ro[1] = x2;
      *pnum_clobbers = 3;
      return 142;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L236;

  L724:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 26 && 1)
    goto L725;
  x2 = XEXP (x1, 0);
  goto L236;

  L725:
  x3 = XEXP (x2, 1);
  if (div_operand (x3, SImode))
    {
      ro[0] = x3;
      goto L726;
    }
  x2 = XEXP (x1, 0);
  goto L236;

  L726:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L727;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L236;

  L727:
  x2 = XEXP (x1, 0);
  if (pnum_clobbers != 0 && register_operand (x2, SImode))
    {
      ro[1] = x2;
      *pnum_clobbers = 3;
      return 144;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L236;

  L746:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 26 && 1)
    goto L747;
  x2 = XEXP (x1, 0);
  goto L236;

  L747:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 25 && 1)
    goto L748;
  x2 = XEXP (x1, 0);
  goto L236;

  L748:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L749;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L236;

  L749:
  x2 = XEXP (x1, 0);
  if (pnum_clobbers != 0 && register_operand (x2, SImode))
    {
      ro[0] = x2;
      *pnum_clobbers = 3;
      return 146;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L236;

  L768:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 26 && 1)
    goto L769;
  x2 = XEXP (x1, 0);
  goto L236;

  L769:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 25 && 1)
    goto L770;
  x2 = XEXP (x1, 0);
  goto L236;

  L770:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L771;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L236;

  L771:
  x2 = XEXP (x1, 0);
  if (pnum_clobbers != 0 && register_operand (x2, SImode))
    {
      ro[0] = x2;
      *pnum_clobbers = 3;
      return 148;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L236;

  L237:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == MEM && 1)
    goto L238;
  x2 = XEXP (x1, 0);
  goto L280;

  L238:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != SImode)
    {
      x2 = XEXP (x1, 0);
      goto L280;
    }
  if (GET_CODE (x3) == PLUS && 1)
    goto L239;
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L263;
    }
  x2 = XEXP (x1, 0);
  goto L280;

  L239:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L240;
    }
  x2 = XEXP (x1, 0);
  goto L280;

  L240:
  x4 = XEXP (x3, 1);
  if (pre_cint_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L241;
    }
  x2 = XEXP (x1, 0);
  goto L280;

  L241:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L242;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L280;

  L242:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L243;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L280;

  L243:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L244;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L280;

  L244:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[1]) && 1)
    goto L245;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L280;

  L245:
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, ro[2]) && 1)
    return 58;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L280;

  L263:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L264;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L280;

  L264:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L265;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L280;

  L265:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L266;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L280;

  L266:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[1]) && 1)
    goto L267;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L280;

  L267:
  x3 = XEXP (x2, 1);
  if (post_cint_operand (x3, SImode))
    {
      ro[2] = x3;
      return 60;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L280;

  L281:
  x2 = XEXP (x1, 1);
  if (pic_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L282;
    }
  goto ret0;

  L282:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L283;
  goto ret0;

  L283:
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      ro[2] = x2;
      return 62;
    }
  goto ret0;

  L370:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == PLUS && 1)
    goto L371;
  goto ret0;

  L371:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L372;
    }
  goto ret0;

  L372:
  x4 = XEXP (x3, 1);
  if (int5_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L373;
    }
  goto ret0;

  L373:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, HImode))
    {
      ro[3] = x2;
      goto L374;
    }
  goto ret0;

  L374:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L375;
  goto ret0;

  L375:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L376;
    }
  goto ret0;

  L376:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L377;
  goto ret0;

  L377:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[1]) && 1)
    goto L378;
  goto ret0;

  L378:
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, ro[2]) && 1)
    return 77;
  goto ret0;

  L358:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == HImode && GET_CODE (x2) == MEM && 1)
    goto L359;
  goto ret0;

  L359:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == PLUS && 1)
    goto L360;
  goto ret0;

  L360:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L361;
    }
  goto ret0;

  L361:
  x4 = XEXP (x3, 1);
  if (int5_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L362;
    }
  goto ret0;

  L362:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L363;
  goto ret0;

  L363:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L364;
    }
  goto ret0;

  L364:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L365;
  goto ret0;

  L365:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[1]) && 1)
    goto L366;
  goto ret0;

  L366:
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, ro[2]) && 1)
    return 76;
  goto ret0;

  L406:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == PLUS && 1)
    goto L407;
  goto ret0;

  L407:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L408;
    }
  goto ret0;

  L408:
  x4 = XEXP (x3, 1);
  if (int5_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L409;
    }
  goto ret0;

  L409:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, QImode))
    {
      ro[3] = x2;
      goto L410;
    }
  goto ret0;

  L410:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L411;
  goto ret0;

  L411:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L412;
    }
  goto ret0;

  L412:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L413;
  goto ret0;

  L413:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[1]) && 1)
    goto L414;
  goto ret0;

  L414:
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, ro[2]) && 1)
    return 83;
  goto ret0;

  L394:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == QImode && GET_CODE (x2) == MEM && 1)
    goto L395;
  goto ret0;

  L395:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == PLUS && 1)
    goto L396;
  goto ret0;

  L396:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L397;
    }
  goto ret0;

  L397:
  x4 = XEXP (x3, 1);
  if (int5_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L398;
    }
  goto ret0;

  L398:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L399;
  goto ret0;

  L399:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L400;
    }
  goto ret0;

  L400:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L401;
  goto ret0;

  L401:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[1]) && 1)
    goto L402;
  goto ret0;

  L402:
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, ro[2]) && 1)
    return 82;
  goto ret0;

  L1033:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == IF_THEN_ELSE && 1)
    goto L1034;
  goto ret0;
 L1034:
  return recog_4 (x0, insn, pnum_clobbers);
 ret0: return -1;
}

int
recog_6 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  int tem;

  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != SImode)
    goto ret0;
  switch (GET_CODE (x2))
    {
    case MULT:
      goto L666;
    case DIV:
      goto L688;
    case UDIV:
      goto L710;
    case MOD:
      goto L732;
    case UMOD:
      goto L754;
    }
  goto ret0;

  L666:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 26 && 1)
    goto L667;
  goto ret0;

  L667:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 25 && 1)
    goto L668;
  goto ret0;

  L668:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L669;
  goto ret0;

  L669:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L670;
    }
  goto ret0;

  L670:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L671;
  goto ret0;

  L671:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 26 && 1)
    goto L672;
  goto ret0;

  L672:
  x1 = XVECEXP (x0, 0, 3);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L673;
  goto ret0;

  L673:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 25 && 1)
    goto L674;
  goto ret0;

  L674:
  x1 = XVECEXP (x0, 0, 4);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L675;
  goto ret0;

  L675:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 31 && 1)
    return 140;
  goto ret0;

  L688:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 26 && 1)
    goto L689;
  goto ret0;

  L689:
  x3 = XEXP (x2, 1);
  if (div_operand (x3, SImode))
    {
      ro[0] = x3;
      goto L690;
    }
  goto ret0;

  L690:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L691;
  goto ret0;

  L691:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L692;
    }
  goto ret0;

  L692:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L693;
  goto ret0;

  L693:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 26 && 1)
    goto L694;
  goto ret0;

  L694:
  x1 = XVECEXP (x0, 0, 3);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L695;
  goto ret0;

  L695:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 25 && 1)
    goto L696;
  goto ret0;

  L696:
  x1 = XVECEXP (x0, 0, 4);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L697;
  goto ret0;

  L697:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 31 && 1)
    return 142;
  goto ret0;

  L710:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 26 && 1)
    goto L711;
  goto ret0;

  L711:
  x3 = XEXP (x2, 1);
  if (div_operand (x3, SImode))
    {
      ro[0] = x3;
      goto L712;
    }
  goto ret0;

  L712:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L713;
  goto ret0;

  L713:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L714;
    }
  goto ret0;

  L714:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L715;
  goto ret0;

  L715:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 26 && 1)
    goto L716;
  goto ret0;

  L716:
  x1 = XVECEXP (x0, 0, 3);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L717;
  goto ret0;

  L717:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 25 && 1)
    goto L718;
  goto ret0;

  L718:
  x1 = XVECEXP (x0, 0, 4);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L719;
  goto ret0;

  L719:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 31 && 1)
    return 144;
  goto ret0;

  L732:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 26 && 1)
    goto L733;
  goto ret0;

  L733:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 25 && 1)
    goto L734;
  goto ret0;

  L734:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L735;
  goto ret0;

  L735:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L736;
    }
  goto ret0;

  L736:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L737;
  goto ret0;

  L737:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 26 && 1)
    goto L738;
  goto ret0;

  L738:
  x1 = XVECEXP (x0, 0, 3);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L739;
  goto ret0;

  L739:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 25 && 1)
    goto L740;
  goto ret0;

  L740:
  x1 = XVECEXP (x0, 0, 4);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L741;
  goto ret0;

  L741:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 31 && 1)
    return 146;
  goto ret0;

  L754:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 26 && 1)
    goto L755;
  goto ret0;

  L755:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 25 && 1)
    goto L756;
  goto ret0;

  L756:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L757;
  goto ret0;

  L757:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L758;
    }
  goto ret0;

  L758:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L759;
  goto ret0;

  L759:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 26 && 1)
    goto L760;
  goto ret0;

  L760:
  x1 = XVECEXP (x0, 0, 3);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L761;
  goto ret0;

  L761:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 25 && 1)
    goto L762;
  goto ret0;

  L762:
  x1 = XVECEXP (x0, 0, 4);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L763;
  goto ret0;

  L763:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 31 && 1)
    return 148;
  goto ret0;
 ret0: return -1;
}

int
recog_7 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  int tem;

  x1 = XVECEXP (x0, 0, 0);
  switch (GET_CODE (x1))
    {
    case CALL:
      goto L1050;
    case SET:
      goto L1068;
    case UNSPEC_VOLATILE:
      if (XINT (x1, 1) == 0 && XVECLEN (x1, 0) == 1 && 1)
	goto L1224;
    }
  goto ret0;

  L1050:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == MEM && 1)
    goto L1051;
  goto ret0;

  L1051:
  x3 = XEXP (x2, 0);
  if (call_operand_address (x3, SImode))
    {
      ro[0] = x3;
      goto L1052;
    }
  L1060:
  if (register_operand (x3, SImode))
    {
      ro[0] = x3;
      goto L1061;
    }
  goto ret0;

  L1052:
  x2 = XEXP (x1, 1);
  ro[1] = x2;
  goto L1053;

  L1053:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L1054;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1060;

  L1054:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 2 && 1)
    goto L1055;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1060;

  L1055:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == USE && 1)
    goto L1056;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1060;

  L1056:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    if (! TARGET_LONG_CALLS)
      return 210;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L1060;

  L1061:
  x2 = XEXP (x1, 1);
  ro[1] = x2;
  goto L1062;

  L1062:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L1063;
  goto ret0;

  L1063:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 2 && 1)
    goto L1064;
  goto ret0;

  L1064:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == USE && 1)
    goto L1065;
  goto ret0;

  L1065:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 1 && 1)
    return 211;
  goto ret0;

  L1068:
  x2 = XEXP (x1, 0);
  ro[0] = x2;
  goto L1069;
  L1130:
  if (GET_CODE (x2) == PC && 1)
    goto L1131;
  goto ret0;

  L1069:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CALL && 1)
    goto L1070;
  x2 = XEXP (x1, 0);
  goto L1130;

  L1070:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == MEM && 1)
    goto L1071;
  x2 = XEXP (x1, 0);
  goto L1130;

  L1071:
  x4 = XEXP (x3, 0);
  if (call_operand_address (x4, SImode))
    {
      ro[1] = x4;
      goto L1072;
    }
  L1082:
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L1083;
    }
  x2 = XEXP (x1, 0);
  goto L1130;

  L1072:
  x3 = XEXP (x2, 1);
  ro[2] = x3;
  goto L1073;

  L1073:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L1074;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L1082;

  L1074:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 2 && 1)
    goto L1075;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L1082;

  L1075:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == USE && 1)
    goto L1076;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L1082;

  L1076:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    if (! TARGET_LONG_CALLS)
      return 213;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L1082;

  L1083:
  x3 = XEXP (x2, 1);
  ro[2] = x3;
  goto L1084;

  L1084:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L1085;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1130;

  L1085:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 2 && 1)
    goto L1086;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1130;

  L1086:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == USE && 1)
    goto L1087;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1130;

  L1087:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 1 && 1)
    return 214;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L1130;

  L1131:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == IF_THEN_ELSE && 1)
    goto L1132;
  goto ret0;

  L1132:
  x3 = XEXP (x2, 0);
  if (comparison_operator (x3, VOIDmode))
    {
      ro[2] = x3;
      goto L1133;
    }
  L1168:
  if (eq_neq_comparison_operator (x3, VOIDmode))
    {
      ro[2] = x3;
      goto L1169;
    }
  goto ret0;

  L1133:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == PLUS && 1)
    goto L1134;
  goto L1168;

  L1134:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, SImode))
    {
      ro[0] = x5;
      goto L1135;
    }
  goto L1168;

  L1135:
  x5 = XEXP (x4, 1);
  if (int5_operand (x5, SImode))
    {
      ro[1] = x5;
      goto L1136;
    }
  goto L1168;

  L1136:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L1137;
  goto L1168;

  L1137:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L1138;
  x3 = XEXP (x2, 0);
  goto L1168;

  L1138:
  x4 = XEXP (x3, 0);
  ro[3] = x4;
  goto L1139;

  L1139:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L1140;
  x3 = XEXP (x2, 0);
  goto L1168;

  L1140:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L1141;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1168;

  L1141:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[0]) && 1)
    goto L1142;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1168;

  L1142:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L1143;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1168;

  L1143:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[0]) && 1)
    goto L1144;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1168;

  L1144:
  x3 = XEXP (x2, 1);
  if (rtx_equal_p (x3, ro[1]) && 1)
    goto L1145;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1168;

  L1145:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L1146;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1168;

  L1146:
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      ro[4] = x2;
      return 224;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L1168;

  L1169:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[0] = x4;
      goto L1170;
    }
  goto ret0;

  L1170:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && 1)
    {
      ro[5] = x4;
      goto L1171;
    }
  goto ret0;

  L1171:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L1172;
  goto ret0;

  L1172:
  x4 = XEXP (x3, 0);
  ro[3] = x4;
  goto L1173;

  L1173:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L1174;
  goto ret0;

  L1174:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == SET && 1)
    goto L1175;
  goto ret0;

  L1175:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[0]) && 1)
    goto L1176;
  goto ret0;

  L1176:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L1177;
  goto ret0;

  L1177:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[0]) && 1)
    goto L1178;
  goto ret0;

  L1178:
  x3 = XEXP (x2, 1);
  if (int5_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L1179;
    }
  goto ret0;

  L1179:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L1180;
  goto ret0;

  L1180:
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SImode))
    {
      ro[4] = x2;
      if (INTVAL (operands[5]) == - INTVAL (operands[1]))
	return 225;
      }
  goto ret0;

  L1224:
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 1 && 1)
    goto L1225;
  goto ret0;

  L1225:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L1226;
  goto ret0;

  L1226:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == MEM && 1)
    goto L1227;
  goto ret0;

  L1227:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[0] = x3;
      goto L1228;
    }
  goto ret0;

  L1228:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == USE && 1)
    goto L1229;
  goto ret0;

  L1229:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == MEM && 1)
    goto L1230;
  goto ret0;

  L1230:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      return 232;
    }
  goto ret0;
 ret0: return -1;
}

int
recog (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  int tem;

  L0:
  switch (GET_CODE (x0))
    {
    case SET:
      goto L1;
    case PARALLEL:
      if (XVECLEN (x0, 0) == 2 && 1)
	goto L235;
      if (XVECLEN (x0, 0) == 7 && 1)
	goto L416;
      if (XVECLEN (x0, 0) == 5 && 1)
	goto L663;
      if (XVECLEN (x0, 0) == 3 && 1)
	goto L1049;
      if (XVECLEN (x0, 0) == 6 && 1)
	goto L1232;
      break;
    case RETURN:
      if (hppa_can_use_return_insn_p ())
	return 200;
      break;
    case UNSPEC_VOLATILE:
      if (XINT (x0, 1) == 0 && XVECLEN (x0, 0) == 1 && 1)
	goto L1025;
      break;
    case CONST_INT:
      if (XWINT (x0, 0) == 0 && 1)
	return 216;
    }
  goto ret0;
 L1:
  return recog_3 (x0, insn, pnum_clobbers);

  L235:
  x1 = XVECEXP (x0, 0, 0);
  switch (GET_CODE (x1))
    {
    case SET:
      goto L248;
    case USE:
      goto L1017;
    case UNSPEC_VOLATILE:
      if (XINT (x1, 1) == 0 && XVECLEN (x1, 0) == 1 && 1)
	goto L1021;
    }
  goto ret0;
 L248:
  return recog_5 (x0, insn, pnum_clobbers);

  L1017:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 2 && 1)
    goto L1018;
  goto ret0;

  L1018:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == RETURN && 1)
    return 201;
  goto ret0;

  L1021:
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    goto L1022;
  goto ret0;

  L1022:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L1023;
  goto ret0;

  L1023:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[0] = x2;
      return 204;
    }
  goto ret0;

  L416:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == SET && 1)
    goto L417;
  goto ret0;

  L417:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == BLKmode && GET_CODE (x2) == MEM && 1)
    goto L418;
  goto ret0;

  L418:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[0] = x3;
      goto L419;
    }
  goto ret0;

  L419:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == BLKmode && GET_CODE (x2) == MEM && 1)
    goto L420;
  goto ret0;

  L420:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L421;
    }
  goto ret0;

  L421:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L422;
  goto ret0;

  L422:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[0]) && 1)
    goto L423;
  goto ret0;

  L423:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L424;
  goto ret0;

  L424:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[1]) && 1)
    goto L425;
  goto ret0;

  L425:
  x1 = XVECEXP (x0, 0, 3);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L426;
  goto ret0;

  L426:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[2] = x2;
      goto L427;
    }
  goto ret0;

  L427:
  x1 = XVECEXP (x0, 0, 4);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L428;
  goto ret0;

  L428:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[3] = x2;
      goto L429;
    }
  goto ret0;

  L429:
  x1 = XVECEXP (x0, 0, 5);
  if (GET_CODE (x1) == USE && 1)
    goto L430;
  goto ret0;

  L430:
  x2 = XEXP (x1, 0);
  if (arith_operand (x2, SImode))
    {
      ro[4] = x2;
      goto L431;
    }
  goto ret0;

  L431:
  x1 = XVECEXP (x0, 0, 6);
  if (GET_CODE (x1) == USE && 1)
    goto L432;
  goto ret0;

  L432:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[5] = x2;
      return 85;
    }
  goto ret0;

  L663:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == SET && 1)
    goto L664;
  goto ret0;

  L664:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 29 && 1)
    goto L665;
  goto ret0;
 L665:
  return recog_6 (x0, insn, pnum_clobbers);
 L1049:
  return recog_7 (x0, insn, pnum_clobbers);

  L1232:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == UNSPEC_VOLATILE && XINT (x1, 1) == 0 && XVECLEN (x1, 0) == 1 && 1)
    goto L1233;
  goto ret0;

  L1233:
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 2 && 1)
    goto L1234;
  goto ret0;

  L1234:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L1235;
  goto ret0;

  L1235:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == MEM && 1)
    goto L1236;
  goto ret0;

  L1236:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[0] = x3;
      goto L1237;
    }
  goto ret0;

  L1237:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == USE && 1)
    goto L1238;
  goto ret0;

  L1238:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == MEM && 1)
    goto L1239;
  goto ret0;

  L1239:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L1240;
    }
  goto ret0;

  L1240:
  x1 = XVECEXP (x0, 0, 3);
  if (GET_CODE (x1) == USE && 1)
    goto L1241;
  goto ret0;

  L1241:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[2] = x2;
      goto L1242;
    }
  goto ret0;

  L1242:
  x1 = XVECEXP (x0, 0, 4);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L1243;
  goto ret0;

  L1243:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[3] = x2;
      goto L1244;
    }
  goto ret0;

  L1244:
  x1 = XVECEXP (x0, 0, 5);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L1245;
  goto ret0;

  L1245:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[4] = x2;
      return 233;
    }
  goto ret0;

  L1025:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == CONST_INT && XWINT (x1, 0) == 2 && 1)
    return 205;
  goto ret0;
 ret0: return -1;
}

rtx
split_insns (x0, insn)
     register rtx x0;
     rtx insn;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5, x6;
  rtx tem;

  L328:
  if (GET_CODE (x0) == PARALLEL && XVECLEN (x0, 0) == 2 && 1)
    goto L329;
  goto ret0;

  L329:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == SET && 1)
    goto L330;
  goto ret0;

  L330:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L619;
    }
  goto ret0;

  L619:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L620;
  L331:
  if (symbolic_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L332;
    }
  goto ret0;

  L620:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L621;
    }
  goto L331;

  L621:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[2] = x3;
      goto L622;
    }
  goto L331;

  L622:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L623;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  goto L331;

  L623:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    goto L632;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  goto L331;

  L632:
  ro[4] = x2;
  if (! cint_ok_for_move (INTVAL (operands[2]))
   && VAL_14_BITS_P (INTVAL (operands[2]) >> 1))
    return gen_split_132 (operands);
  L633:
  ro[4] = x2;
  if (! cint_ok_for_move (INTVAL (operands[2])))
    return gen_split_133 (operands);
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  goto L331;

  L332:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L333;
  goto ret0;

  L333:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[2] = x2;
      return gen_split_71 (operands);
    }
  goto ret0;
 ret0: return 0;
}

