/* Generated automatically by the program `genrecog'
from the machine description file `md'.  */

#include "config.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "real.h"
#include "output.h"
#include "flags.h"


/* `recog' contains a decision tree
   that recognizes whether the rtx X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.
   If the rtx is valid, recog returns a nonnegative number
   which is the insn code number for the pattern that matched.
   This is the same as the order in the machine description of
   the entry that matched.  This number can be used as an index into
   entry that matched.  This number can be used as an index into various
   insn_* tables, such as insn_templates, insn_outfun, and insn_n_operands
   (found in insn-output.c).

   The third argument to recog is an optional pointer to an int.
   If present, recog will accept a pattern if it matches except for
   missing CLOBBER expressions at the end.  In that case, the value
   pointed to by the optional pointer will be set to the number of
   CLOBBERs that need to be added (it should be initialized to zero by
   the caller).  If it is set nonzero, the caller should allocate a
   PARALLEL of the appropriate size, copy the initial entries, and call
   add_clobbers (found in insn-emit.c) to fill in the CLOBBERs.*/

rtx recog_operand[MAX_RECOG_OPERANDS];

rtx *recog_operand_loc[MAX_RECOG_OPERANDS];

rtx *recog_dup_loc[MAX_DUP_OPERANDS];

char recog_dup_num[MAX_DUP_OPERANDS];

#define operands recog_operand

int
recog_1 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5;
  int tem;

  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != SImode)
    goto ret0;
  switch (GET_CODE (x1))
    {
    case MEM:
      if (indexed_operand (x1, SImode))
	{
	  ro[1] = x1;
	  return 67;
	}
    L695:
      goto L696;
    case ZERO_EXTEND:
      goto L395;
    case SIGN_EXTEND:
      goto L407;
    case ASHIFTRT:
      goto L431;
    case PLUS:
      goto L508;
    case MINUS:
      goto L518;
    case AND:
      goto L549;
    case IOR:
      goto L555;
    case XOR:
      goto L560;
    case ASHIFT:
      goto L646;
    case LSHIFTRT:
      goto L666;
    }
  goto ret0;

  L696:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == PLUS && 1)
    goto L697;
  goto ret0;

  L697:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L698;
    }
  goto ret0;

  L698:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L699;
  goto ret0;

  L699:
  x4 = XEXP (x3, 0);
  ro[2] = x4;
  return 146;

  L395:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case HImode:
      if (register_operand (x2, HImode))
	{
	  ro[1] = x2;
	  return 75;
	}
      break;
    case QImode:
      if (register_operand (x2, QImode))
	{
	  ro[1] = x2;
	  return 77;
	}
    }
  goto ret0;

  L407:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case HImode:
      if (GET_CODE (x2) == MEM && indexed_operand (x2, HImode))
	{
	  ro[1] = x2;
	  return 78;
	}
    L419:
      if (nonimmediate_operand (x2, HImode))
	{
	  ro[1] = x2;
	  return 81;
	}
      break;
    case QImode:
      if (GET_CODE (x2) == MEM && indexed_operand (x2, QImode))
	{
	  ro[1] = x2;
	  return 80;
	}
    L427:
      if (nonimmediate_operand (x2, QImode))
	{
	  ro[1] = x2;
	  return 83;
	}
    }
  goto ret0;

  L431:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode)
    goto ret0;
  if (GET_CODE (x2) == SIGN_EXTEND && 1)
    goto L438;
  if (memory_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L642;
    }
  L661:
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L662;
    }
  goto ret0;

  L438:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != QImode)
    goto ret0;
  switch (GET_CODE (x3))
    {
    case SUBREG:
      if (XINT (x3, 1) == 0 && 1)
	goto L439;
      break;
    case ASHIFT:
      goto L448;
    }
  L432:
  if (register_operand (x3, QImode))
    {
      ro[1] = x3;
      goto L433;
    }
  goto ret0;

  L439:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == ASHIFT && 1)
    goto L440;
  goto L432;

  L440:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, SImode))
    {
      ro[1] = x5;
      goto L441;
    }
  goto L432;

  L441:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && logic_int (x5, SImode))
    {
      ro[2] = x5;
      goto L442;
    }
  goto L432;

  L442:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && logic_int (x2, SImode))
    {
      ro[3] = x2;
      if (INTVAL (operands[3]) < 8)
	return 85;
      }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L432;

  L448:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, QImode))
    {
      ro[1] = x4;
      goto L449;
    }
  goto ret0;

  L449:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && logic_int (x4, QImode))
    {
      ro[2] = x4;
      goto L450;
    }
  goto ret0;

  L450:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && logic_int (x2, SImode))
    {
      ro[3] = x2;
      if (INTVAL (operands[3]) < 8)
	return 86;
      }
  goto ret0;

  L433:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && logic_int (x2, SImode))
    {
      ro[2] = x2;
      if (INTVAL (operands[2]) < 8)
	return 84;
      }
  goto ret0;

  L642:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 24 && 1)
    return 123;
  x2 = XEXP (x1, 0);
  goto L661;

  L662:
  x2 = XEXP (x1, 1);
  if (shift_operand (x2, SImode))
    {
      ro[2] = x2;
      return 127;
    }
  goto ret0;

  L508:
  x2 = XEXP (x1, 0);
  if (nonmemory_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L509;
    }
  goto ret0;

  L509:
  x2 = XEXP (x1, 1);
  if (arith_operand (x2, SImode))
    {
      ro[2] = x2;
      return 98;
    }
  goto ret0;

  L518:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L519;
    }
  goto ret0;

  L519:
  x2 = XEXP (x1, 1);
  if (arith_operand (x2, SImode))
    {
      ro[2] = x2;
      return 100;
    }
  goto ret0;

  L549:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == NOT && 1)
    goto L550;
  if (nonmemory_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L545;
    }
  goto ret0;

  L550:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L551;
    }
  goto ret0;

  L551:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[2] = x2;
      return 108;
    }
  goto ret0;

  L545:
  x2 = XEXP (x1, 1);
  if (nonmemory_operand (x2, SImode))
    {
      ro[2] = x2;
      return 107;
    }
  goto ret0;

  L555:
  x2 = XEXP (x1, 0);
  if (nonmemory_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L556;
    }
  goto ret0;

  L556:
  x2 = XEXP (x1, 1);
  if (nonmemory_operand (x2, SImode))
    {
      ro[2] = x2;
      return 109;
    }
  goto ret0;

  L560:
  x2 = XEXP (x1, 0);
  if (nonmemory_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L561;
    }
  goto ret0;

  L561:
  x2 = XEXP (x1, 1);
  if (nonmemory_operand (x2, SImode))
    {
      ro[2] = x2;
      return 110;
    }
  goto ret0;

  L646:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L647;
    }
  goto ret0;

  L647:
  x2 = XEXP (x1, 1);
  if (shift_operand (x2, SImode))
    {
      ro[2] = x2;
      return 124;
    }
  goto ret0;

  L666:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L667;
    }
  goto ret0;

  L667:
  x2 = XEXP (x1, 1);
  if (shift_operand (x2, SImode))
    {
      ro[2] = x2;
      return 128;
    }
  goto ret0;
 ret0: return -1;
}

int
recog_2 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5;
  int tem;

  x1 = XEXP (x0, 1);
  switch (GET_CODE (x1))
    {
    case EQ:
      goto L3;
    case NE:
      goto L10;
    case LT:
      goto L51;
    case GT:
      goto L56;
    case LE:
      goto L61;
    case GE:
      goto L66;
    case GEU:
      goto L71;
    case LEU:
      goto L76;
    }
  goto ret0;

  L3:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      switch (GET_CODE (x2))
	{
	case AND:
	  goto L473;
	case ASHIFTRT:
	  goto L32;
	case ZERO_EXTEND:
	  goto L142;
	case CONST_INT:
	  if (GET_CODE (x2) == CONST_INT && small_int (x2, SImode))
	    {
	      ro[0] = x2;
	      goto L148;
	    }
	  break;
	case SIGN_EXTEND:
	  goto L464;
	}
    L41:
      if (logic_operand (x2, SImode))
	{
	  ro[0] = x2;
	  goto L42;
	}
      break;
    case SFmode:
      if (reg_or_0_operand (x2, SFmode))
	{
	  ro[0] = x2;
	  goto L82;
	}
      break;
    case DFmode:
      if (reg_or_0_operand (x2, DFmode))
	{
	  ro[0] = x2;
	  goto L112;
	}
    }
  goto ret0;

  L473:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != SImode)
    goto ret0;
  switch (GET_CODE (x3))
    {
    case LSHIFTRT:
      goto L474;
    case ASHIFTRT:
      goto L483;
    case SUBREG:
    case REG:
      if (register_operand (x3, SImode))
	{
	  ro[0] = x3;
	  goto L5;
	}
    }
  goto ret0;

  L474:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[0] = x4;
      goto L475;
    }
  goto ret0;

  L475:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && logic_int (x4, SImode))
    {
      ro[1] = x4;
      goto L476;
    }
  goto ret0;

  L476:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && logic_int (x3, SImode))
    {
      ro[2] = x3;
      goto L477;
    }
  goto ret0;

  L477:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    if (LOGIC_INTVAL (INTVAL (operands[2]) << INTVAL (operands[1])))
      return 89;
  goto ret0;

  L483:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[0] = x4;
      goto L484;
    }
  goto ret0;

  L484:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && logic_int (x4, SImode))
    {
      ro[1] = x4;
      goto L485;
    }
  goto ret0;

  L485:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && logic_int (x3, SImode))
    {
      ro[2] = x3;
      goto L486;
    }
  goto ret0;

  L486:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    if (LOGIC_INTVAL (INTVAL (operands[2]) << INTVAL (operands[1])))
      return 90;
  goto ret0;

  L5:
  x3 = XEXP (x2, 1);
  if (logic_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L6;
    }
  L19:
  if (immediate_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L20;
    }
  goto ret0;

  L6:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 0;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  goto L19;

  L20:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    if (GET_CODE (operands[1]) == CONST_INT && (INTVAL (operands[1]) & 0xffff) == 0)
      return 2;
  goto ret0;

  L32:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == SIGN_EXTEND && 1)
    goto L33;
  goto ret0;

  L33:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == QImode && GET_CODE (x4) == ASHIFT && 1)
    goto L34;
  goto ret0;

  L34:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, QImode))
    {
      ro[0] = x5;
      goto L35;
    }
  goto ret0;

  L35:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && logic_int (x5, QImode))
    {
      ro[1] = x5;
      goto L36;
    }
  goto ret0;

  L36:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && logic_int (x3, SImode))
    {
      ro[2] = x3;
      goto L37;
    }
  goto ret0;

  L37:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 4;
  goto ret0;

  L142:
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case HImode:
      switch (GET_CODE (x3))
	{
	case MEM:
	  if (load_operand (x3, HImode))
	    {
	      ro[0] = x3;
	      goto L143;
	    }
	}
      break;
    case QImode:
      if (GET_CODE (x3) == SUBREG && XINT (x3, 1) == 0 && 1)
	goto L456;
    }
  goto ret0;

  L143:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && small_int (x2, SImode))
    {
      ro[1] = x2;
      if (INTVAL (operands[1]) >= 0)
	return 25;
      }
  goto ret0;

  L456:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == LSHIFTRT && 1)
    goto L457;
  goto ret0;

  L457:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, SImode))
    {
      ro[0] = x5;
      goto L458;
    }
  goto ret0;

  L458:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 7 && 1)
    goto L459;
  goto ret0;

  L459:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 87;
  goto ret0;

  L148:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == ZERO_EXTEND && 1)
    goto L149;
  x2 = XEXP (x1, 0);
  goto L41;

  L149:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == MEM && load_operand (x3, HImode))
    {
      ro[1] = x3;
      if (INTVAL (operands[0]) >= 0)
	return 26;
      }
  x2 = XEXP (x1, 0);
  goto L41;

  L464:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == QImode && GET_CODE (x3) == SUBREG && XINT (x3, 1) == 0 && 1)
    goto L465;
  goto ret0;

  L465:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == ASHIFTRT && 1)
    goto L466;
  goto ret0;

  L466:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, SImode))
    {
      ro[0] = x5;
      goto L467;
    }
  goto ret0;

  L467:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 7 && 1)
    goto L468;
  goto ret0;

  L468:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 88;
  goto ret0;

  L42:
  x2 = XEXP (x1, 1);
  if (logic_operand (x2, SImode))
    {
      ro[1] = x2;
      return 5;
    }
  goto ret0;

  L82:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, SFmode))
    {
      ro[1] = x2;
      return 13;
    }
  goto ret0;

  L112:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DFmode))
    {
      ro[1] = x2;
      return 19;
    }
  goto ret0;

  L10:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      if (GET_CODE (x2) == AND && 1)
	goto L11;
      if (logic_operand (x2, SImode))
	{
	  ro[0] = x2;
	  goto L47;
	}
      break;
    case SFmode:
      if (reg_or_0_operand (x2, SFmode))
	{
	  ro[0] = x2;
	  goto L87;
	}
      break;
    case DFmode:
      if (reg_or_0_operand (x2, DFmode))
	{
	  ro[0] = x2;
	  goto L117;
	}
    }
  goto ret0;

  L11:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[0] = x3;
      goto L12;
    }
  goto ret0;

  L12:
  x3 = XEXP (x2, 1);
  if (logic_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L13;
    }
  L26:
  if (immediate_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L27;
    }
  goto ret0;

  L13:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  goto L26;

  L27:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    if (GET_CODE (operands[1]) == CONST_INT && (INTVAL (operands[1]) & 0xffff) == 0)
      return 3;
  goto ret0;

  L47:
  x2 = XEXP (x1, 1);
  if (logic_operand (x2, SImode))
    {
      ro[1] = x2;
      return 6;
    }
  goto ret0;

  L87:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, SFmode))
    {
      ro[1] = x2;
      return 14;
    }
  goto ret0;

  L117:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DFmode))
    {
      ro[1] = x2;
      return 20;
    }
  goto ret0;

  L51:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      if (arith_operand (x2, SImode))
	{
	  ro[0] = x2;
	  goto L52;
	}
      break;
    case SFmode:
      if (reg_or_0_operand (x2, SFmode))
	{
	  ro[0] = x2;
	  goto L92;
	}
      break;
    case DFmode:
      if (reg_or_0_operand (x2, DFmode))
	{
	  ro[0] = x2;
	  goto L122;
	}
    }
  goto ret0;

  L52:
  x2 = XEXP (x1, 1);
  if (arith_operand (x2, SImode))
    {
      ro[1] = x2;
      return 7;
    }
  goto ret0;

  L92:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, SFmode))
    {
      ro[1] = x2;
      return 15;
    }
  goto ret0;

  L122:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DFmode))
    {
      ro[1] = x2;
      return 21;
    }
  goto ret0;

  L56:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      if (arith_operand (x2, SImode))
	{
	  ro[0] = x2;
	  goto L57;
	}
      break;
    case SFmode:
      if (reg_or_0_operand (x2, SFmode))
	{
	  ro[0] = x2;
	  goto L97;
	}
      break;
    case DFmode:
      if (reg_or_0_operand (x2, DFmode))
	{
	  ro[0] = x2;
	  goto L127;
	}
    }
  goto ret0;

  L57:
  x2 = XEXP (x1, 1);
  if (arith_operand (x2, SImode))
    {
      ro[1] = x2;
      return 8;
    }
  goto ret0;

  L97:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, SFmode))
    {
      ro[1] = x2;
      return 16;
    }
  goto ret0;

  L127:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DFmode))
    {
      ro[1] = x2;
      return 22;
    }
  goto ret0;

  L61:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      if (arith_operand (x2, SImode))
	{
	  ro[0] = x2;
	  goto L62;
	}
      break;
    case SFmode:
      if (reg_or_0_operand (x2, SFmode))
	{
	  ro[0] = x2;
	  goto L102;
	}
      break;
    case DFmode:
      if (reg_or_0_operand (x2, DFmode))
	{
	  ro[0] = x2;
	  goto L132;
	}
    }
  goto ret0;

  L62:
  x2 = XEXP (x1, 1);
  if (arith_operand (x2, SImode))
    {
      ro[1] = x2;
      return 9;
    }
  goto ret0;

  L102:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, SFmode))
    {
      ro[1] = x2;
      return 17;
    }
  goto ret0;

  L132:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DFmode))
    {
      ro[1] = x2;
      return 23;
    }
  goto ret0;

  L66:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      if (arith_operand (x2, SImode))
	{
	  ro[0] = x2;
	  goto L67;
	}
      break;
    case SFmode:
      if (reg_or_0_operand (x2, SFmode))
	{
	  ro[0] = x2;
	  goto L107;
	}
      break;
    case DFmode:
      if (reg_or_0_operand (x2, DFmode))
	{
	  ro[0] = x2;
	  goto L137;
	}
    }
  goto ret0;

  L67:
  x2 = XEXP (x1, 1);
  if (arith_operand (x2, SImode))
    {
      ro[1] = x2;
      return 10;
    }
  goto ret0;

  L107:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, SFmode))
    {
      ro[1] = x2;
      return 18;
    }
  goto ret0;

  L137:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DFmode))
    {
      ro[1] = x2;
      return 24;
    }
  goto ret0;

  L71:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && arith_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L72;
    }
  goto ret0;

  L72:
  x2 = XEXP (x1, 1);
  if (arith_operand (x2, SImode))
    {
      ro[1] = x2;
      return 11;
    }
  goto ret0;

  L76:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && arith_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L77;
    }
  goto ret0;

  L77:
  x2 = XEXP (x1, 1);
  if (arith_operand (x2, SImode))
    {
      ro[1] = x2;
      return 12;
    }
  goto ret0;
 ret0: return -1;
}

int
recog_3 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5;
  int tem;

  x1 = XEXP (x0, 0);
  switch (GET_MODE (x1))
    {
    case SImode:
      if (general_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L564;
	}
    L366:
      if (register_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L367;
	}
      break;
    case HImode:
      if (general_operand (x1, HImode))
	{
	  ro[0] = x1;
	  goto L390;
	}
    L369:
      if (register_operand (x1, HImode))
	{
	  ro[0] = x1;
	  goto L370;
	}
      break;
    case QImode:
      if (general_operand (x1, QImode))
	{
	  ro[0] = x1;
	  goto L382;
	}
    L372:
      if (register_operand (x1, QImode))
	{
	  ro[0] = x1;
	  goto L373;
	}
      break;
    case DFmode:
      if (general_operand (x1, DFmode))
	{
	  ro[0] = x1;
	  goto L349;
	}
    L360:
      if (register_operand (x1, DFmode))
	{
	  ro[0] = x1;
	  goto L361;
	}
      break;
    case DImode:
      if (general_operand (x1, DImode))
	{
	  ro[0] = x1;
	  goto L355;
	}
    L496:
      if (register_operand (x1, DImode))
	{
	  ro[0] = x1;
	  goto L497;
	}
      break;
    case SFmode:
      if (general_operand (x1, SFmode))
	{
	  ro[0] = x1;
	  goto L358;
	}
    L363:
      if (register_operand (x1, SFmode))
	{
	  ro[0] = x1;
	  goto L364;
	}
    }
  switch (GET_MODE (x1))
    {
    case DFmode:
      switch (GET_CODE (x1))
	{
	case MEM:
	  if (indexed_operand (x1, DFmode))
	    {
	      ro[0] = x1;
	      goto L376;
	    }
	}
      break;
    case SFmode:
      switch (GET_CODE (x1))
	{
	case MEM:
	  if (indexed_operand (x1, SFmode))
	    {
	      ro[0] = x1;
	      goto L379;
	    }
	}
      break;
    case SImode:
    L526:
      switch (GET_CODE (x1))
	{
	case SUBREG:
	  if (XINT (x1, 1) == 0 && 1)
	    goto L527;
	  if (XINT (x1, 1) == 1 && 1)
	    goto L535;
	}
    }
  switch (GET_CODE (x1))
    {
    case CC0:
      goto L2;
    case PC:
      goto L692;
    case SUBREG:
    case REG:
    L683:
      if (register_operand (x1, VOIDmode))
	{
	  ro[0] = x1;
	  goto L684;
	}
    }
  goto ret0;

  L564:
  x1 = XEXP (x0, 1);
  switch (GET_MODE (x1))
    {
    case SImode:
      switch (GET_CODE (x1))
	{
	case NEG:
	  goto L565;
	case NOT:
	  goto L569;
	}
    }
  if (general_operand (x1, SImode))
    {
      ro[1] = x1;
      return 56;
    }
  x1 = XEXP (x0, 0);
  goto L366;

  L565:
  x2 = XEXP (x1, 0);
  if (arith_operand (x2, SImode))
    {
      ro[1] = x2;
      return 111;
    }
  x1 = XEXP (x0, 0);
  goto L366;

  L569:
  x2 = XEXP (x1, 0);
  if (arith_operand (x2, SImode))
    {
      ro[1] = x2;
      return 112;
    }
  x1 = XEXP (x0, 0);
  goto L366;
 L367:
  tem = recog_1 (x0, insn, pnum_clobbers);
  if (tem >= 0) return tem;
  x1 = XEXP (x0, 0);
  goto L526;

  L390:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == HImode && GET_CODE (x1) == TRUNCATE && 1)
    goto L391;
  if (general_operand (x1, HImode))
    {
      ro[1] = x1;
      return 57;
    }
  x1 = XEXP (x0, 0);
  goto L369;

  L391:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      return 74;
    }
  x1 = XEXP (x0, 0);
  goto L369;

  L370:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != HImode)
    {
      x1 = XEXP (x0, 0);
      goto L683;
    }
  switch (GET_CODE (x1))
    {
    case MEM:
      if (indexed_operand (x1, HImode))
	{
	  ro[1] = x1;
	  return 68;
	}
      break;
    case ZERO_EXTEND:
      goto L399;
    case SIGN_EXTEND:
      goto L411;
    case ASHIFT:
      goto L651;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L399:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, QImode))
    {
      ro[1] = x2;
      return 76;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L411:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != QImode)
    {
      x1 = XEXP (x0, 0);
      goto L683;
    }
  if (GET_CODE (x2) == MEM && indexed_operand (x2, QImode))
    {
      ro[1] = x2;
      return 79;
    }
  L423:
  if (nonimmediate_operand (x2, QImode))
    {
      ro[1] = x2;
      return 82;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L651:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, HImode))
    {
      ro[1] = x2;
      goto L652;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L652:
  x2 = XEXP (x1, 1);
  if (shift_operand (x2, HImode))
    {
      ro[2] = x2;
      return 125;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L382:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == QImode && GET_CODE (x1) == TRUNCATE && 1)
    goto L383;
  if (general_operand (x1, QImode))
    {
      ro[1] = x1;
      return 58;
    }
  x1 = XEXP (x0, 0);
  goto L372;

  L383:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      if (register_operand (x2, SImode))
	{
	  ro[1] = x2;
	  return 72;
	}
      break;
    case HImode:
      if (register_operand (x2, HImode))
	{
	  ro[1] = x2;
	  return 73;
	}
    }
  x1 = XEXP (x0, 0);
  goto L372;

  L373:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != QImode)
    {
      x1 = XEXP (x0, 0);
      goto L683;
    }
  switch (GET_CODE (x1))
    {
    case MEM:
      if (indexed_operand (x1, QImode))
	{
	  ro[1] = x1;
	  return 69;
	}
      break;
    case ASHIFT:
      goto L656;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L656:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, QImode))
    {
      ro[1] = x2;
      goto L657;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L657:
  x2 = XEXP (x1, 1);
  if (shift_operand (x2, QImode))
    {
      ro[2] = x2;
      return 126;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L349:
  x1 = XEXP (x0, 1);
  ro[1] = x1;
  if (GET_CODE (operands[1]) == CONST_DOUBLE)
    return 61;
  L352:
  if (general_operand (x1, DFmode))
    {
      ro[1] = x1;
      return 62;
    }
  x1 = XEXP (x0, 0);
  goto L360;

  L361:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != DFmode)
    {
      x1 = XEXP (x0, 0);
      goto L683;
    }
  switch (GET_CODE (x1))
    {
    case MEM:
      if (indexed_operand (x1, DFmode))
	{
	  ro[1] = x1;
	  return 65;
	}
      break;
    case FLOAT_EXTEND:
      goto L490;
    case PLUS:
      goto L573;
    case MINUS:
      goto L583;
    case MULT:
      goto L593;
    case NEG:
      goto L603;
    case DIV:
      goto L621;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L490:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      return 91;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L573:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L574;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L574:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DFmode))
    {
      ro[2] = x2;
      return 113;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L583:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L584;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L584:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DFmode))
    {
      ro[2] = x2;
      return 115;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L593:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L594;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L594:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DFmode))
    {
      ro[2] = x2;
      return 117;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L603:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      return 119;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L621:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L622;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L622:
  x2 = XEXP (x1, 1);
  if (pnum_clobbers != 0 && register_operand (x2, DFmode))
    {
      ro[2] = x2;
      *pnum_clobbers = 2;
      return 121;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L355:
  x1 = XEXP (x0, 1);
  if (general_operand (x1, DImode))
    {
      ro[1] = x1;
      return 63;
    }
  x1 = XEXP (x0, 0);
  goto L496;

  L497:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != DImode)
    {
      x1 = XEXP (x0, 0);
      goto L683;
    }
  switch (GET_CODE (x1))
    {
    case FIX:
      goto L498;
    case PLUS:
      goto L513;
    case MINUS:
      goto L523;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L498:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != FIX)
    {
      x1 = XEXP (x0, 0);
    goto L683;
    }
  switch (GET_MODE (x2))
    {
    case DFmode:
      goto L499;
    case SFmode:
      goto L504;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L499:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DFmode))
    {
      ro[1] = x3;
      return 95;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L504:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SFmode))
    {
      ro[1] = x3;
      return 97;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L513:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L514;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L514:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DImode))
    {
      ro[2] = x2;
      return 99;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L523:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L524;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L524:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, DImode))
    {
      ro[2] = x2;
      return 101;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L358:
  x1 = XEXP (x0, 1);
  if (general_operand (x1, SFmode))
    {
      ro[1] = x1;
      return 64;
    }
  x1 = XEXP (x0, 0);
  goto L363;

  L364:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != SFmode)
    {
      x1 = XEXP (x0, 0);
      goto L683;
    }
  switch (GET_CODE (x1))
    {
    case MEM:
      if (indexed_operand (x1, SFmode))
	{
	  ro[1] = x1;
	  return 66;
	}
      break;
    case FLOAT_TRUNCATE:
      goto L494;
    case PLUS:
      goto L578;
    case MINUS:
      goto L588;
    case MULT:
      goto L598;
    case NEG:
      goto L607;
    case DIV:
      goto L636;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L494:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DFmode))
    {
      ro[1] = x2;
      return 92;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L578:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L579;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L579:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SFmode))
    {
      ro[2] = x2;
      return 114;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L588:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L589;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L589:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SFmode))
    {
      ro[2] = x2;
      return 116;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L598:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L599;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L599:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SFmode))
    {
      ro[2] = x2;
      return 118;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L607:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      return 120;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L636:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L637;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L637:
  x2 = XEXP (x1, 1);
  if (pnum_clobbers != 0 && register_operand (x2, SFmode))
    {
      ro[2] = x2;
      *pnum_clobbers = 2;
      return 122;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L376:
  x1 = XEXP (x0, 1);
  if (register_operand (x1, DFmode))
    {
      ro[1] = x1;
      return 70;
    }
  goto ret0;

  L379:
  x1 = XEXP (x0, 1);
  if (register_operand (x1, SFmode))
    {
      ro[1] = x1;
      return 71;
    }
  goto ret0;

  L527:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[0] = x2;
      goto L528;
    }
  goto L683;

  L528:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode && GET_CODE (x1) == MULT && 1)
    goto L529;
  x1 = XEXP (x0, 0);
  goto L683;

  L529:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == SUBREG && XINT (x2, 1) == 0 && 1)
    goto L530;
  x1 = XEXP (x0, 0);
  goto L683;

  L530:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L531;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L531:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == SUBREG && XINT (x2, 1) == 0 && 1)
    goto L532;
  x1 = XEXP (x0, 0);
  goto L683;

  L532:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DImode))
    {
      ro[2] = x3;
      if (! WORDS_BIG_ENDIAN)
	return 105;
      }
  x1 = XEXP (x0, 0);
  goto L683;

  L535:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[0] = x2;
      goto L536;
    }
  goto L683;

  L536:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == SImode && GET_CODE (x1) == MULT && 1)
    goto L537;
  x1 = XEXP (x0, 0);
  goto L683;

  L537:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == SUBREG && XINT (x2, 1) == 1 && 1)
    goto L538;
  x1 = XEXP (x0, 0);
  goto L683;

  L538:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L539;
    }
  x1 = XEXP (x0, 0);
  goto L683;

  L539:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == SUBREG && XINT (x2, 1) == 1 && 1)
    goto L540;
  x1 = XEXP (x0, 0);
  goto L683;

  L540:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DImode))
    {
      ro[2] = x3;
      if (WORDS_BIG_ENDIAN)
	return 106;
      }
  x1 = XEXP (x0, 0);
  goto L683;
 L2:
  return recog_2 (x0, insn, pnum_clobbers);

  L692:
  x1 = XEXP (x0, 1);
  if (register_operand (x1, SImode))
    {
      ro[0] = x1;
      return 145;
    }
  switch (GET_CODE (x1))
    {
    case IF_THEN_ELSE:
      goto L153;
    case LABEL_REF:
      goto L671;
    }
  goto ret0;

  L153:
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case EQ:
      goto L190;
    case NE:
      goto L199;
    }
  goto ret0;

  L190:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[0] = x3;
      goto L191;
    }
  if (GET_CODE (x3) == CC0 && 1)
    goto L155;
  goto ret0;

  L191:
  x3 = XEXP (x2, 1);
  if (bte_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L192;
    }
  goto ret0;

  L192:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L193;
    case PC:
      goto L211;
    }
  goto ret0;

  L193:
  x3 = XEXP (x2, 0);
  ro[2] = x3;
  goto L194;

  L194:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 31;
  goto ret0;

  L211:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L212;
  goto ret0;

  L212:
  x3 = XEXP (x2, 0);
  ro[2] = x3;
  return 33;

  L155:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L156;
  goto ret0;

  L156:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L157;
    case PC:
      goto L175;
    }
  goto ret0;

  L157:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L158;

  L158:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 27;
  goto ret0;

  L175:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L176;
  goto ret0;

  L176:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 29;

  L199:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[0] = x3;
      goto L200;
    }
  if (GET_CODE (x3) == CC0 && 1)
    goto L164;
  goto ret0;

  L200:
  x3 = XEXP (x2, 1);
  if (bte_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L201;
    }
  goto ret0;

  L201:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      goto L202;
    case PC:
      goto L220;
    }
  goto ret0;

  L202:
  x3 = XEXP (x2, 0);
  ro[2] = x3;
  goto L203;

  L203:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 32;
  goto ret0;

  L220:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L221;
  goto ret0;

  L221:
  x3 = XEXP (x2, 0);
  ro[2] = x3;
  return 34;

  L164:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L165;
  goto ret0;

  L165:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PC:
      goto L166;
    case LABEL_REF:
      goto L184;
    }
  goto ret0;

  L166:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L167;
  goto ret0;

  L167:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  return 28;

  L184:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L185;

  L185:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 30;
  goto ret0;

  L671:
  x2 = XEXP (x1, 0);
  ro[0] = x2;
  return 129;

  L684:
  x1 = XEXP (x0, 1);
  if (GET_CODE (x1) == CALL && 1)
    goto L685;
  goto ret0;

  L685:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == MEM && call_insn_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L686;
    }
  goto ret0;

  L686:
  x2 = XEXP (x1, 1);
  ro[2] = x2;
  return 139;
 ret0: return -1;
}

int
recog_4 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5;
  int tem;

  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == SET && 1)
    goto L224;
  goto ret0;

  L224:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == PC && 1)
    goto L675;
  goto ret0;

  L675:
  x2 = XEXP (x1, 1);
  if (register_operand (x2, SImode))
    {
      ro[0] = x2;
      goto L676;
    }
  if (GET_CODE (x2) == IF_THEN_ELSE && 1)
    goto L226;
  goto ret0;

  L676:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L677;
  goto ret0;

  L677:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L678;
  goto ret0;

  L678:
  x3 = XEXP (x2, 0);
  ro[1] = x3;
  return 132;

  L226:
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case EQ:
      goto L227;
    case NE:
      goto L239;
    }
  goto ret0;

  L227:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == ZERO_EXTEND && 1)
    goto L228;
  goto ret0;

  L228:
  x5 = XEXP (x4, 0);
  switch (GET_MODE (x5))
    {
    case QImode:
      if (memory_operand (x5, QImode))
	{
	  ro[0] = x5;
	  goto L229;
	}
      break;
    case HImode:
      if (memory_operand (x5, HImode))
	{
	  ro[0] = x5;
	  goto L277;
	}
    }
  goto ret0;

  L229:
  x4 = XEXP (x3, 1);
  if (bte_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L230;
    }
  goto ret0;

  L230:
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      goto L231;
    case PC:
      goto L255;
    }
  goto ret0;

  L231:
  x4 = XEXP (x3, 0);
  ro[2] = x4;
  goto L232;

  L232:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L233;
  goto ret0;

  L233:
  x1 = XVECEXP (x0, 0, 1);
  if (scratch_operand (x1, SImode))
    {
      ro[3] = x1;
      return 35;
    }
  goto ret0;

  L255:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L256;
  goto ret0;

  L256:
  x4 = XEXP (x3, 0);
  ro[2] = x4;
  goto L257;

  L257:
  x1 = XVECEXP (x0, 0, 1);
  if (scratch_operand (x1, SImode))
    {
      ro[3] = x1;
      return 37;
    }
  goto ret0;

  L277:
  x4 = XEXP (x3, 1);
  if (bte_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L278;
    }
  goto ret0;

  L278:
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      goto L279;
    case PC:
      goto L303;
    }
  goto ret0;

  L279:
  x4 = XEXP (x3, 0);
  ro[2] = x4;
  goto L280;

  L280:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L281;
  goto ret0;

  L281:
  x1 = XVECEXP (x0, 0, 1);
  if (scratch_operand (x1, SImode))
    {
      ro[3] = x1;
      return 39;
    }
  goto ret0;

  L303:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L304;
  goto ret0;

  L304:
  x4 = XEXP (x3, 0);
  ro[2] = x4;
  goto L305;

  L305:
  x1 = XVECEXP (x0, 0, 1);
  if (scratch_operand (x1, SImode))
    {
      ro[3] = x1;
      return 41;
    }
  goto ret0;

  L239:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == ZERO_EXTEND && 1)
    goto L240;
  goto ret0;

  L240:
  x5 = XEXP (x4, 0);
  switch (GET_MODE (x5))
    {
    case QImode:
      if (memory_operand (x5, QImode))
	{
	  ro[0] = x5;
	  goto L241;
	}
      break;
    case HImode:
      if (memory_operand (x5, HImode))
	{
	  ro[0] = x5;
	  goto L289;
	}
    }
  goto ret0;

  L241:
  x4 = XEXP (x3, 1);
  if (bte_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L242;
    }
  goto ret0;

  L242:
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      goto L243;
    case PC:
      goto L267;
    }
  goto ret0;

  L243:
  x4 = XEXP (x3, 0);
  ro[2] = x4;
  goto L244;

  L244:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L245;
  goto ret0;

  L245:
  x1 = XVECEXP (x0, 0, 1);
  if (scratch_operand (x1, SImode))
    {
      ro[3] = x1;
      return 36;
    }
  goto ret0;

  L267:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L268;
  goto ret0;

  L268:
  x4 = XEXP (x3, 0);
  ro[2] = x4;
  goto L269;

  L269:
  x1 = XVECEXP (x0, 0, 1);
  if (scratch_operand (x1, SImode))
    {
      ro[3] = x1;
      return 38;
    }
  goto ret0;

  L289:
  x4 = XEXP (x3, 1);
  if (bte_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L290;
    }
  goto ret0;

  L290:
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      goto L291;
    case PC:
      goto L315;
    }
  goto ret0;

  L291:
  x4 = XEXP (x3, 0);
  ro[2] = x4;
  goto L292;

  L292:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L293;
  goto ret0;

  L293:
  x1 = XVECEXP (x0, 0, 1);
  if (scratch_operand (x1, SImode))
    {
      ro[3] = x1;
      return 40;
    }
  goto ret0;

  L315:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L316;
  goto ret0;

  L316:
  x4 = XEXP (x3, 0);
  ro[2] = x4;
  goto L317;

  L317:
  x1 = XVECEXP (x0, 0, 1);
  if (scratch_operand (x1, SImode))
    {
      ro[3] = x1;
      return 42;
    }
  goto ret0;
 ret0: return -1;
}

int
recog (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5;
  int tem;

  L0:
  switch (GET_CODE (x0))
    {
    case SET:
      goto L319;
    case PARALLEL:
      if (XVECLEN (x0, 0) == 2 && 1)
	goto L223;
      if (XVECLEN (x0, 0) == 8 && 1)
	goto L328;
      if (XVECLEN (x0, 0) == 3 && 1)
	goto L609;
      break;
    case CALL:
      goto L680;
    case UNSPEC_VOLATILE:
      if (XINT (x0, 1) == 0 && XVECLEN (x0, 0) == 1 && 1)
	goto L688;
      break;
    case CONST_INT:
      if (XWINT (x0, 0) == 0 && 1)
	return 144;
    }
  goto ret0;
 L319:
  return recog_3 (x0, insn, pnum_clobbers);
 L223:
  return recog_4 (x0, insn, pnum_clobbers);

  L328:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == SET && 1)
    goto L329;
  goto ret0;

  L329:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == BLKmode && GET_CODE (x2) == MEM && 1)
    goto L330;
  goto ret0;

  L330:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[0] = x3;
      goto L331;
    }
  goto ret0;

  L331:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == BLKmode && GET_CODE (x2) == MEM && 1)
    goto L332;
  goto ret0;

  L332:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L333;
    }
  goto ret0;

  L333:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L334;
  goto ret0;

  L334:
  x2 = XEXP (x1, 0);
  if (general_operand (x2, SImode))
    {
      ro[2] = x2;
      goto L335;
    }
  goto ret0;

  L335:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == USE && 1)
    goto L336;
  goto ret0;

  L336:
  x2 = XEXP (x1, 0);
  if (immediate_operand (x2, SImode))
    {
      ro[3] = x2;
      goto L337;
    }
  goto ret0;

  L337:
  x1 = XVECEXP (x0, 0, 3);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L338;
  goto ret0;

  L338:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[4] = x2;
      goto L339;
    }
  goto ret0;

  L339:
  x1 = XVECEXP (x0, 0, 4);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L340;
  goto ret0;

  L340:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[5] = x2;
      goto L341;
    }
  goto ret0;

  L341:
  x1 = XVECEXP (x0, 0, 5);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L342;
  goto ret0;

  L342:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[6] = x2;
      goto L343;
    }
  goto ret0;

  L343:
  x1 = XVECEXP (x0, 0, 6);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L344;
  goto ret0;

  L344:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[0]) && 1)
    goto L345;
  goto ret0;

  L345:
  x1 = XVECEXP (x0, 0, 7);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L346;
  goto ret0;

  L346:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[1]) && 1)
    return 60;
  goto ret0;

  L609:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == SET && 1)
    goto L610;
  goto ret0;

  L610:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case DFmode:
      if (register_operand (x2, DFmode))
	{
	  ro[0] = x2;
	  goto L611;
	}
      break;
    case SFmode:
      if (register_operand (x2, SFmode))
	{
	  ro[0] = x2;
	  goto L626;
	}
    }
  goto ret0;

  L611:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DFmode && GET_CODE (x2) == DIV && 1)
    goto L612;
  goto ret0;

  L612:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DFmode))
    {
      ro[1] = x3;
      goto L613;
    }
  goto ret0;

  L613:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, DFmode))
    {
      ro[2] = x3;
      goto L614;
    }
  goto ret0;

  L614:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L615;
  goto ret0;

  L615:
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, DFmode))
    {
      ro[3] = x2;
      goto L616;
    }
  goto ret0;

  L616:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L617;
  goto ret0;

  L617:
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, DFmode))
    {
      ro[4] = x2;
      return 121;
    }
  goto ret0;

  L626:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SFmode && GET_CODE (x2) == DIV && 1)
    goto L627;
  goto ret0;

  L627:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, SFmode))
    {
      ro[1] = x3;
      goto L628;
    }
  goto ret0;

  L628:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SFmode))
    {
      ro[2] = x3;
      goto L629;
    }
  goto ret0;

  L629:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L630;
  goto ret0;

  L630:
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SFmode))
    {
      ro[3] = x2;
      goto L631;
    }
  goto ret0;

  L631:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L632;
  goto ret0;

  L632:
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, SFmode))
    {
      ro[4] = x2;
      return 122;
    }
  goto ret0;

  L680:
  x1 = XEXP (x0, 0);
  if (GET_CODE (x1) == MEM && call_insn_operand (x1, SImode))
    {
      ro[0] = x1;
      goto L681;
    }
  goto ret0;

  L681:
  x1 = XEXP (x0, 1);
  ro[1] = x1;
  return 135;

  L688:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == CONST_INT && XWINT (x1, 0) == 0 && 1)
    return 143;
  goto ret0;
 ret0: return -1;
}

rtx
split_insns (x0, insn)
     register rtx x0;
     rtx insn;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5;
  rtx tem;

  goto ret0;
 ret0: return 0;
}

