#ifndef SC_MAP_H
#define SC_MAP_H

#ifdef CM5
#define SC_CPP_SPEC " -DMPL=CMMD -DCM5"
static char *link_command_spec = "\
%{!c:%{!M:%{!MM:%{!E:%{!S:cmmd-ld -comp gcc %{o*} -host \
	%{L*} %D %{ho*:%*} %{hl*:-l%*} \
	-lm -lsplit-c -node \
	%X %{A} %{d} %{e*} %{m} %{N} %{n} %{r} %{s} %{T*} %{t} %{x} %{z} \
	%{L*} %D %o \
	-lsplit-c_pe -lm\n}}}}}";
#endif

#ifdef NXAM
#define SC_CPP_SPEC " -DPARAGON"
static char *link_command_spec = "\
%{!fsyntax-only: \
 %{!c:%{!M:%{!MM:%{!E:%{!S:cc -nx \
                        -L/usr/castle/share/proj/split-c/install/NXAM/lib/ \
                        -L/usr/castle/share/proj/split-c/install/NXAM/lib/splitcc-lib/ \
                        %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
			%{r} %{s} %{T*} %{t} %{u*} %{x} %{z} \
			%{L*} %o -lm -lsplit-c -lgcc\n }}}}}}";
#endif

#ifdef HPAM
#define SC_CPP_SPEC " -DHPAM"
static char *link_command_spec = "\
%{!fsyntax-only: \
 %{!c:%{!M:%{!MM:%{!E:%{!S:ld %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
			%{r} %{s} %{T*} %{t} %{u*} %{x} %{z}\
			%{!A:%{!nostartfiles:%{!nostdlib:%S}}} %{static:}\
                        -L/usr/castle/share/proj/split-c/install/HPPA/lib/ \
                        -L/usr/castle/share/proj/split-c/install/HPPA/lib/splitcc-lib/ \
			%{L*} %D %o %{!nostdlib:-lgcc %L -lgcc -lsplit-c -lm %{!A:%E}}\n }}}}}}";
#endif

#ifdef EUIH_AM
#define SC_CPP_SPEC " -DEUIH_AM"
static char *link_command_spec = "\
%{!fsyntax-only: \
 %{!c:%{!M:%{!MM:%{!E:%{!S:cc \
                        -L/usr/castle/share/proj/split-c/install/EUIH_AM/lib/ \
                        -L/usr/castle/share/proj/split-c/install/EUIH_AM/lib/splitcc-lib/ \
                        %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
			%{r} %{s} %{T*} %{t} %{u*} %{x} %{z} \
			%{L*} %o -lm -lsplit-c -lgcc -bimport:/usr/lpp/euih/eui/eui.exp \n }}}}}}";
#endif

#ifdef EUI_AM
#define SC_CPP_SPEC " -DEUI_AM"
static char *link_command_spec = "\
%{!fsyntax-only: \
 %{!c:%{!M:%{!MM:%{!E:%{!S:mpcc -us \
                        -L/usr/lpp/poe/lib -L/usr/lpp/poe/lib/us \
                        -L/usr/castle/share/proj/split-c/install/EUI/lib/ \
                        -L/usr/castle/share/proj/split-c/install/EUI/lib/splitcc-lib/ \
                        %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
			%{r} %{s} %{T*} %{t} %{u*} %{x} %{z} \
			%{L*} %o -lm -lsplit-c -lgcc \n }}}}}}";
#endif


#ifdef TCPAM_SOLARIS
#define SC_CPP_SPEC " -DTCPAM"
static char *link_command_spec = "\
%{!fsyntax-only: \
 %{!c:%{!M:%{!MM:%{!E:%{!S:gcc \
                        -L/usr/castle/share/proj/split-c/install/TCPAM_SOLARIS/lib/ \
                        -L/usr/castle/share/proj/split-c/install/TCPAM_SOLARIS/lib/splitcc-lib/ \
                        %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
			%{r} %{s} %{T*} %{t} %{u*} %{x} %{z} \
			%{L*} %o -lm -lsplit-c -lgcc -lsocket -lnsl\n }}}}}}";
#endif


#ifdef TCPAM_GLUNIX_SOLARIS
#define SC_CPP_SPEC " -DTCPAM -DGLUNIX"
static char *link_command_spec = "\
%{!fsyntax-only: \
 %{!c:%{!M:%{!MM:%{!E:%{!S:cc \
   -L/usr/castle/share/proj/split-c/install/TCPAM_GLUNIX_SOLARIS/lib/ \
   -L/usr/castle/share/proj/split-c/install/TCPAM_GLUNIX_SOLARIS/lib/splitcc-lib/ \
   -L/usr/now/lib \
   -L/usr/sww/lib/gcc-lib/sparc-sun-solaris2.3/default \
                        %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
			%{r} %{s} %{T*} %{t} %{u*} %{x} %{z} \
			%{L*} %o -lsplit-c -lglunix -lTCPAM_GLUNIX_SOLARIS -lsocket -lnsl -lgcc -lm -R/usr/ucblib -R/usr/now/lib\n }}}}}}";
#endif

#ifdef LAM
#define SC_CPP_SPEC " -DLAM"
static char *link_command_spec = "\
%{!fsyntax-only: \
 %{!c:%{!M:%{!MM:%{!E:%{!S:cc \
   -L/usr/castle/share/proj/split-c/install/LAM/lib/ \
   -L/usr/castle/share/proj/split-c/install/LAM/lib/splitcc-lib/ \
   -L/disks/barad-dur/now/CAL/myricom/myrinet/lib/solaris/sun4m/ \
   -L/usr/sww/lib/gcc-lib/sparc-sun-solaris2.4/2.6.3 \
   -L/usr/ucblib \
                        %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
			%{r} %{s} %{T*} %{t} %{u*} %{x} %{z} \
			%{L*} %o -lsplit-c -lLAM -lLanaiDevice -lucb -lgcc -lm\n }}}}}}";
#endif

#ifdef MEIAM
#define SC_CPP_SPEC " -DMEIAM"
static char *link_command_spec = "\
%{!fsyntax-only: \
 %{!c:%{!M:%{!MM:%{!E:%{!S:cc \
                        -L/u0/chad/split-c/MEIAM/lib/ \
                        -L/u0/chad/split-c/MEIAM/lib/splitcc-lib/ \
			-L/opt/MEIKOcs2/lib/ \
                        %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
			%{r} %{s} %{T*} %{t} %{u*} %{x} %{z} \
			%{L*} %o -lm -lsplit-c -lgcc -lew -lelan\n }}}}}}";
#endif

#ifdef PAM
#define SC_CPP_SPEC " -DPAM"
static char *link_command_spec = "\
%{!fsyntax-only: \
 %{!c:%{!M:%{!MM:%{!E:%{!S:cc -nx \
                        -L/usr/castle/share/proj/split-c/install/PAM/lib/ \
                        -L/usr/castle/share/proj/split-c/install/PAM/lib/splitcc-lib/ \
                        %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
			%{r} %{s} %{T*} %{t} %{u*} %{x} %{z} \
			%{L*} %o -lm -lsplit-c -lgcc\n }}}}}}";
#endif

#endif SC_MAP_H
